/* bb_create_db.c: Create a new brett database
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>

#include "config.h"
#include "libquark.h"

#include "brett_db.h"
#include "brett_int.h"

/*
BB_FUNCTION(Funktion,BOOLEAN,bb_create_db,[[(const char *@var{dir})]],[[
    Legt eine neue Brettdatenbank im Verzeichnis @var{dir}
    an, falls die Datei noch nicht existiert.

    Liefert TRUE zurck, wenn eine neue Datenbank angelegt werden
    konnte, sonst FALSE.
]])
*/
BOOLEAN bb_create_db(const char *dir)
{
	char dummy[BB_OFFSET_FIRST_BRETT];
	struct bb_verwalt v;
	FILE *neu_f;
	struct stat st;
	char datei[PATH_MAX];

	if (0!=stat(dir,&st))
	{
		return FALSE;
	}
	else if (!(S_ISDIR(st.st_mode)))
		return FALSE;
	strcpy(datei,dir);
	strcat(datei,"/brett.dat");
	if (stat(datei,&st)==0)
		return FALSE; /* nur falls die noch nicht existiert */

	if ((neu_f = fopen(datei,"wb")) == NULL)
		return FALSE;

	memset(dummy,0,BB_OFFSET_FIRST_BRETT);
	if (!fwrite(dummy,BB_OFFSET_FIRST_BRETT,1,neu_f))
	{
		fclose(neu_f);
		return FALSE;
	}

	memset(&v,0,sizeof(v));
	v.dat_size=sizeof(BRETT);
	fseek(neu_f,0,SEEK_SET);
	if (1!=fwrite(&v,sizeof(v),1,neu_f))
	{
		fclose(neu_f);
		return FALSE;
	}

	fclose(neu_f);

	return TRUE;

} /* bb_create */

