/* bb_remove.c: remove a brett. 
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>

#include "config.h"
#include "libquark.h"

#include "config.h"
#include "libquark.h"

#include "brett_db.h"
#include "brett_int.h"

/*
BB_FUNCTION(Funktion,BOOLEAN,bb_remove_brett,[[(BRETTNR @var{nr})]],[[
    Lscht das Brett mit der Nummer @var{nr} aus den Verwaltungsdaten
    des Prozesses und der Datenbank. Das Brett mu vorher gelockt 
    worden sein.

    Liefert TRUE bei Erfolg, sonst FALSE.
]])
*/
BOOLEAN bb_remove_brett(BRETTNR nr)
{

	/* existiert das Brett auch ? */
	if (nr > max_brettnr || !br_ind[nr].brett)
		return FALSE;
	if (!(br_ind[nr].brett->flags & B_LOCKED))
		return FALSE;
	br_ind[nr].brett->geloescht=TRUE;
	if (!bb_write_brett(nr,TRUE,FALSE))
		return FALSE;
	free(br_ind[nr].canon);
	br_ind[nr].brett->flags &= ~(B_LOCKED);
	/* free(br_ind[nr].brett) fehlt noch - wird das oberhalb gebraucht? */
	br_ind[nr].brett=NULL;
	br_ind[nr].canon=NULL;

	return TRUE;

} /* bb_remove_brett */

