/* bb_sprache.c: returns a string describing the language of a brett.
    Copyright (C) 19yy  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <portab.h>
#include <stddef.h> /* NULL */


#include "config.h"
#include "libquark.h"

#include "brett_db.h"


/*
BB_FUNCTION(Funktion,const char *,bb_sprache,[[(UWORD sprache)]],[[
    Liefert den Namen der Sprache @var{sprache} zurck. Zur Zeit definiert
    sind:

@enumerate 0
@item Unbekannt
@item Deutsch
@item English
@item Franzsisch
@end enumerate

Liefert NULL, wenn @var{sprache} auerhalb des defininierten Bereichs ist.
]])
*/
const char * 
bb_sprache(UWORD sprache)
{
	switch(sprache)
	{
	case 0: return "Unbekannt"; break;
	case 1: return "Deutsch"; break;
	case 2: return "Englisch"; break;
	case 3: return "Franzsisch"; break;
	default: return NULL;
	}
}
