/* bb_update.c: set reference time of a brett.
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <portab.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

#include "config.h"
#include "libquark.h"


#include "brett_db.h"

/*
BB_FUNCTION(Funktion,BOOLEAN,bb_update_brett,[[(BRETTNR @var{nr})]],[[
    Setzt den Zeitpunkt des letzten Schreibzugriffs auf das Brett 
    @var{nr} auf @code{jetzt}.

    Liefert TRUE bei Erfolg, sonst FALSE (Brett gelockt?).
]])
*/
BOOLEAN bb_update_brett(BRETTNR nr)
{
    /* existiert das Brett auch ? */
    CHECK_BRETTNR(nr,return FALSE);

	/* das ist fr die Verwendung im Boxprozess selbst */
	br_ind[nr].brett->flags |= B_NEU;
    if (br_ind[nr].brett->flags & B_LOCKED)
    {
        /* wenn das Brett gelockt ist, knnen wir nicht mehr versuchen
         * als das: (und das fhrt natrlich nicht zu Ziel, weil der
         * Datensatz, auf dem gearbeitet wird, irgendeine Kopie ist)
         */
        br_ind[nr].brett->datum = time(NULL);
    }
    else
    {
    	/* dann mssen wir es locken und *lesen* (um nicht inaktuelle
    	 * Daten zu aktualisieren */
        if (!bb_read_brett(nr,TRUE))
            return FALSE;
        /* so, interne Daten sind jetzt aktuell. */
        br_ind[nr].brett->datum = time(NULL);
        if (!bb_write_brett(nr,TRUE,FALSE))
            return FALSE;
    }

    return TRUE;
}
