/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <signal.h>

#include "io.h"
#include "modem.h"
#include "befehle.h"

extern int user_out_fd;

static volatile sig_atomic_t baud_stop;

static RETSIGTYPE baud_catch_alarm(int sig);

static RETSIGTYPE 
baud_catch_alarm (int sig TOM_ATTRIB_UNUSED)
{
	baud_stop=1;
}

#define SEKUNDEN 10

/*
	bertragungsgeschwindigkeit messen

	Uwe Ohse, 
	21.06.92 Uwe, Arraygre erhht (Zyxelbeschreibung: 2K Puffer)
	24.08.92 Frank, Schleifenoverhead minimiert
	22.10.93 Frank, dito
	23.02.94 Frank, Ausgabe in jedem Schleifendurchlauf flushen
*/
BOOLEAN bef_baud(const char *dummy)
{
	char zufall[5*1024+10];
	char *pos;
	size_t len;
	size_t i;
	long anzahl=0;
	size_t bereiche;

	len = 5*1024;
	bereiche = len/80;
	for (i = 0; i < len; i++)
		zufall[i] = (rand() & 0xDF) +31;
	for (i = 0; i < bereiche; i++)
		zufall[i * 80 + 79] = 0;

	i = 0;
	pos = zufall;

	baud_stop=0;
	signal (SIGALRM, baud_catch_alarm);
	alarm (SEKUNDEN);

	while (!baud_stop)
	{
		anzahl+=write(user_out_fd,pos,79);
		anzahl+=write(user_out_fd,"\r",1);
		pos += 80;
		if (i % 64 == 0)  
			pos = zufall;
		i++;

		anzahl+=write(user_out_fd,pos,79);
		anzahl+=write(user_out_fd,"\r",1);
		pos += 80;
		if (i % 64 == 0)  
			pos = zufall;
		i++;

		anzahl+=write(user_out_fd,pos,79);
		anzahl+=write(user_out_fd,"\r",1);
		pos += 80;
		if (i % 64 == 0)  
			pos = zufall;
		i++;
	}

	io_drain(user_out_fd);

	mbprintf("\r\n\n Die Box sendete %ld Zeichen pro Sekunde\r\n\n",anzahl/SEKUNDEN);
	alarm(0);
	signal (SIGALRM, SIG_DFL);
	return TRUE;

} /* bef_baud */
