/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
*/

/*
 * befehle/betreff.c: Betreff und Programmname von Binrdateien ndern.
 */

#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>

#include "prototyp.h"
#include "befehle.h"
#include "brett.h"
#include "user.h"
#include "modem.h"
#include "bin_msg.h"

extern USER user;
extern BRETT akt_brett;
extern BRETTNR brettnrW;
extern BRETTINFO *br_ind;
extern long max_brettnr;



/*
	ndern des Betreffs
	nur in Binrbrettern erlaubt

	15.12.92 Frank
	07.02.93 Frank, fr Binrdateien

	### wg. interaktiver Eingabe bleibt die Indexdatei solange blockiert
*/
BOOLEAN bef_betreff(const char *para)
{
	BOOLEAN paraB = FALSE;
	BOOLEAN ok = TRUE;
	long nr;
	long all;
	BOOLEAN first = TRUE;
	FILE *bin_f;

	/* kein Binrbrett? */
	if (brettnrW && akt_brett.art != BINAER_BRETT)
	{
		mbfehler("Betreff-nderung nur in Binrbrettern mglich");
		return FALSE;
	}

	set_status_line("Betreff ndern");

	if (!binaer_dat_anzahl(brettnrW,0,&all,NULL,NULL,NULL))
		return FALSE;
	if (!all)
	{
		mbfehler("Noch kein Eintrag in diesem Brett vorhanden");
		return FALSE;
	}

	if ((bin_f = binaer_dat_oeffnen(brettnrW,TRUE)) == NULL)
		return FALSE;
 

	for (ok = lrange(para,&nr); ok && nr > 0; ok = lrange(NULL,&nr))
	{
		BIN_MSG bin_info;

		if (nr == 0)
			continue;
		if ((nr < 0) || (nr > all))
			break;


		fseek(bin_f,(nr-1)*sizeof(BIN_MSG),SEEK_SET);
		fread(&bin_info,sizeof(BIN_MSG),1,bin_f);

		if (bin_change_access(&bin_info))
		{
			if (!first)
			{
				mboutput("\r\n");
				mboutput(" >> (A)bbruch, (CR)Nchsten Betreff ndern: ");
				if (mbdecide("A\r","Abbruch\r\n|Weiter ...\r\n") == 1)
					break;
				mboutput("\r\n");
			}

			first=FALSE;
			mboutput("\r\n");
			mbprintf(" >> Alter Programmname #%ld: %s\r\n",nr,bin_info.name);
			mbquestion(30,2,TRUE,tprintf(" >> Neuer Programmname #%ld: ",nr),bin_info.name,bin_info.name);
			mboutput("\r\n");
			mbprintf(" >> Alter Betreff-Text #%ld: %s\r\n",nr,bin_info.betreff);
			mbquestion(50,0,TRUE,tprintf(" >> Neuer Betreff-Text #%ld: ",nr),bin_info.betreff,bin_info.betreff);
			mboutput("\r\n");
			paraB = TRUE;

			fseek(bin_f,(nr-1)*sizeof(BIN_MSG),SEEK_SET);
			fwrite(&bin_info,sizeof(BIN_MSG),1,bin_f);

		}

	}
	binaer_dat_schliessen(bin_f);

	if (!paraB)  
	{
		parameter_falsch("BETREFF",para);
		return FALSE;
	}
	return TRUE;

} /* bef_betreff */
