/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
*/

/*
 * befehle/crunch.c: Online Nachrichten lschen (nicht nur markieren).
 * Scheint auf die Dauer in die Tonne zu gehren. Hmm ...
 */

#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "prototyp.h"
#ifdef OFFLINE2
#include "offline/inc/version.h"
#include "offline/inc/mdb_global.h"
#else
#include "offline/version.h"
#include "offline/mdb_global.h"
#endif
#include "befehle.h"
#include "modem.h"
#include "brett.h"
#include "user.h"
#include "bin_msg.h"

extern BRETTINFO *br_ind;
extern BRETTNR brettnrW;
extern BRETT akt_brett;


static BOOLEAN crunch_text(const char *para);
static BOOLEAN crunch_binaer(const char *para);



/*
	Crunch

	- User
	- Binrbrett
	- Textbrett
*/
BOOLEAN bef_crunch(const char *para)
{
	if (brettart(brettnrW) == BINAER_BRETT)
		return crunch_binaer(para);
	else
		return crunch_text(para);

} /* bef_crunch */



static BOOLEAN crunch_text(const char *para)
{
#ifdef OFFLINE_VERSION
	set_status_line("Brett crunchen");
	return mdb_putz(akt_brett.name,brettnrW == 0);
#else
	BOOLEAN pm;

	pm = (brettnrW == 0);

	if (!strcmp(para,"!"))
	{
		set_status_line("Brett grndlich crunchen");
		return mdb_putze_gruppe(akt_brett.name,pm,TRUE,NULL);
	}
	else
	if (!*para)
	{
		set_status_line("Brett crunchen");
		return mdb_putze_gruppe(akt_brett.name,pm,FALSE,NULL);
	}
	else
	{
		parameter_falsch("CRUNCH",para);
		return FALSE;
	}
#endif
} /* crunch_text */



/*
	27.01.93 Frank, neu
	10.03.95 Frank, keine Abfrage mehr
*/
static BOOLEAN crunch_binaer(const char *para)
{
	if (!*para)
		set_status_line("Brett crunchen");
	else
	{
		parameter_falsch("CRUNCH",para);
		return TRUE;
	}

	return binaer_dat_putzen(brettnrW);

} /* crunch_binaer */
