/* hilfe.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * befehle/hilfe.c: HILFE und HILFE BEFEHL
 */

#include "config.h"

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>

#include "tomsysdep.h"
#include "befehle.h"
#include "box_conf.h"
#include "prototyp.h"
#include "modem.h"
#include "terminal.h"
#include "user.h"

extern USER user;


static BOOLEAN zeige_hilfe(const char *name);



BOOLEAN bef_hilfe(const char *para)
{
	char name[PATH_MAX];

	if (!*para)
	{
		set_status_line("Hilfetext der Box:");

		sprintf(name,"%s%s",box_conf.hilfe_dir,"hilfe.txt");
		if (fileexist(name))
			return zeige_hilfe(name);
		else
			mbfehler("Datei \"hilfe.txt\" im Verzeichnis <tom/hilfe> nicht installiert");
	}
	else
	{
		char par[80];

		strcpy(par,para);
		strlwr(par);
		sprintf(name,"%s%s%s",box_conf.hilfe_dir,par,".txt");
		if (fileexist(name))
			return zeige_hilfe(name);
		else
			mbprintf(" Hilfe zum Befehl <%s> nicht installiert\r\n\n",para);
	}
	return FALSE;
}



/*
	Hilfetext ausgeben

	02.12.93 Frank

	zustzliche Funktionalitt gg. zeige_datei():
	- Parameter in Fettschrift
	- Userlevel-abhngige Blcke im Hilfetext

	todo
	- MEHR einschalten 
	  (blo nicht! Wer MEHR ausschaltet will auch kein MEHR! -- uwe)
*/
static BOOLEAN zeige_hilfe(const char *name)
{
	FILE *type_f;
	char textS[120];
	char *pos;
	UWORD min_level = ULV_GAST;

	if ((type_f = fopen(name,BINREAD)) == NULL)
		return FALSE;

	while (tom_fgetline(textS,type_f))
	{
		if (textS[0] == '#')
		{
			if (textS[1] == 'L')
				min_level = atoi(textS+2);
			else
			if (!textS[1] || isspace(textS[1]))
				min_level = ULV_GAST;
			continue;
		}

		if (user.level >= min_level)
		{
			if ((pos = strchr(textS,'_')) != NULL)
			{
				mbprintf(" %s",vt_S(ATTR_FETT));
				mbprintf("%.*s",(int)(pos-textS),textS);
				if (mbprintf("%s%s\r\n",vt_S(ATTR_OFF),pos) < 0)
					break;
			}
			else
			{
				if (mbprintf(" %s\r\n",textS) < 0)
					break;
			}
		}

		if (userbreak())
			break;
	}
	fclose(type_f);

	return TRUE;

} /* zeige_hilfe */
