/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
*/
/*
 * befehle/info.c: Anzeige von Infofiles.
 */

#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <limits.h>

#include "prototyp.h"
#include "modem.h"
#include "user.h"
#include "brett.h"
#include "tompaths.h"
#include "tausch.h"
#include "ta_info.h"
#include "befehle.h"

extern USER user;

extern BRETTNR brettnrW;
extern BRETTINFO *br_ind;

static BOOLEAN info_menue(void);

static BOOLEAN info_menue(void)
{
	infofile_t *akt;
	BOOLEAN found=FALSE;
	int old_scroll;
	char tmp[64];
	akt=ta_get_info_anker();
	set_status_line("Infotexte anzeigen");
	mboutput("Verfgbare Informationstexte:\r\n");
	mbprintf("%s\r\n",trennzeile);
	old_scroll=set_scroll_area(2);
	while(akt)
	{
		if (level()>=akt->level)
		{
			strftime(tmp,sizeof(tmp)-1,"%d.%m.%Y, %H:%M",
				localtime(&akt->zeit));
			found=TRUE;
			if (0 > mbprintf("  %-8.8s %-8.8s (%s)\r\n    %s\r\n",akt->name,
				(akt->typ==ITYP_LOKAL) ? "lokal" : "MausNet",
				tmp,akt->text))
				break;
		}
		akt=akt->next;
	}
	if (found)
	{
		mboutput("\r\nBitte whlen Sie einen Text aus.\r\n");
		mbquestion(sizeof(tmp)-1,2,FALSE,"Ihre Wahl: ","",tmp);
		if (*tmp)
		{
			set_scroll_area(old_scroll);
			return bef_info(tmp);
		}
	}
	else
	{
		mboutput("\r\nEs sind keine Informationstexte installiert.\r\n");
	}
	set_scroll_area(old_scroll);
	return TRUE;
}


/*
	Info
	- SHOW [infofilename]
	- nix -> Men
*/
BOOLEAN bef_info(const char *para)
{
	if (!*para)
		return info_menue();
	else if (!stricmp(para,"SYNC"))
	{
		ta_info_sync();
		return TRUE;
	}
	else
	{
		infofile_t *inf;
		char tname[PATH_MAX];
		int old_scroll;

		inf = ta_find_infofile(para);
		if (!inf)
		{
			mbfehler(" Unbekannter Informationstest");
			return FALSE;
		}
		if (inf->level>level())
		{
			mbfehler("Zugriff verweigert");
			return FALSE;
		}
		if (inf->typ==ITYP_PROC || inf->typ==ITYP_CMD || inf->typ==ITYP_INTERN)
		{
			sprintf(tname,"%s%s.ifo",tom_tmp_dir,inf->name);
			if (!ta_online_varinfofile (tname, inf->name))
			{
				mbfehler("Informationstext kann zur Zeit nicht angezeigt werden");
				return FALSE;
			}
		}
		else
			ta_info_filename(inf,tname);
		mbprintf("Infotext %s: %s\r\n",inf->name,inf->text);
		mbprintf("%s\r\n",trennzeile);
		old_scroll=set_scroll_area(2);
		set_status_line(inf->name);
		zeige_datei(tname);
		set_scroll_area(old_scroll);
		if (inf->typ==ITYP_PROC || inf->typ==ITYP_CMD || inf->typ==ITYP_INTERN)
			remove(tname);
		return TRUE;
	}
}
