/* umlaut.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
 * TOM Mailboxsystem
 * Copyright (C) 1993 1994 1995 Frank Baumgart, Uwe Ohse
 *
 * #include <all_rights_reserved>
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "config.h"

#include <portab.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "prototyp.h"
#include "befehle.h"
#include "user.h"
#include "modem.h"
#include "cslib.h"

extern USER user;



BOOLEAN bef_umlaut(const char *para)
{
	BOOLEAN paraB = FALSE;

	if (!*para)
	{
		cstl_t *this;
		this=get_charset_from_nr(user.zeichensatz);
		if (!this)
			this=get_charset_from_name("ascii");
		mbprintf(" Umlaute werden im Zeichensatz %s%s ausgegeben\r\n\n",
			this->name, 
			(this->flags & CSF_ENTUMLAUTEN) ? " entumlautet" : "" );
		paraB = TRUE;
	}
	else if (!stricmp(para,"ALIAS"))
	{
		paraB = TRUE;
		cst_list(1);
	}
	else if (!stricmp(para,"LIST") || !stricmp(para,"LISTE"))
	{
		paraB = TRUE;
		cst_list(0);
	}
	else if (*para)
	{
		BOOLEAN ende;
		char str[32];
		cstl_t *alt=NULL;
		cstl_t *neu=NULL;
		const char *name=NULL;

		set_status_line("Zeichensatz auswhlen:");
		if (!strnicmp(para,"SET",3))
			name=para+3;
		else if (!strnicmp(para,"SETZEN",6))
			name=para+6;
		else if (strcmp(para,"*"))
			name=para;

		while (name && isspace(*name))
			name++;
		paraB = TRUE;
		if (name && *name)
		{
			/* Form mit Leerzeichen? -> Zeichensatzname angegeben */

			neu = get_charset_from_name(name);
			if (!neu)
			{
				/* Vielleicht die Nummer? */
				neu=get_charset_from_nr(strtol(name,NULL,10));
			}
			if (!neu)
			{
				mboutput(" Dieser Zeichensatz ist mir unbekannt!\r\n");
				mboutput(" Eine Liste der Zeichenstze erhalten sie mit UMLAUT LIST\r\n");
			}
			else
			{
				user.zeichensatz = neu->csid;
				mbprintf(" Zeichensatz %s eingestellt.\r\n",neu->name);
				set_charset(neu);
				mboutput("\n");
			}
		}
		else /* Kein Zeichensatz angegeben */
		{
			alt = get_charset_from_nr(user.zeichensatz);
			cst_list(0);
			ende = FALSE;
			do
			{
				mboutput(" \"liste\" fr eine Liste der Zeichenstze,"
						" \"alias\" fr eine lange Liste.\r\n");
				mbquestion(sizeof(str)-1,0,TRUE," Zeichensatz   : ",
						(alt) ? alt->name : "", str);
				neu = NULL;
				if (strtol(str,NULL,10)>0)
				{
					/* dann Nr. eingegeben */
					neu = get_charset_from_nr(strtol(str,NULL,10));
				}
				if (!neu)
					neu = get_charset_from_name(str);
				if (!neu)
				{
					if (!strnicmp(str,"list",4))
						cst_list(0);
					if (!strnicmp(str,"alias",5))
						cst_list(1);
					else if (*str=='\0')
						ende=TRUE;
					else
						mboutput(" Dieser Zeichensatz ist mir unbekannt!\r\n\n");
				}
				else
				{
					user.zeichensatz = neu->csid;
					mbprintf(" Zeichensatz %s eingestellt.\r\n",neu->name);
					set_charset(neu);
					ende=TRUE;
				}
			}
			while (!ende);
		} /* Zeichensatz im Parameter angegeben oder nicht? */
		paraB = TRUE;
	}

	if (!paraB)
	{
		parameter_falsch("UMLAUTE",para);
		return FALSE;
	}
	else
		return TRUE;
}
