/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include "tomsysdep.h"

#include <portab.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>

#include "prototyp.h"
#include "brett.h"
#include "befehle.h"
#include "modem.h"
#include "bin_msg.h"
#include "tompaths.h"
#include "box_conf.h"
#include "packer.h"

extern BRETTNR brettnrW;

BOOLEAN bef_verbose(const char *para)
{
	long nr;
	BOOLEAN ok;
	char cmd[PATH_MAX];
	char kopie[PATH_MAX];
	BIN_MSG bin_info;
	const char *bf;

	if (brettart(brettnrW) != BINAER_BRETT)
	{
		mbfehler("Anzeige von Archiv-Inhalten nur in Binrbrettern mglich");
		return FALSE;
	}

	if (!*para)
		goto abbruch;

	nr = atol(para);
	if (nr <= 0)
		goto abbruch;

	if (!binaer_dat_suchen(brettnrW,nr,&bin_info))
		goto abbruch;

	if (!brettnr && !bin_read_access(&bin_info))
	{
		mbfehler("Anwendung auf fremde Daten nicht erlaubt");
		return FALSE;
	}

	if (wildcard(bin_info.name,"*.txt") || wildcard(bin_info.name,"*.TXT"))
	{
		mbfehler("Archiv-Inhaltsanzeigen von Textfiles sind nicht mglich");
		return FALSE;
	}

	set_status_line(tprintf("Listing des Archivs: %s",bin_info.name));

	sprintf(kopie,"%s%s", tom_tmp_dir, bin_info.name);
	bf=brettpfad(brettnrW);
	/* absoluter Pfad wegen symlink */
	if (*bf=='/')
		sprintf(cmd,"%s%ld.bin",brettpfad(brettnrW),bin_info.nr);
	else
		sprintf(cmd,"%s%s%ld.bin",box_conf.quark_dir, brettpfad(brettnrW),bin_info.nr);
#ifdef HAVE_SYMLINK
	if (symlink(cmd,kopie))
#endif
#ifdef HAVE_LINK
	if (link(cmd,kopie))
#endif
	if (!file_copy(cmd,kopie))
	{
		mbfehler("kann Datei nicht linken/kopieren");
		return FALSE;
	}

	ok=packer_list(kopie);
	unlink(kopie);

	mboutput("\r\n");
	if (!ok)
		mboutput("Schade!\r\n");

	return ok;

abbruch:
	parameter_falsch("VERBOSE",para);
	return FALSE;

	} /* bef_verbose */
