#
# 

proc do_hook { cmd para } {
	if { "$cmd" == "UMLAUT" } {
		return [umlaut_hook $para]
	}
	return "notdone"
}
proc umlautmenuhelp { off lang } {
    global menuestil
    global mausnetinfozahl
    global mausnetinfofile
    global SCHNELLOGOUT
    global TRENNSTRICHE
    set auswahl ""
    append_entry auswahl liste "(A)tari"
    append_entry auswahl liste "(D)os, cp437"
    append_entry auswahl liste "(L)atin-1, Unix, Amiga"
    append_entry auswahl liste "(M)acintoch"
    append_entry auswahl liste "(S)onstige"
    if {$TRENNSTRICHE} {
        lappend liste "-----------------------------"
    }
    append_entry auswahl liste "(H)albautomatisch Erkennung"
    if {$TRENNSTRICHE} {
        lappend liste "-----------------------------"
    }
    append_entry auswahl liste "(K)eine nderung"
	do_help $off $liste
    return "${auswahl}"
}
proc umlaut_halbautomatik { } {
	set old [tom_getvar "%uz"]
	set alle ""
	set str_latin1 "\344\366\374\304\326\334\337"
	set str_atari  "\204\224\201\216\231\232\236"
	set str_ibmpc  "\204\224\201\216\231\232\341"
	set str_mac    "\212\232\237\200\205\206\247"

	tom_befehl -quiet "UMLAUT iso-8859-1"

	for {set i 0} {$i <7} {incr i} {
		switch -- $i {
			0 { set desc "ae,\"a" }
			1 { set desc "oe,\"o" }
			2 { set desc "ue,\"u" }
			3 { set desc "Ae,\"A" }
			4 { set desc "Oe,\"O" }
			5 { set desc "Ue,\"U" }
			6 { set desc "ss,sz" }
		}
		tom_puts -nonewline "Bitte die Taste fuer $desc druecken:"
		set c [tom_getchar ]
		tom_puts "*"
		if {[string first "$c" "$alle"] != -1} {
			tom_puts "das Zeichen wurde schon eingegeben!"
			tom_befehl -quiet "UMLAUT $old"
			return "done"
		}
		set alle "$alle$c"
	}
	tom_puts "->$alle"
	if {[string compare "$alle" "$str_atari"] == 0} {
		tom_puts "Zeichensatz Atari-ST eingestellt!"
		tom_befehl -quiet "UMLAUT atarist"
		return "done"
	} elseif {[string compare "$alle" "$str_latin1"] == 0} {
		tom_puts "Zeichensatz iso-8859-1, alias latin-1, eingestellt!"
		tom_befehl -quiet "UMLAUT iso-8859-1"
		return "done"
	} elseif {[string compare "$alle" "$str_ibmpc"] == 0} {
		tom_puts "Zeichensatz IBM-PC eingestellt!"
		tom_befehl -quiet "UMLAUT ibmpc"
		return "done"
	} elseif {[string compare "$alle" "$str_mac"] == 0} {
		tom_puts "Macintosh-Zeichensatz eingestellt!"
		tom_befehl -quiet "UMLAUT macintosh"
		return "done"
	} else {
		tom_puts "Zeichensatz nicht erkannt!"
	}
	tom_befehl -quiet "UMLAUT $old"
	# ja, done: Sonst wird hinterher noch UMLAUT ausgefhrt.
	return "done"
}

proc umlautmenu { } {
    global mausnetinfozahl
    global mausnetinfofile
    while (1) {
        set wahl [work_menu "Zeichensatz whlen" umlautmenuhelp]

		switch -- "$wahl" {
			"A"  { return "modified atarist" }
			"D"  { return "modified ibmpc" }
			"L"  { return "modified iso-8859-1" }
			"M"  { return "modified macintosh" }
			"H"  { return [umlaut_halbautomatik]}
			"K"  { return "done" }
			"S"  -
			default { return "modified *" }
		}
    }
}


proc umlaut_hook { zs } {
	if {0==[string compare $zs ""]} {
		return [umlautmenu]
	} else {
		switch -- $zs {
			atarist    -
			atari      -
			st         { return "modified atarist" }
			amiga      -
			unix       -
			linux      -
			latin1     -
			latin-1    { return "modified iso-8859-1" }
			pc         -
			dos        { return "modified ibmpc" }
			apple      -
			macintosch -
			mac        { return "modified macintosh" }
			ascii      -
			7bit       { return "modified usascii" }
			default { return notdone }
		}
	}
}

set lokalinfozahl 0
set mausnetinfozahl 0
set proginfozahl 0
set progteilzahl 0
set tauschsoftzahl 0
set uploadareazahl 0

source tom/bin/tcl/mausfkt.tcl
source tom/bin/tcl/mausmsg.tcl
source tom/bin/tcl/mausconf.tcl

set menuestil [tom_getvar "%um"]
set terminaltyp [tom_getvar "%uT"]
