# hilfsfunktionen.tcl: hilfsfunktionsmen der Mausoberflche
#
#   Copyright (C) 1995, 1996 Uwe Ohse
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#   Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
#      Snail Mail (don't expect me to answer):
#            Uwe Ohse
#            Drosselstrae 2
#            47055 Duisburg
#            Germany
#   Contact2: MausNet Newsgroups Quark & Q-Sysops.
#
#
proc hilfsfktmenuhelp { off lang} {
	global SCHNELLOGOUT TRENNSTRICHE
	set auswahl ""

	append_entry auswahl liste "(B)enutzerdaten editieren"
	append_entry auswahl liste "(D)atum, Zeit und Restzeit anzeigen"
	append_entry auswahl liste "Telefon-(G)ebhren zeigen"
	append_entry auswahl liste "(U)mlauteinstellung"
	append_entry auswahl liste "(T)erminalgrenerkennung"
	if {$TRENNSTRICHE} {
		lappend liste "-----------------------------"
	}
	if {$SCHNELLOGOUT} {
		append_entry auswahl liste "(!) Schnell ausloggen"
	}
	append_entry auswahl liste "(Z)urck zum Hauptmen"
	if {$lang} {
		do_help $off $liste
		return "${auswahl}"
	}
	kurz_menue_hilfe "$auswahl"
	return "${auswahl}?"
}

proc hilfsfktmenu { } {
	global logout_modus
	while (1) {
		set wahl [work_menu "Hilfsfunktionen" hilfsfktmenuhelp]
		if {$logout_modus} { return }

		if { "$wahl" == "Z" } {
			return
		} elseif { "$wahl" == "!" } {
			tom_befehl LOGOUT
		} elseif { "$wahl" == "U" } {
			tom_befehl "UMLAUT"
		} elseif { "$wahl" == "D" } {
	    	# Heute ist Montag, der 10.10.94, es ist 00:20 Uhr.
			set t [tom_time]
			set tnr [tom_strftime {%w} $t]
			switch -- $tnr {
				0 {set tag Sonntag }
				1 {set tag Montag }
				2 {set tag Dienstag }
				3 {set tag Mittwoch }
				4 {set tag Donnerstag }
				5 {set tag Freitag }
				6 {set tag Samstag }
			}
			set datum [tom_strftime {%d.%m.%Y} $t]
			set zeit [tom_strftime {%H:%M} $t]
			tom_puts "Heute ist $tag, der $datum,  es ist $zeit Uhr."

			set end [tom_getvar {%ae}]
			set end [tom_mtzeit_to_time_t $end]
	    	# Ihnen stehen noch 60 Minuten zur Verfgung.
	    	set rest [expr  $end - $t]
	    	set rest [expr $rest / 60]
	    	tom_puts "Ihnen stehen noch $rest Minuten zur Verfgung"
			wait_after
	    } elseif { "$wahl" == "G" } {
			tom_befehl "ZEIT"
			# MAUS:
	    	# Telefongebhren bisher: (Billigtarif)
            #
	    	#  Nah    -50km   >50km
            #
	    	#  0.23    0.23    0.23  DM
	    	# Quark:
			wait_after
		} elseif { "$wahl" == "B" } {
			tom_befehl "EDIT USER"
			set menuestil [tom_getvar "%um"]
			set terminaltyp [tom_getvar "%uT"]
		} elseif { "$wahl" == "T" } {
			tom_befehl "INSTALL RESIZE"
		} else { 
			tom_puts "????" 
		}
	}
}
