/* bflags2str.c: convert brettflags to string.
    Copyright (C) 1995 1996 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#include <portab.h>


#include "config.h"
#include "libquark.h"

#include "brett_db.h"


/* 
BB_FUNCTION(Funktion,BOOLEAN,brettflags_to_string,
[[(ULONG @var{flags}, char *@var{string}, size_t @var{place});
    Erzeugt einen String bei @var{string} mit Maximallnge @var{place}
    (inclusive Stringendezeichen) aus den gesetzten Bits in @var{flags}.

    Liefert TRUE bei Erfolg, FALSE bei Platzmangel.
]])
*/
#define ADDIT(c) { if (place--<=1) return FALSE; *s++=c; }
BOOLEAN brettflags_to_string(ULONG flags, char *s, size_t place)
{
	if (flags & B_ANONYM) ADDIT('A')
	if (flags & B_GEHEIM) ADDIT('G')
	if (flags & B_MITGLIED) ADDIT('M')
	if (flags & B_ZAHLER) ADDIT('$')
	if (flags & B_PASSWORT) ADDIT('P')
	if (flags & B_ZWANG) ADDIT('Z')
	if (flags & B_DEFAULT) ADDIT('D')
	if (flags & B_MODERIERT) ADDIT('O')
	if (flags & B_ACL) ADDIT('C')
	if (flags & B_LESMITGLIED) ADDIT('L')
	if (flags & B_PAYWRITE) ADDIT('Y')
	*s='\0';
	return TRUE;
}

#undef ADDIT
