/* bin_msg.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Struktur fr Binrdaten (Uploads)

	Frank
	begonnen: 21.01.93
*/
#ifndef BIN_MSG_H
#define BIN_MSG_H

#include <time.h>

#include "brett.h"

#define BIN_FREE	0		/* DL freigegeben */
#define BIN_LOCKED	1		/* DL gesperrt */
#define BIN_KILLED	2		/* Datei lschmarkiert */

typedef struct
{
	long nr; 					/* fortlaufende, eindeutige Nummer */
	long lokal; 				/* lckenlose brettinterne Nummer */
	long brettnr;				/* Brettnummer (fr globalen Index) */
	long usernr;				/* Usernummer des Uploaders */
	long empfaenger;			/* Usernummer des Empfngers (nur fr PP) */
	long zugriffe; 			/* Anzahl Downloads */
	long bytes; 				/* Gre der Datei */
	char name[60];				/* Name der Datei */
	char absender[64];		/* Name des Uploaders */
	char betreff[60];			/* Kurzinfo zur Datei */
	char datum[10];			/* dd.mm.yy */
	char zeit[10]; 			/* hh:mm:ss */
	time_t datime; 			/* Uploadzeit */
	int deleted;				/* Lschflag */
	int status;					/* BIN_[LOCKED | FREE | KILLED] */
	int art; 					/* 0 = binr, 1 = uu, 2 = btoa, 3 = ASCII, ... */
	int system; 				/* Rechnersystem */
	int bereich;				/* Programmtyp */
	time_t last_download;	/* Zeitpunkt des letzten Downloads */
	char resvd[36];

} BIN_MSG;



/*
	Prototypen fr Binrverwaltung
*/

FILE *binaer_dat_oeffnen(BRETTNR bnr,BOOLEAN for_write);
void binaer_dat_schliessen(FILE *bin_f);
BOOLEAN binaer_dat_anhaengen(BRETTNR bnr,BIN_MSG *bin_info);
BOOLEAN binaer_dat_loeschen(BRETTNR bnr,long bin_nummer);
BOOLEAN binaer_dat_suchen(BRETTNR bnr,long bin_nummer,BIN_MSG *bin_info);
BOOLEAN binaer_dat_kopieren(BRETTNR bnr,BRETTNR zielbrett,long nummer);
BOOLEAN binaer_dat_putzen(BRETTNR bnr);
BOOLEAN binaer_dat_putze_alle(BOOLEAN pm);
BOOLEAN binaer_dat_anzahl(BRETTNR bnr,time_t ref_time,long *all,long *neu,long *bytes,long *geloescht);


void loesche_programmfach(long usernr);

FILE *bin_global_oeffnen(BOOLEAN for_write);
BOOLEAN bin_global_create(void);
BOOLEAN bin_global_append(BIN_MSG *bin_info);
long bin_global_suchen(int art,const char *suche,long start,BIN_MSG *bin_info);
long bin_global_putzen(void);

BOOLEAN bin_read_access(const BIN_MSG *bin_info);
BOOLEAN bin_change_access(const BIN_MSG *bin_info);

#endif
