/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Ausgabe von Binrdaten-Inhalten

	Version vom 04.03.1994
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "prototyp.h"
#include "box_conf.h" /* MYDOMAINPART */
#include "modem.h"
#include "terminal.h"
#include "user.h"
#include "brett.h"
#include "bin_msg.h"
#include "bin_out.h"
#include "aktdata.h"

extern USER user;
extern BRETT akt_brett;
extern BRETTNR brettnrW;

extern int col_ix[];

extern WORD vtmodeW;



static void exportiere_binaer(const char *brettname,time_t von, FILE *f);


const char *trennzeile =
"------------------------------------------------------------------------------";


/*
	Header + Infotext von Binrnachrichten anzeigen
*/
void bin_msg_header(const BIN_MSG *bin_info)
{
	const char *s1,*s2;

	s1 = vt_S(col_ix[C_BLAU]);
	s2 = vt_S(ATTR_OFF);

	mboutput("\r\n");
	mbprintf(" %s\r\n",trennzeile);
	mbprintf("%s%s %sNr. :%s %-6ld                     %sByte:%s %-9ld %sAbg.:%s %s %s\r\n",
				vt_pos_S(4,1),vt_S(DEL_SCR_REST),
				s1,s2,bin_info->lokal,
				s1,s2,bin_info->bytes,
				s1,s2,bin_info->datum,bin_info->zeit);
	mbprintf(" %sFile:%s %-42.42s %sAbs.:%s %s\r\n",
				s1,s2,bin_info->name,
				s1,s2,bin_info->absender);
	mbprintf(" %sBet.:%s %-58.58s %sZug.:%s %ld\r\n",
				s1,s2,bin_info->betreff,
				s1,s2,bin_info->zugriffe);
	mbprintf(" %s\r\n",trennzeile);

	if (!zeige_datei(tprintf("%s%ld.txt",brettpfad(brettnrW),bin_info->nr)))
		mboutput("\r\n Kein Infotext zu dieser Binrdatei vorhanden\r\n\n");

} /* bin_msg_header */



void bin_heading(void)
{
	mbprintf(" %s%s%s\r\n",
	         vt_S(ATTR_FETT),
	         "  NR. DATEINAME          BYTES DATUM  ZUG BETREFF",
/*				" *123 12345678.ext1234 1234567 11.12. 123 BETREFF",*/
	         vt_S(ATTR_OFF));
	mboutput(" ------------------------------------------------------------------------------\r\n");

} /* bin_heading */



/*
	Aufrufe aus: HITLISTE, INHALT, SUCHEN
*/
int bin_msg_inhalt(const BIN_MSG *bin_info)
{
	BOOLEAN su;

	su = (akt_brett.grp_chef == user.nummer) || (level()==9);

	if (bin_info->deleted && !su)
		return 0;

	if (bin_info->deleted)
		mbprintf(" %sD%s",vt_S(col_ix[C_ROT]),vt_S(ATTR_OFF));
	else
		mboutput("  ");

	if (bin_info->usernr == user.nummer)
		mboutput(vt_S(ATTR_FETT));

	if (su || bin_info->status <= 1)
	{
		mbprintf("%3ld %-17.17s %7ld %-6.6s %3ld %.36s",
					bin_info->lokal,bin_info->name,bin_info->bytes,
					bin_info->datum,bin_info->zugriffe,bin_info->betreff);
	}

	if (bin_info->usernr == user.nummer)
		mboutput(vt_S(ATTR_OFF));

	return mboutput("\r\n");

} /* bin_msg_inhalt */



/*
	Binr-Brett in Outfileform exportieren

	->			brettname	:	klar
				von			:	Referenzzeitpunkt
				out_f			:	Daten werden an diesen stream angehngt
*/
static void exportiere_binaer(const char *brettname,time_t von,FILE *out_f)
{
	BRETTNR nr;
	FILE *bin_f;
	BIN_MSG bin_info;

	nr = brettnr(brettname);
	if (nr==0 && stricmp(brettname,"Programmfach"))
		return;

	if ((bin_f = binaer_dat_oeffnen(nr,FALSE)) == NULL)
		return;

	while (fread(&bin_info,sizeof(BIN_MSG),1,bin_f))
	{
		FILE *txt_f;
		char buf[100];
		char datum[14];

		/* Nachricht neuer ? */
		if (bin_info.datime <= von)
			continue;
		/* eigenes Programmfach ? */
		if (nr==0 && bin_info.empfaenger!=user.nummer)
			continue;

		fprintf(out_f,"#B%ld@%s\r\n",bin_info.nr,MYDOMAINPART);
		fprintf(out_f,"V%s\r\n",bin_info.absender);
		fprintf(out_f,"W%s\r\n",bin_info.name);
		strftime(datum,13,"%Y%m%d%H%M",localtime(&bin_info.datime));
		fprintf(out_f,"E%s\r\n",datum);
		fprintf(out_f,"G%s\r\n",brettname);
		fprintf(out_f,": %s\r\n",trennzeile);
		fprintf(out_f,": Nr. : %-6ld          ",bin_info.lokal);
		fprintf(out_f,"Byte: %-12ld  ",bin_info.bytes);
		fprintf(out_f,"Abg.: %s %s  ",bin_info.datum,bin_info.zeit);
		fprintf(out_f,"Zu.: %4ld\r\n",bin_info.zugriffe);
		fprintf(out_f,": Abs.: %-15.15s ",bin_info.absender);
		fprintf(out_f,"File: %-13.13s Bet.: %s\r\n",bin_info.name,bin_info.betreff);
		fprintf(out_f,": %s\r\n",trennzeile);

		/* Infodatei, falls vorhanden, ausgeben */
		txt_f = fopen(tprintf("%s%ld.txt",brettpfad(nr),bin_info.nr),"r");
		if (!txt_f)
			fprintf(out_f,":\r\n: Kein Infotext vorhanden\r\n:\r\n");
		else
		{
			fputs(":\r\n",out_f);
			while (tom_fgetline(buf,txt_f))
				fprintf(out_f,":%s\r\n",buf);
			fclose(txt_f);
		}

		if (akt_connection.is_modem)
		{
			fputs(":\r\n",out_f);
			fprintf(out_f,": Download-Zeit bei %ld CPS ca. %s Min:Sec",
					(long) akt_connection.carrier_cps,download_time_S(nr,bin_info.nr));
			fputs(":\r\n",out_f);
		}
	}
	binaer_dat_schliessen(bin_f);

} /* exportiere_binaer */



/*
	Binrbrettinhalte in Textform exportieren
	(spez. fr den Tausch)

	->			liste	:	Textdatei mit Liste der Binrbretter
				von	:	Referenzdatum, ab dem exportiert werden soll
							(sofern keine expliziten Brett-spezifischen Einstellungen)
				fname	:	Zieldatei

	<-			TRUE	:	konnte Listendatei ffnen
				FALSE	:	konnte Listendatei nicht ffnen

	Dir Daten werden im Outfile-Format in Datei "fname" exportiert.
*/
BOOLEAN bin_export(const char *liste,time_t von,const char *fname)
{
	char eintrag[256];
	FILE *lis_f;
	FILE *f;

	if ((lis_f = fopen(liste,"r")) == NULL)
		return FALSE;
	f=xfopen(fname,BINAPPEND);

	while (tom_fgetline(eintrag,lis_f))
	{
		time_t t;
		char *p=strchr(eintrag,',');
		if (p)
		{
			*p=0;
			t=strtol(p+1,NULL,10);
		}
		else
			t=von;
		exportiere_binaer(eintrag,t,f);
	}

	fclose(lis_f);
	fclose(f);

	return TRUE;

} /* bin_export */
