/* brett_int.h: internal declarations of the brett library.
    Copyright (C) 1996 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
*/
#ifndef BRETT_DB_INTERN_H
#define BRETT_DB_INTERN_H

/* Offset zum ersten Brett in der Datei (vorher Verwaltungsdaten) */
#define BB_OFFSET_FIRST_BRETT    512

#define CLOSE_IT do {if (-1!=bb_fh) close(bb_fh); bb_fh=-1;}while(0)
#define POS_NR(x) (BB_OFFSET_FIRST_BRETT + br_ind[x].brett->index * sizeof(BRETT))
#define POS_INDEX(x) (BB_OFFSET_FIRST_BRETT + x * sizeof(BRETT))

#define ANZ_INTERN      1000            /* Anzahl interner Bretteintrge */

                                        
struct bb_verwalt
{
	long dat_size;
	BRETTNR last_ten[10];
};

extern long brettanzahl;
extern int bb_fh;
extern char *bb_text_db_dir;
extern char *bb_binaer_db_dir;
extern char *bb_sys_dir;

enum locktyp { BB_UNLOCK, BB_READLOCK, BB_WRITELOCK };

BOOLEAN bb_lock_brett(BRETTNR nr,enum locktyp locktyp, BOOLEAN block);

#endif
