/* check_part_free.c: still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <syslog.h>

#include "tompaths.h"
#include "prototyp.h"
#include "user.h" /* level() */
#include "modem.h"
#include "box_conf.h"

#ifdef HAVE_DOSDRIVES
extern char installed_drivesS[];
#endif

extern USER user;
struct merk {
	const char *pfad;
	long freebytes;
};


void check_part_free(BOOLEAN automode)
{
	PATH_BYTES_FREE_TYPE bytes;
	BOOLEAN trouble=FALSE;

#ifdef HAVE_DOSDRIVES
	WORD nW;
	size_t drives;
	if (level() < 8)
		return;
	drives = strlen(installed_drivesS);
#else
	const char **ptr;

	const char *pfade[20];
	if (level() < 8)
		return;

	pfade[0]=box_conf.batch_dir;
	pfade[1]=box_conf.hilfe_dir;
	pfade[2]=box_conf.bin_dir;
	pfade[3]=box_conf.log_dir;
	pfade[4]=box_conf.config_dir;
	pfade[5]=box_conf.var_dir;
	pfade[6]=box_conf.tausch_dir;
	pfade[7]=box_conf.texte_dir;
	pfade[8]=box_conf.binbrett_dir;
	pfade[9]=box_conf.bretter_dir;
	pfade[10]=tom_tmp_dir;
	pfade[11]=tom_utmp_dir;
	pfade[12]=tom_info_net_dir;
	pfade[13]=tom_info_lokal_dir;
	pfade[14]=NULL;
#endif

	mboutput(" G");

#ifdef HAVE_DOSDRIVES
	for (nW = 0; nW < drives; nW++)
	{
		bytes = bytes_free(installed_drivesS[nW]-64);
#else
	for (ptr=pfade; *ptr!=NULL; ptr++)
	{
		bytes = path_bytes_free(*ptr);
#endif
		if (bytes < (PATH_BYTES_FREE_TYPE) box_conf.warn_diskspace)
		{
#ifdef HAVE_DOSDRIVES
			mbprintf("\r\n Achtung, auf Drive: %c: sind nur noch: %ld kB frei\r\n",
						installed_drivesS[nW],bytes/1024);
#else
			mbprintf("\r\n Achtung, es sind nur noch %lu kB frei auf %s\r\n",
						(unsigned long)bytes/1024,*ptr);
#endif
			trouble=TRUE;
		}
		else
			mboutput("");
	}
	if (trouble)
	{
		mboutput(" Zeit zum Wachwerden, die Sysoparbeit ruft! (Taste bitte)\r\n\n");
		if (!automode)
			mbchar();
	}
	else
		mboutput("hn.. so, es kann losgehen\r\n\n");
} /* check_part_free */
