/* dqueue.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "dqueue.h"

/* #define TEST */

typedef struct dqueue_t 
{
	dqueue_fn_t fn;
	void             * para;
	struct dqueue_t  * next;
} dqueue_t;

typedef struct typelist_t 
{
	dqueue_t *anker;
	ULONG id;
	struct typelist_t *next;
} typelist_t;

static typelist_t *anker;

BOOLEAN 
dqueue_add(ULONG id, dqueue_fn_t fn, void *para)
{
	typelist_t *akt;
	typelist_t *diese=NULL;
	typelist_t *last=NULL;
	dqueue_t *neu;
	for (akt=anker;akt != NULL && akt->id >= id; akt=akt->next)
	{
		if (akt->id==id)
		{
			diese=akt;
			break;
		}
		last=akt;
	}
	if (!diese)
	{
		diese=malloc(sizeof(typelist_t));
		if (!diese) 
			return FALSE;
		diese->id=id;
		diese->anker=NULL;
		if (last)
		{
			diese->next=last->next;
			last->next=diese;
		}
		else if (anker)
		{
			if (anker->id>id)
			{
				diese->next=anker->next;
				anker->next=diese;
			}
			else
			{
				diese->next=anker;
				anker=diese;
			}
		}
		else
		{
			anker=diese;
			diese->next=NULL;
		}
	}
	/* die queue ist bekannt: diese */
	neu=malloc(sizeof(dqueue_t));
	if (!neu) 
		return FALSE;
	neu->para=para;
	neu->fn=fn;
	neu->next=diese->anker;
	diese->anker=neu;
	return TRUE;
}

static void
dqueue_work_one(typelist_t *id)
{
	dqueue_t *akt;
	dqueue_t *next;
	for (akt=id->anker; akt; akt=next)
	{
		if (akt->fn)
			akt->fn(akt->para);
		next=akt->next;
		free(akt);
	}
	id->anker=NULL;
}

void
dqueue_work_all(void)
{
	typelist_t *akt;
	for (akt=anker;akt;akt=akt->next)
		dqueue_work_one(akt);
}

void dqueue_delete_queue(ULONG id)
{
	typelist_t *akt_id;
	for (akt_id=anker;akt_id;akt_id=akt_id->next)
	{
		if (akt_id->id==id)
		{
			dqueue_t *akt_fn;
			dqueue_t *next;
			for (akt_fn=akt_id->anker; akt_fn; akt_fn=next)
			{
				next=akt_fn->next;
				free(akt_fn);
			}
			akt_id->anker=NULL;
			break;
		}
	}
}

void dqueue_work(ULONG id)
{
	typelist_t *akt;
	for (akt=anker;akt;akt=akt->next)
	{
		if (akt->id==id)
		{
			dqueue_work_one(akt);
			break;
		}
	}
}

#ifdef TEST
static void doit(const void *str)
{
	printf("work %s\n",(char *) str);

}

int main(void)
{
	dqueue_add(5,doit,"lv 5.1");
	dqueue_add(5,doit,"lv 5.2");
	dqueue_add(4,doit,"lv 4.1");
	dqueue_add(6,doit,"lv 6.1");
	dqueue_work_all();
	dqueue_add(0,doit,"lv 0.1");
	dqueue_add(4,doit,"lv 4.2");
	dqueue_add(6,doit,"lv 6.2");
	dqueue_add(6,doit,"lv 6.3");
	dqueue_work(4);
	dqueue_add(4,doit,"lv 4.3");
	dqueue_work(7);
	dqueue_add(4,doit,"lv 4.4");
	dqueue_work_all();
	exit(0);
}
#endif
