/* event.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef EVENT_H
#define EVENT_H

typedef struct event_t_struct
{

	/* Stunde * 100 + Minute */
	ULONG soft_begin; /* ab da wird der Event vielleicht gestartet */
	ULONG wurf_begin; /* bis da drfen User bleiben, -1 nicht gesetzt = soft */
	ULONG hard_begin; /* Allerletzter Zeitpunkt, den Event zu starten */

	time_t last_started; /* Zeitpunkt des letzten Eventstarts */
	time_t next_soft;    /* Zeitpunkt des naechsten Softstarts */
	time_t next_wurf;    /* Zeitpunkt des naechsten Wurfs */
	time_t next_hard;    /* Zeitpunkt des naechsten Hardstarts */

	BOOLEAN manuell_ok;   /* darf der Event manuell ausgelst werden? */
	BOOLEAN auto_ok;      /* darf der Event automatisch gestartet werden? */

	/* 
	 * auszufhrendes Kommando. Bis jetzt
	 * BATCH
	 * LEAVE 
	 */
	char *cmd;
	/* ID des Events */
	char *id;

	struct event_t_struct *next;
} event_t;

	/* load und reload */
BOOLEAN event_load(void);
	/* 
	 * alle anliegenden Events ausfhren (id==NULL) oder den angegebenen 
	 * Event als manuellen Event ausfhren (id != NULL).
	 * Liefert NULL oder die ID eines Events, der die Quark beenden soll,
	 * zurck.
	 */
char *event_execute(const char *id);
	/* Event und Abstand des nchsten soft-event-starts bestimmen */
event_t * event_next_soft(time_t *offset);
	/* Event und Abstand des nchsten wurf-events bestimmen.
	 * Verwendung im Login erforderlich!
	 */
event_t * event_next_wurf(time_t *offset);

event_t * event_anker(void);


#endif
