/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <syslog.h>

#include "prototyp.h"
#include "modem.h"
#include "protokoll.h"

extern int user_in_fd;


/*
	Fehlerhandling

	vorlufiger Ersatz fr Konverterlib-Routine
	Programm wird derzeit grundstzlich beendet
*/
void dateifehler(const char *dateiname)
{
	int e=errno;

	mboutput("Ein Dateifehler ist aufgetreten:\n  ");
	if (dateiname)
		mbprintf("%s: ",dateiname);
	mbprintf("%s",strerror(e));
	mboutput("Programmabbruch :-(");

	/* syslog */
	syslog(LOG_ERR,"Dateifehler %s aufgetreten in %s",
		strerror(e),
		dateiname ? dateiname : "(nicht feststellbar)");

	mboutput("Modem auflegen");
	hangup_modem(user_in_fd);

	exit(1);
}

void
speicherproblem(BOOLEAN fatal, const char *wo)
{
	static BOOLEAN in_sprob; /* keine Rekursion bitte */
	if (in_sprob)
	{
		/* was nun? Meldung machen geht wohl nicht*/
		if (fatal)
			exit(1);
		return;
	}
	in_sprob=TRUE;
	mboutput("Out of memory\n");
	if (wo)
		mbprintf("  in %s\n",wo);
	if (fatal)
		mbprintf("  Programm wird beendet\n");
	/* syslog */
	if (fatal)
	{
		if (wo)
			syslog(LOG_ERR,"Fatal out of memory in %s",wo);
		else
			syslog(LOG_ERR,"Fatal out of memory");
	}
	else
	{
		if (wo)
			syslog(LOG_NOTICE,"out of memory in %s",wo);
		else
			syslog(LOG_NOTICE,"out of memory");
	}
	if (fatal)
		exit(1);
	in_sprob=FALSE;
}

