/* sysdep.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Dirk Hagedorn, Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
*/

/*	----------------------------------------------------------------------
	Includes
	----------------------------------------------------------------------	*/
#include "tomsysdep.h"
#include	<string.h>
#include	<stdlib.h>

#ifdef HAVE_TERMIOS_H
#  include <termios.h>
#  define USE_TERMIO
#elif defined(HAVE_TERMIO_H)
#  include <termio.h>
#  define USE_TERMIO
#elif defined(HAVE_SYS_TERMIOS_H)
#  include <sys/termios.h>
#  define USE_TERMIO
#elif defined(HAVE_SYS_TERMIO_H)
#  include <sys/termio.h>
#  define USE_TERMIO
#endif

#include	"lineedit.h"

#ifdef USE_TERMIO
static struct termios cons;
#endif
void
save_console_attribs(void)
{
#ifdef USE_TERMIO
	tcgetattr(0,&cons);
#endif
}

void
set_console_attribs(void)
{
#ifdef USE_TERMIO
	struct termios console;
	console = cons;
	/*
	 * Function: int cfmakeraw (struct termios *TERMIOS_P)
     * This function provides an easy way to set up *TERMIOS_P for what
     * has traditionally been called "raw mode" in BSD.  It does exactly
     * this:
     */
console.c_cc[VMIN]=1;
console.c_iflag &= ~(IGNBRK|BRKINT|PARMRK|ISTRIP|INLCR|IGNCR|ICRNL|IXON);
console.c_oflag &= ~OPOST;
console.c_lflag &= ~(ECHO|ECHONL|ICANON|ISIG|IEXTEN);
console.c_cflag &= ~(CSIZE|PARENB);
console.c_cflag |= CS8;
	atexit(reset_console_attribs);
	tcsetattr(0,TCSADRAIN,&console);
#endif
}

void 
reset_console_attribs(void)
{
#ifdef USE_TERMIO
	tcsetattr(0,TCSADRAIN,&cons);
#endif
}

