/* login.c : still no description */
/*
    Copyright (C) 1994 1995 1996 1997 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <signal.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <syslog.h>
#include "fnmatch.h"

#include "prototyp.h"
#include "aktdata.h"
#include "befehle.h"				/* wg. bef_inhalt, bef_brett, bef_zone, bef_tausch */
#include "brett.h"
#include "user.h"
#include "io.h"
#include "modem.h"
#include "terminal.h"
#include "routing.h"
#include "event.h"
#include "business.h"
#include "tausch.h"		/* wg. AutoTausch */
#include "cslib.h"
#include "cmd.h"
#include "tomtcl.h"
#include "log.h"
#include "owrite_cmdl.h"
#include "tompaths.h"

#include "box_conf.h"

extern USER user;

extern BRETT akt_brett;
extern BRETTNR brettnrW;
extern BRETTART postfach_art;
extern BRETTINFO *br_ind;

extern int attrW[],col_ix[];


extern BYTE
batchB;									/* wg. show_prompt */

extern WORD
anz_lineW,
anz_spalten,
count_crW,
vtmodeW;

extern int logout_modus;

extern long
actual_downloadL,
actual_uploadL,
actual_writeL;

extern int user_in_fd;
extern int user_out_fd;

char *benutzer_prompt_eingabe;


static void login_spruch(void);
static void show_logoff(void);
static void check_birthday(BOOLEAN auto_login);
static void show_banner(void);
static char * find_spec_login(char *str, size_t vgllen);



/* ======================  Mailbox - Unterroutinen  ===================== */

static BOOLEAN istail(const char *s, const char *t)
{
	size_t ls;
	size_t lt;

	ls = strlen(s);
	lt = strlen(t);
	if (ls < lt)
		return FALSE;
	if (!strcmp(s+ls-lt,t))
		return TRUE;
	return FALSE;
}


static void 
show_banner(void)
{
	char buf[8192];
	char bannerbuf[8192];
	/* look like MAUS */
	msleep(150);
	mboutput("\r\n");
	msleep(150);
	mboutput("\r\n");
	msleep(150);
	mboutput("\r\n");
	msleep(150);
	mboutput("\r\n");

	/*
	 * Der folgende Code tuscht eine MAUS vor. Die zuerst ausgegebene
	 * Zeile wird sofort wieder berschrieben.
	 */
	if (do_interpret(
		"MAUS %@ - Version Quark :-)\r",
			buf,sizeof(buf)))
		mboutput(buf);
	if (do_interpret(
		"QUARK %@, TOM Version II-%tv vom %td\r\n",
			buf,sizeof(buf)))
		mboutput(buf);
	mboutput("\r\n");

	if (!box_conf.banner_file)
	{
		mboutput("     Willkommen im MausNet!\r\n\n");
	}
	else
	{
		if (do_interpret( box_conf.banner_file, buf,sizeof(buf)))
		{
			FILE *f;
			f=fopen(buf,"r");
			if (f)
			{
				int got;
				got=fread(buf,1,sizeof(buf),f);
				if (got>=0)
					buf[got]=0;
				if (got > 0
					&& do_interpret(buf,bannerbuf,sizeof(bannerbuf)))
				{
					char *p,*s;
					s=bannerbuf;
					while (s && *s)
					{
						char *next;
						p=strpbrk(s,"\r\n");
						if (p)
						{
							if (*p=='\n')
								next=p+1;
							else
								next=p+2;
							*p=0;
						}
						else
							next=NULL;
						mboutput(s);
						mboutput("\r\n");
						s=next;
					}
				}
				fclose(f);
			}
		}
	}
}

/*
	21.01.93 Frank, MultiTausch implementiert
*/
void impressum(
	 BOOLEAN *tauschlogin, BOOLEAN *multitausch, BOOLEAN *ist_gast,
	 BOOLEAN *sysop_schutzzeichen, const char *force_user, 
	 const char *hint_user, const char *fake_prompt, char **command)
{
	BOOLEAN okB = FALSE;
	WORD iW;
	char stringS[80];

	show_banner();

	/* wenn wir den Usernamen nicht sowieso wissen ... */
	if (!force_user && !hint_user)
	{
		BOOLEAN do_fake=fake_prompt!=NULL;
		/* Defaults setzen */
		*tauschlogin=FALSE;
		*multitausch=FALSE;
		*ist_gast=FALSE;
		*sysop_schutzzeichen=do_fake;
		*command=NULL;

		cmdline_overwrite("TOM: promptwait");

		/* 
		   Mal durchdenken - was soll die Funktion eigentlich tun?
		   Im Klartext: Wenig.
		   Wichtig ist eigentlich blo, da geklrt wird, was eigentlich los ist:
		   - Tausch
		   - Multitausch
		   - Sysopschutzzeichen
		   - Normallogin
		   + als Zugabe noch den Login ohne Gefasel (Logintext)
		   + als Zugabe noch Gastidentifizierung.
		   + als Zugabe noch Speziallogins (uucp, EMSI, ...)
		   Dementsprechend handelt die Routine.
		*/
		   
		for (iW = 0; iW < box_conf.login_tries; iW++)
		{
			time_t try_start;
			const char *fp=fake_prompt;

			if (akt_connection.is_modem)
				io_drain(user_in_fd);

			if (!do_fake)
				mboutput("Sind Sie eingetragener Benutzer? (J/N) ");

			*stringS = '\0';
			try_start=time(NULL);

			do
			{
				char zeichen;
				size_t len;

				len=strlen(stringS);
				if (len >= 70)
				{
					memcpy(stringS,stringS+10,70);
					len-=10;
				}
				if (do_fake)
				{
					if (!fp)
						goto abbruch;
					zeichen=*fp++;
					if (!zeichen)
					{
						zeichen='\n';
						fp=NULL;
					}
					else
						zeichen=toupper(zeichen);
				}
				else
				{
					zeichen = toupper(mbchar());
					if (!zeichen)
						goto abbruch;
				}
				stringS[len++] = zeichen;
				stringS[len] = 0;

				/* Backspace ... */
				if (zeichen=='\b')
				{
					if (len>1)
						len-=2;
					else 
						len=0;
					stringS[len] = 0;
					continue;
				}

				if ((zeichen=='\r' || zeichen =='\n') && len>1)
				{
					*command=find_spec_login(stringS,len-1);
					if (*command)
					{
						okB=TRUE;
						break;
					}
					else if (zeichen=='\r' || zeichen=='\n')
					{
						/* wenn nicht gefunden, neue Zeile beginnen */
						stringS[0]=0;
						len=0;
					}
				}

				/* J: normaler Login */
				if (zeichen=='J')
				{
					zeige_datei(tprintf("%s%s",box_conf.texte_dir,"login.txt"));
					mboutput("\r\n");
					okB=TRUE;
					break;
				}
				else if (zeichen=='.') /* Leiser Login */
				{
					mboutput(" <....>\r\n\n");
					okB=TRUE;
					break;
				}
				else if (zeichen=='N') /* Gastlogin */
				{
					/* Launische Bemerkung */
					mboutput("\r\n\n Ach, Du schon wieder, Gast. :-)\r\n\n");
					okB=TRUE;
					*ist_gast=TRUE;
					break;
				}
				else if (istail(stringS,"MultiTausch")
					  ||  istail(stringS,"MULTITAUSCH"))
				{
					mboutput(" <..MultiTausch..>\r\n\n");
					*tauschlogin = TRUE;
					*multitausch = TRUE;
					*sysop_schutzzeichen=TRUE;
					okB=TRUE;
					break;
				}
				else if (istail(stringS,"TAUSCH") || istail(stringS,"MausTausch"))
				{
					mboutput(" <..Tausch..>\r\n\n");
					*tauschlogin = TRUE;
					*sysop_schutzzeichen=TRUE;
					okB=TRUE;
					break;
				}
				else if (istail(stringS,box_conf.login_protection))
				{
					mboutput(" <..>\r\n\n");
					*sysop_schutzzeichen=TRUE;
					okB=TRUE;
					break;
				}
			}
			while (time(NULL) <= try_start+30);
			do_fake=FALSE;

			if (okB || logout_modus)
				break;
		}

	abbruch:
		mboutput("\r\n\n");

		if (benutzer_prompt_eingabe)
			free(benutzer_prompt_eingabe);
		benutzer_prompt_eingabe=NULL;

		if (!okB)
		{
			mboutput(" <..Fehler..>\r\n\n");

			logout_modus = 1;
		}
		else
		{
			/*
			 * Die Eingabe hier kann fr EMSI von Bedeutung sein.
			 */
			char *p=strpbrk(stringS,"\r\n");
			if (p)
				*p=0;
			benutzer_prompt_eingabe=strdup(stringS);
		}
	}

	if (logout_modus != 1)
		login_spruch();

	count_crW = 0;

} /* impressum */



/*
	Spruch auswhlen, anzeigen und als Infofile IGS schreiben
*/
static void login_spruch(void)
{
	FILE *fort_f;
	struct status_dat st;

	open_read_status_dat(TRUE,&st);

	mbprintf(" Verbindung Nr.%d am %s dem %s um %s (Anruf #%ld)\r\n\n",
				st.tagesanrufe+1,wochentagS(),dd_mm_yy(),hh_mm_ss(),
				st.anz_calls+1);
	if ((fort_f = fopen(tprintf("%s%s",box_conf.texte_dir,"spruch.txt"),BINREAD)) != NULL)
	{
		static BOOLEAN init = FALSE;
		BOOLEAN first;
		char *p;
		char zeile[200];
		long anzahl = 0;
		long nr;
		FILE *igs_f;

		igs_f = fopen(tprintf("%s%s",tom_info_lokal_dir,"IGS"),BINWRITE);

		while (fgets(zeile,200,fort_f))
			if (*zeile != '>')
				anzahl++;

		mboutput(" Spruch des Logins ...\r\n\n");
		if (!init)
		{
			srand((unsigned) time(NULL) & 0x3fff);
			init = TRUE;
		}
		nr = (((double) rand())/RAND_MAX)*anzahl + 1;
		rewind(fort_f);

		while (nr && fgets(zeile,200,fort_f))
			if (*zeile != '>')
				nr--;

		first=TRUE;
		do
		{
			p=strpbrk(zeile,"\r\n");
			if (p)
				*p='\0';
			if (igs_f)
				fprintf(igs_f,"%s\r\n",(first) ? zeile : zeile+1);
			mbprintf(" %s\r\n",(first) ? zeile : zeile+1);
			first=FALSE;
		}
		while (fgets(zeile,200,fort_f) && *zeile == '>');

		if (igs_f)
			fclose(igs_f);
		fclose(fort_f);

		mboutput("\r\n");
	}
	else
	{
		/* Dummlall hat keine hohe Prioritt, daher nur zur Info */
		syslog(LOG_INFO,"Keine Spruchdatei %sspruch.txt vorhanden",
			   box_conf.texte_dir);
	}
} /* login_spruch */



/* 
	13.02.93 Frank, Berechtigung fr autom. Tausch abhngig vom Bezahltflag 
				       des Tauschbefehls
*/
BOOLEAN login(char *force_username, const char *hint_username, BOOLEAN tauschlogin, 
	BOOLEAN *ist_gast, BOOLEAN sysop_schutzzeichen)
{
	BOOLEAN okB;
	WORD iW;
	char nameS[80];
	BOOLEAN name_ok;
	USERNR need_unlock=0;
	time_t ende_lt_business;
	USERNR usernrW;
	long next_time;
	BOOLEAN first=TRUE;
	char *text;
	BOOLEAN passwort_falsch=FALSE;

	usernrW = 0;
	brettnrW = 0;
	postfach_art = TEXT_BRETT;
	iW = 0;


	do
	{
		if (logout_modus==1)
			break;
		cmdline_overwrite("TOM: wait, username");
		write_info_protokoll(INFOPROT_LOGIN,"","");
		if (!*ist_gast && !force_username && !(hint_username && first))
		{
			mbquestion(60,1,FALSE, "Ihr Name      : ","",nameS);
		}
		else if (force_username)
			strcpy(nameS,force_username);
		else if (hint_username && first)
			strcpy(nameS,hint_username);
		else
			strcpy(nameS,"GAST");
		first=FALSE;
		name_ok = ub_find_username(&usernrW,nameS);
		if (!name_ok)
		{
			usernrW = 0;
			iW++;
			if (stricmp(nameS,"GAST"))
			{
				mboutput("\r\n ### Benutzername unbekannt. Gste bitte GAST eingeben\r\n");
				syslog(LOG_INFO,"unbekannter Benutzername beim Login: %s",nameS);
			}
			else
			{
				syslog(LOG_NOTICE,"versuchter Gastlogin");
				mboutput("\r\n ### Kein Gastlogin mglich.\r\n");
			}
		}
		else
		{
			UWORD passwdcount=0;
			if (!ub_read_user(usernrW,&user,TRUE) || user.geloescht)
			{
				usernrW = 0;
				goto abbruch;
			}
			else
				need_unlock=usernrW;

			if (!stricmp(user.name,"GAST"))
			{
				*ist_gast = TRUE;
				break;
			}
			text=concat("TOM: password ",user.name, NULL);
			if (text) 
			{
				cmdline_overwrite(text);
				free(text);
			}

			do
			{
				if (akt_connection.shelluser 
					/* force_username!=NULL: der User hat die Box frisch
					 * gestartet.
					 * shellusernummer==user.nummer: Das kann problemlos
					 * bei einem Relogin passieren.
					 */
					&& (force_username
					|| akt_connection.shellusernummer==user.nummer))
				{
					okB=TRUE;
					break;
				}
				passwdcount++;
				mboutput("\r\n");
				mbquestion(15,5,FALSE,"Ihr Password  : ","",nameS);
				
				if (!*nameS)
				{
					okB = TRUE;
					usernrW = 0;
					iW++;
					if (need_unlock)
					{
						ub_unlock_user(need_unlock);
						need_unlock=0;
					}
				}
				else if (!passwort_vergleich(&user, nameS))
				{
					mboutput(" <== Passwort ist fehlerhaft!");
					passwort_falsch=TRUE;
					okB = FALSE;
				}
				else
					okB = TRUE;
				if (level() >= 8 && !sysop_schutzzeichen && okB && usernrW>0
					&& !hint_username)
				{
					syslog(LOG_WARNING, 
						"Versuchter Hack? %s: Schutzstring falsch", user.name);
					mboutput(" <== Passwort ist fehlerhaft!");
					okB = FALSE;
				}
			}
			while (passwdcount<3 && !okB);
			if (!okB) {
				usernrW = 0;
				syslog(LOG_WARNING, "Versuchter Hack? Name %s", user.name);
				iW++;
				if (need_unlock)
				{
					ub_unlock_user(need_unlock);
					need_unlock=0;
				}
			}
			mboutput("\r\n\n");
			memset(nameS,0,sizeof(nameS));
		}
	}
	while (!(iW>2 || (usernrW > 0 && !user.geloescht)));


abbruch:

	if (usernrW == 0)
	{
		mboutput("\r\n Login fehlerhaft ==> Rauswurf\r\n");
		mboutput("\r\n");
		if (passwort_falsch) {
			/* go away. Don't like you */
			mboutput("              \\|/ ____ \\|/\n");
			mboutput("              \"@'/ ,. \\`@\"\n");
			mboutput("              /_| \\__/ |_\\\n");
			mboutput("                 \\__U_/\n");
			strcpy(akt_anruf.name,"PASSWORT FALSCH");
		} else
			strcpy(akt_anruf.name,"NO LOGIN");
		if (need_unlock)
			ub_unlock_user(need_unlock);
		return FALSE;
	}

	write_info_protokoll(INFOPROT_USER,"","");

	text=concat("TOM: ",user.name, " logged in", NULL);
	if (text) 
	{
		cmdline_overwrite(text);
		free(text);
	}

	if (!check_business(tauschlogin ? 't' : 'l',&next_time,&ende_lt_business))
	{
		mbprintf(" Zur Zeit ist kein %s erlaubt\r\n",
					tauschlogin ? "Tausch" : "Login");
		mbprintf(" nchstmgliches Login um %ld:%ld Uhr\r\n",
			next_time/60,next_time%60);

		/* ### syslog fehlt noch */
		sleep(5);
		return FALSE;
	}

	if (user.zeichensatz!=0)
	{
		cstl_t *cs;
		cs = get_charset_from_nr(user.zeichensatz);
		if (cs)
			set_charset(cs);
		else
		{
			unset_charset(); /* sichere Seite */
			mboutput(" der von Ihnen benutzte Zeichensatz ist nicht vorhanden!\r\n");
		}
	}
	else
		unset_charset(); /* sichere Seite */

	if (!user.bs_zeilen)
		user.bs_zeilen=22;
	anz_lineW = user.bs_zeilen;

	if (*ist_gast)
	{
		user.mehr = TRUE;
		user.menue_stil = 1;
		user.autohilfe = TRUE;
		user.bs_spalten = 78;
		user.letzter_login = time(NULL) - box_conf.gast_flashback * 24L*60*60;
	}

	{
		event_t *ev;
		time_t wurf;
		struct tm tmlast,tmnow,*tm;
		time_t t;
		time_t restzeit_limit;
		struct status_dat st;

		/* setzen der Scrollzeilen, Gesamtzeilen und Spalten */
		if (akt_connection.is_console && getenv("LINES"))
			anz_lineW = atoi(getenv("LINES"));
		else
			anz_lineW = user.bs_zeilen;
		if (user.bs_spalten < 80)
			user.bs_spalten = 80;
		if (akt_connection.is_console && getenv("COLUMNS"))
			anz_spalten = atoi(getenv("COLUMNS"));
		else 
			anz_spalten = user.bs_spalten;
		vtmodeW=T_ASCII;
		sync_terminal();

		akt_anruf.ist_zahler = user.bezahlt;
		strcpy(akt_anruf.name,user.name);
		strcpy(akt_anruf.zuletzt,"BOX");

		/* 
         * neuer User bzw. letztes Login vor einem Tag?
		 * Dann (erstmals) Restzeit zuordnen 
		 */
		t=time(NULL);
		tmnow=*localtime(&t);
		tm=localtime(&user.letzter_login);
		if (tm)
			tmlast=*tm;
		else
			tmlast=*localtime(&t);
		
		if (!user.anrufe 
			|| tmlast.tm_year!=tmnow.tm_year 
			|| tmlast.tm_mon!=tmnow.tm_mon
			|| tmlast.tm_mday!=tmnow.tm_mday)
			user.restzeit = box_conf.onlinezeit[user.level]*60;

		if ((box_conf.paid_fulltime && user.bezahlt) || *ist_gast
			|| box_conf.anybody_fulltime)
			restzeit_limit = time(NULL)+box_conf.onlinezeit[user.level]*60;
		else
		{
			restzeit_limit = time(NULL)+user.restzeit;
			if (!box_conf.auto_tausch_all)
				tauschlogin = FALSE;
		}
		if (box_conf.paid_extratime && user.bezahlt)
			restzeit_limit += box_conf.paid_extratime * 60;


		/* business.cnf beeinflut Zeitlimits fr User */
		ev=event_next_wurf(&wurf);

		/*
		 * Verfahren: Hartes Limit auf nchsten Event setzen, auer bei
		 * Level 9, dort restzeit ausschpfen.
		 */
		if (!ev || level()==9)
		{ 
			if (level()==9 && restzeit_limit>time(NULL)+wurf)
			{
				mbprintf(" Nchster Event in %d Minuten. Sie wissen, was Sie tun?\r\n",
					(int) wurf/60);
				akt_anruf.hard_limit = restzeit_limit;
			}
			else if (level()==9)
				akt_anruf.hard_limit = time(NULL) + wurf;
			else
				akt_anruf.hard_limit = restzeit_limit;
		}
		else
			akt_anruf.hard_limit = time(NULL) + wurf;

		/* hartes Limit ist der nchste Event, als soft limit wird 
		 * Business/Restzeit-Ende verwendet, falls nicht vorher ein
		 * Event anliegt.
		 */
		akt_anruf.soft_limit=akt_anruf.hard_limit;

		if (akt_anruf.soft_limit > ende_lt_business)
		{
			if (ende_lt_business<time(NULL)+15)
				mbprintf(" (Business-Limit erreicht, %ld, jetzt %ld, ignoriert)\r\n",
					(long) ende_lt_business,(long)time(NULL));
			else
				akt_anruf.soft_limit = ende_lt_business;
		}
		if (akt_anruf.soft_limit > restzeit_limit)
			akt_anruf.soft_limit = restzeit_limit;

		if (level()==9 && akt_anruf.soft_limit - time(NULL) <10 * 60)
		{
			/* 
			 * Feature: L9-Sysops noch eine Chance geben.
			 */
			mboutput(" Onlinezeit auf 10 Minuten erhht!\r\n");
			akt_anruf.soft_limit=time(NULL)+10*60;
		}

		if (akt_anruf.soft_limit <= time(NULL))
		{
			if (need_unlock)
				ub_unlock_user(need_unlock);
			mboutput(" Leider keine Online-Zeit mehr fr heute vorhanden\r\n\n");
			if (restzeit_limit <= time(NULL))
			{
				strcpy(akt_anruf.zuletzt,"T-R");
				mboutput(" (Restzeit-Limit erreicht)\r\n");
			}
			if (ende_lt_business <= time(NULL))
			{
				strcpy(akt_anruf.zuletzt,"T-B");
				mboutput(" (Business-Limit erreicht)\r\n");
			}
			if (akt_anruf.hard_limit <= time(NULL))
			{
				strcpy(akt_anruf.zuletzt,"T-E");
				mboutput(" (Event-Limit erreicht)\r\n");
			}
			sleep(3);
			if (akt_connection.is_modem)
				hangup_modem(user_out_fd);
			return FALSE;
		}

		/* Letzten Anrufer und Zeit speichern */
		{
			FILE *f=open_read_status_dat(FALSE,&st);
			if (f)
			{
				strncpy(st.last_user,user.name,sizeof(st.last_user));
				st.last_user[sizeof(st.last_user)-1]=0;
				st.last_call=time(NULL);
				write_close_status_dat(f,&st);
			}
		}
		user.anrufe++;
		ub_write_user(&user,FALSE);
		check_user_data(user.nummer); /* make sure we have has private directory */

		mbprintf(" Userlevel: %d\r\n",level());
		mbprintf(" Restzeit : %ld Minuten.\r\n\n",(restzeit()+30)/60);
#if 0
		mbprintf(" Die Post verdiente heute bisher DM %.1ld.%02ld an dieser Box.\r\n",
					st.postertrag/100,st.postertrag%100);
#endif
		mbprintf(" Systemauslastung bis %s: %d %%\r\n\n",hh_mm_ss(),auslastung());
		mboutput(" CTRL-X = Abbruch / CTRL-S = Stop / CTRL-Q = Weiter\r\n\n");
		if (*ist_gast)
		{
			zeige_datei(tprintf("%s%s", box_conf.texte_dir,"gastinfo.txt"));
			mboutput("\r\n");
			if (box_conf.ask_newuser_userantrag)
			{
				struct mbselect_t sel[]=
				{
					{ 'J' , "Ja\r\n" },
					{ 'N' , "Nein\r\n" },
					{ 0   , NULL }
				};
				mboutput(
					" Wollen Sie sich nun als Benutzer eintragen? (J/N) ");
				if (mbselect(sel)=='J')
					bef_userantrag(NULL);
				mboutput("\r\n");
			}
		}
		b_set_flags(&user);
		automatic_batch("login");
	}
	return TRUE;
}



void redraw_status(void)
{
	if (vtmodeW != T_VT100)
		return;

	mbprintf("%s%s%s  Brett: %s",
				vt_pos_S(1,1),vt_S(DEL_RIGHT),
				vt_S(ATTR_FETT),vt_S(ATTR_OFF));
	if (brettnrW==0)
	{
		if (postfach_art == BINAER_BRETT)
			mboutput(" <Programmfach>");
		else
			mboutput(" <Postfach>");
	}
	else
		mbprintf(" %s",akt_brett.name);

	mbprintf("%s%s Restzeit: %s %ld Min.%s%s Bereich:%s",
				vt_pos_S(1,35),vt_S(ATTR_FETT),
				vt_S(ATTR_OFF),restzeit()/60,
				vt_pos_S(1,65),vt_S(ATTR_FETT),
				vt_S(ATTR_OFF));

	if ((brettnrW==0 && postfach_art==BINAER_BRETT)
		|| (akt_brett.art == BINAER_BRETT))		/* Lokal, Bin */
		mboutput(" Binr");
	else if (brettnrW==0 || br_ind[brettnrW].brett->flags & B_LOKAL)
		/* Lokal, Text */
		mboutput(" Lokal");
	else
		mboutput(" Netz ");						/* Netz */

	mbprintf("%s%ld ",vt_pos_S(1,47),restzeit()/60);

} /* redraw_status */



/*
	Statuszeile, Befehlsprompt und Uhrzeit anzeigen

	->			befehl	:	auszugebende Befehlszeile (fr Batchmodus)

	wird in login() Eingabeschleife sowie bei Batchverarbeitung	bentigt
*/
char *
prepare_prompt(void)
{
	static char buf[256];
	/* ### fehlende Statuszeilen verhindern */
	redraw_status();

	if (vtmodeW == T_VT100)
	{
		/* In oberster Zeile die Restzeit ausgeben */
		mbprintf("%s%ld ",vt_pos_S(1,47),restzeit()/60);
		/* Cursor nach unten */
		mbprintf("%s",vt_pos_S(anz_lineW,1));
	}

	switch(user.uhrmodus)
	{
	case UHR_REST:
		sprintf(buf,"%u ", (unsigned)(restzeit()/60));
		break;
	case UHR_NORMAL:
		sprintf(buf,"%u ", (unsigned)((time(NULL)-akt_anruf.startzeit)/60));
		break;
		break;
	case UHR_ZEIT:
		sprintf(buf,"%s ", hh_mm_ss());
		break;
	default:
		*buf=0;
		break;
	}

	/* bei vt100 stehen diese Informationen in der obersten Zeile */
	if (vtmodeW != T_VT100)
	{
		if (brettnrW==0)
		{
			if (postfach_art == BINAER_BRETT)
				sprintf(buf+strlen(buf),"<Programmfach> ");
			else
				sprintf(buf+strlen(buf),"<Postfach> ");
		}
		else
		{
				if (akt_brett.art == BINAER_BRETT)		/* Lokal, Bin */
					sprintf(buf+strlen(buf),"(Binr: ");
				else if (br_ind[brettnrW].brett->flags & B_LOKAL)/* Lokal, Text */
					sprintf(buf+strlen(buf),"(Lokal: ");
				else
					sprintf(buf+strlen(buf),"(Netz: ");						/* Netz */

				sprintf(buf+strlen(buf),"%s) ",akt_brett.name);
			}
	}

	sprintf(buf+strlen(buf),"Befehl: ");
 
 #if 0
	if (vtmodeW == T_VT100)
	{
		mbprintf("%s%ld ",vt_pos_S(1,47),restzeit()/60);

		mbprintf("%s %sBefehl: %s%s",
					vt_pos_S(anz_lineW,1),
					(batchB) ? "BATCH-" : "",
					vt_S(ATTR_OFF),vt_S(DEL_RIGHT));
		switch(user.uhrmodus)
		{
		case UHR_REST:
			mbprintf("%s%u%s",vt_pos_S(anz_lineW,72),
					(unsigned)(restzeit()/60),vt_pos_S(anz_lineW,10));
			break;
		case UHR_NORMAL:
			mbprintf("%s%u%s",vt_pos_S(anz_lineW,72),
					(unsigned) (time(NULL)-akt_anruf.startzeit),
					vt_pos_S(anz_lineW,10));
			break;
		case UHR_ZEIT:
			mbprintf("%s%s%s",vt_pos_S(anz_lineW,72),
					hh_mm_ss(),vt_pos_S(anz_lineW,10));
			break;
		default:
			break;
		}
	}
	else
	{
		mboutput("\r\n");
		if (brettnrW==0)
		{
			if (postfach_art == BINAER_BRETT)
				mboutput(" <Programmfach>");
			else
				mboutput(" <Postfach>");
			if (batchB)
				mbprintf(" %sefehl: %s\r\n\n",(batchB) ? "Batchb" : "B",befehl);
			else
				mboutput(" Befehl: ");
		}
		else
		{
			if (batchB)
				mbprintf(" (%s) Batchbefehl: %s\r\n\n",
					br_ind[brettnrW].brett->name,befehl);
			else
			{
				if (akt_brett.art == BINAER_BRETT)		/* Lokal, Bin */
					mboutput(" (Binr:");
				else
				if (br_ind[brettnrW].brett->flags & B_LOKAL)	/* Lokal, Text */
					mboutput(" (Lokal:");
				else
					mboutput(" (Netz:");						/* Netz */

				mbprintf(" %s) Befehl: ",akt_brett.name);
			}
		}
	}

#endif
	if (user.glocke)
		userglocke();

	return buf;
} /* show_prompt */



/*
	10.12.92 Frank, berarbeitungsbedrftig (AutoTausch auslagern usw.)
*/
void communication(BOOLEAN tauschlogin, BOOLEAN ist_gast)
{
	WORD decideW = 0;
	BOOLEAN neue_pers = FALSE;
#ifdef HAVE_LIBTCL
	BOOLEAN first = TRUE;
#endif
	BOOLEAN anything_new = FALSE;

	BOOLEAN autotausch_erlaubt=TRUE;
	box_cmd_t *tau;

	tau=befehl_find("TAUSCH",NULL);
	if (!tau || !tau->level[level()] 
		|| (tau->nur_zahler && !user.bezahlt))
			autotausch_erlaubt=FALSE;

	/* Relogins nicht zhlen */
	if (akt_anruf.ist_relogin==0)
	{
		FILE *f;
		struct status_dat st;
		f=open_read_status_dat(FALSE,&st);
		if (f)
		{
			st.tagesanrufe++;
			st.anz_calls++; 
			write_close_status_dat(f,&st);
		}
		akt_anruf.anrufnummer=st.anz_calls;
	}

	actual_downloadL = 0;
	actual_uploadL = 0;
	check_part_free(tauschlogin);

	bef_clearscreen("");

	if (!ist_gast)
	{
		struct stat sb;
		uostr_t datei={0};
		uostr_xdup_cstrmulti(&datei,box_conf.texte_dir,"neu.txt",NULL);
		uostr_x0(&datei);
		if (!stat(datei.data,&sb))
		{
			if (sb.st_mtime > user.letzter_login)
			{
				zeige_datei(datei.data);
				/* der Text ist wichtig - und wir lschen gleich den 
				 * Bildschirm!
				 */
				if (!tauschlogin)
					wait_mehr();
			}
		}
		uostr_freedata(&datei);
		check_birthday(tauschlogin);
	}

	/*
		setzen der Bildschirmeinstellungen
		war: set_vtprefs()
	*/
	/* User-spezifische Schriftfarben setzen */
	{
		BOOLEAN ok=TRUE;
		UWORD i;
		/* Suchen ob die Farbe in den Userdaten schon initialisiert
		 * ist 
		 */
		for (i = 0; i < NUMBER_COLORS; i++)
		{
			if (user.colatt[i].fg_col<FIRST_COLOR 
				|| user.colatt[i].fg_col>LAST_COLOR)
				ok=FALSE;
		}
		if (ok)
		{
			for (i = 0; i < NUMBER_COLORS; i++)
				col_ix[i] = user.colatt[i].fg_col;
		}
		else
		{
			for (i = 0; i < NUMBER_COLORS; i++)
				col_ix[i] = i+FIRST_COLOR;
		}
	}

	mboutput("\r\n");

	akt_brett=*br_ind[0].brett;
	strcpy(akt_brett.name,user.name);

	if (level()==0)
	{
		cstl_t * cs;

		cs = get_charset_from_nr(user.zeichensatz);
		mbprintf(
			" Zur Zeit ist %s %sZeichensatz eingestellt.\r\n"
			" Wollen Sie das jetzt ndern? (J/N) ",
			cs && cs->name ? cs->name : "kein",
			cs && cs->name ? "als " : "");
		if (mbdecide("JN","Ja\r\n|Nein\r\n")==1)
		{
			char *k=XSTRDUP("UMLAUT *");
			befehl_ausfuehrung(k);
			free(k);
		}

		if (user.box_stil==QUARK_STYLE)
			bef_fragezeichen("");
	}
	else if (!tauschlogin)
	{
		mboutput("\r\n");
		postfach_art = TEXT_BRETT;
		if (!bef_inhalt(""))
		{
			postfach_art = BINAER_BRETT;
			if (!bef_inhalt(""))
				postfach_art = TEXT_BRETT;
			else
			{
				neue_pers = TRUE;
				anything_new=TRUE;
			}
		}
		else
		{
			neue_pers = TRUE;
			anything_new=TRUE;
			akt_anruf.hat_neue_pms=TRUE;
		}
	}

	/*
	 * Gste, Autotauscher und Benutzer mit Mausoberflche bekommen
	 * die neuen Bretter nicht angezeigt.
	 */
	if (level() && !tauschlogin && user.box_stil!=MAUS_STYLE)
	{
		if (b_check_new())
		{
			mboutput("\r\n");

			if (!autotausch_erlaubt)
			{
				mboutput(" >> Bretter mit neuen Eintrgen auflisten (J/N) : ");
				decideW = mbdecide("JN","Ja ...|Nein");
			}
			else
			{
				mboutput(" >> Bretter mit neuen Eintrgen auflisten (J/N/Tausch) : ");
				decideW = mbdecide("JNT","Ja ...|Nein|Tausch ...");
			}
			mboutput("\r\n");
			mboutput("\r\n");
			if (decideW==1)
			{
				anything_new=TRUE;
				bef_brett("");
			}
			else
				/* der User hat sich schon durch eine Abfrage geqult */
				anything_new=FALSE;
		}
		else /* !b_check_new() */
		{
			mboutput("\r\n");
			mboutput(" Keine neuen Eintrge in den Brettern\r\n");
			mboutput("\r\n");
		}
	}
	if (level()==0)
	{
		bef_vt("");
		mboutput("\r\n");
	}
	/* bei Tauschlogin nicht - niemand bekommt sonst den Neutext mit! */
	else if (!tauschlogin)
	{
		if (anything_new && user.terminal_typ==T_VT100)
			wait_mehr(); /* damit die Ausgaben nicht sofort gelscht werden */
		vtmodeW=user.terminal_typ;
		sync_terminal();
		if (user.flags & UB_FLAG_AUTO_RESIZE)
		{
		    int ret;
			ret=io_resize_terminal(user_in_fd,user_out_fd,RESIZE_MODE_INQUIRE);
			if (ret==RESIZE_ANS_NOT_CAP || ret == RESIZE_ANS_OK)
			{
				/* Der User *will* es so - sagte er jedenfalls dem
				 * Usereditor.
				 */
				int mode;
				int spalten, zeilen;
				if (ret==RESIZE_ANS_OK)
					mode=RESIZE_MODE_NORMAL;
				else
					mode=RESIZE_MODE_FORCE_VT;
				io_resize_terminal(user_in_fd,user_out_fd,mode);
				sync_terminal();
				io_get_term_size(user_in_fd,&spalten,&zeilen);
		        anz_lineW = zeilen;
				mboutput("\r");
			}
		}
		mboutput(vt_S(DEL_SCR));
		if (vtmodeW==T_VT100)
			set_scroll_area(1);
	}

	if ((decideW==3 || tauschlogin) && autotausch_erlaubt)
	{
		if ((ta_run_tausch(ta_modus_normal,NULL,NULL,NULL,NULL) 
			|| tauschlogin) && logout_modus != 2)
		{
			if (tauschlogin)
				logout_modus = 1;
		}
	}

	while (TRUE)
	{
		char *prompt;
		char *bef;
		check_timeout();
		if (logout_modus)
			break;
#ifdef HAVE_LIBTCL
		if (first && user.box_stil==MAUS_STYLE)
		{
			/* kein tprintf - das knnte hier rekursiv aufgerufen 
			 * werden. Aber auch kein Stackpuffer, ANSI erzwingt,
			 * da der Stackplatz erst am Ende der Funktion freigegeben
			 * wird (braindead, indeed), und PATH_MAX ist recht
			 * viel Platz fr eine Funktion "ganz oben".
			 */
			uostr_t datei={0};
			/* Mausoberflche TMP */
			uostr_xdup_cstrmulti(&datei,box_conf.tcl_dir,"maus2/main.tcl",NULL);
			uostr_x0(&datei);
			if (fileexist(datei.data))
				ttcl_script(datei.data,NULL);
			else {
				/* Mausoberflche V2 */
				uostr_xdup_cstrmulti(&datei,box_conf.tcl_dir,"maus/main.tcl",NULL);
				uostr_x0(&datei);
				if (fileexist(datei.data))
					ttcl_script(datei.data,NULL);
				else
				{
					uostr_xdup_cstrmulti(&datei,box_conf.tcl_dir,"mausmain.tcl",NULL);
					uostr_x0(&datei);
					if (fileexist(datei.data))
						ttcl_script(datei.data,NULL);
				}
			}
			uostr_freedata(&datei);
		}
		first=FALSE;
#endif
		if (logout_modus)
			break;

		prompt=prepare_prompt();
		bef=befehl_eingabe(prompt);
		if (!bef || logout_modus)
			break;

		mbprintf("%s",vt_pos_S(3,1));
		mbprintf("%s\r\n",vt_S(DEL_SCR_REST));
		befehl_ausfuehrung(bef);
		free(bef);
		if (logout_modus)
			break;
	}
	show_logoff();
	unset_charset();
	if (!user.bezahlt)
	{
		/*
		 * Schlechte Idee: Wenn ein User mit 60 Minuten Tagesgesamtzeit
		 * in einer Phase mit nur 15 Minuten Onlinezeit sich einloggt
		 * und 11 Minuten bleibt, hat er nur noch 4 Minuten.
		 * user.restzeit = restzeit();
		 */
		time_t verbraucht=time(NULL)-akt_anruf.userstartzeit;
		user.restzeit-=verbraucht;
		if (user.restzeit<0)
			user.restzeit=0;
	}

} /* communication */



static void show_logoff(void)
{
	long o_zeitL;

	/* EVERY STOP */
	if (logout_modus > 0)
	{
		char zeile[120];
		time_t oz;
		FILE *spr_f;

		user.letzter_login3 = user.letzter_login2;
		user.letzter_login2 = user.letzter_login;
		user.letzter_login = time(NULL);
		set_scroll_area(0);
		mboutput(vt_S(DEL_SCR));

		zeige_datei(tprintf("%s%s",box_conf.texte_dir,"logoff.txt"));

		akt_anruf.endzeit=time(NULL);

		mboutput("\r\n");
		mbprintf(" Login #%ld /// User: %s /// System: %s\r\n\n",
					akt_anruf.anrufnummer,user.name,box_conf.systemname);
		mbprintf(" Login  : %s Uhr\r\n",
				 zeige_datum_S(
					 akt_anruf.ist_relogin ? akt_anruf.userstartzeit : 
					 akt_anruf.startzeit));
		mbprintf(" Logoff : %s %s Uhr\r\n",dd_mm_yy(),hh_mm_ss());
		oz=time(NULL) - akt_anruf.userstartzeit;
		mbprintf(" Online : %02d:%02d:%02d\r\n",
				 (int) (oz / 3600), (int) ((oz / 60)%60), (int) (oz % 60));
		if (akt_connection.is_modem 
			&& logout_modus==1
			&& fileexist(tprintf("%sgebuehren",box_conf.bin_dir)))
		{
			puts(" "); /* leicht einruecken */
			call_piped(tprintf("%sgebuehren --from %lu",box_conf.bin_dir,
								(unsigned long) akt_anruf.startzeit),FALSE);
		}
		mboutput("\r\n");

		o_zeitL = akt_anruf.endzeit-akt_anruf.userstartzeit;
		o_zeitL = o_zeitL/60;
		o_zeitL = Min(o_zeitL,60)/6;
		o_zeitL++;

		spr_f = fopen(tprintf("%s%s",box_conf.texte_dir,"abschied.txt"),"r");
		if (spr_f != NULL)
		{
			while (o_zeitL--)
				fgets(zeile,100,spr_f);
			fclose(spr_f);
			mboutput("\r\n");
			mboutput(zeile);
			mboutput("\r\n\n");
		}

		mbprintf(" tsch, %s und Danke fr Deinen Besuch......\r\n\n",user.name);

		akt_connection.carrier_cps = Max(230,akt_connection.carrier_cps);

		/* warten, bis das eigene Modem die Daten hat */
		if (akt_connection.is_modem)
			io_drain(user_out_fd);
	}

	write_info_protokoll(INFOPROT_LOGOUT,"","");
	put_auslastung(akt_anruf.userstartzeit, useronline());

	/* So, jetzt noch genau zwei Sekunden warten, falls wir remote sind */
	if (akt_connection.is_modem)
		sleep(2);

} /* show_logoff */



/* 
 * Geburtstagsgru senden.
 * einmal auf den Bildschirm.
 * wenn autologin dann noch mal als Mail, wenn sich derjenige heute
 * noch nicht eingeloggt haben sollte (sonst hagelt es doppelte bei
 * Vieltauschern).
 * Als Modul auslagern?
 */
static void 
check_birthday(BOOLEAN auto_login)
{
	struct tm *tm;
	time_t t;

	t=time(NULL);
	tm=localtime(&t);
	if (!tm)
		return;  /* error silently ignored */

	if (tm->tm_mday!=user.geburtstag || tm->tm_mon+1!=user.geburtsmonat)
		return;

	mboutput(" -----------------------------------------------------\r\n");
	mbprintf(" Lieber %s\r\n\n",user.name);
	mboutput(" !!!  H E R Z L I C H E N   G L  C K W U N S C H  !!!\r\n\n");
	mboutput("                        zum\r\n\n");
	mboutput(" !!!             G E B U R T S T A G               !!!\r\n\n");
	mboutput("            - wnscht Dir Deine Mailbox -\r\n");
	mboutput(" -----------------------------------------------------\r\n");
	if (!auto_login)
		mbchar();
	else
	{
		FILE *f;
		uostr_t fname={0};
		uostr_t an={0};
		uostr_t von={0};
		struct tm heute;
		
		heute=*tm;
		heute.tm_hour=0;
		heute.tm_min=0;
		heute.tm_sec=0;
		t=mktime(&heute);
		if (user.letzter_login>t)
			return;

		uostr_xdup_cstrmulti(&fname,tom_tmp_dir,"glueckw.msg",NULL);
		uostr_x0(&fname);
		uostr_xdup_cstrmulti(&an,user.name," @ ",MYDOMAINPART, NULL);
		uostr_x0(&an);
		uostr_xdup_cstrmulti(&von,"Quark @ ",MYDOMAINPART, NULL);
		uostr_x0(&von);

		f=xfopen(fname.data,"w");
		fprintf(f,
				"\n"
				" Lieber %s\n\n"
				" !!!  H E R Z L I C H E N   G L  C K W U N S C H  !!!\n\n"
				"                        zum\n\n"
				" !!!             G E B U R T S T A G               !!!\n\n"
				"            - wnscht Dir Deine Mailbox -\n"
				,user.name);
		fclose(f); /* ### soetwas fngt man eigentlich ab! */
		einfachnachricht(TRUE,9,TRUE,fname.data,
						 'A', an.data,
						 'V', von.data,
						 'W', "Herzlichen Glckwunsch",
						 0);
		unlink(fname.data);

		uostr_freedata(&fname);
		uostr_freedata(&an);
		uostr_freedata(&von);
	}
} /* check_birthday */

static char *
find_spec_login(char *str, size_t vgllen)
{
	struct speclogin {
		const char *name;
		char *cmd;
		struct speclogin *next;
	};
	static BOOLEAN init_done=FALSE;
	static struct speclogin *anker=NULL;
	struct speclogin *akt;
	char old;
	char buf[1024];

	if (!init_done)
	{
		struct speclogin *neu;
		FILE *f;
		init_done=TRUE;
		if (tom_port_config_dir)
			f=fopen(tprintf("%sspeclogin.cnf",tom_port_config_dir),"r");
		else
			f=NULL;
		if (!f)
			f=fopen(tprintf("%sspeclogin.cnf",box_conf.config_dir),"r");
		if (!f)
			return NULL;
		while (fgets(buf,sizeof(buf),f))
		{	
			char *p;
			p=strpbrk(buf,"\r\n");
			if (p)
				*p=0;
			p=strchr(buf,'=');
			if (!p)
				continue;
			*p++=0;
			strtrim(buf);
			strtrim(p);
			if (!*buf || !*p)
				continue;
			neu=XMALLOC(sizeof(struct speclogin));
			strlwr(buf);
			neu->name=XSTRDUP(buf);
			neu->cmd=XSTRDUP(p);
			neu->next=anker;
			anker=neu;
		}
		fclose(f);
	}

	old=str[vgllen];
	str[vgllen]=0;
	strlwr(str);
	for (akt=anker;akt;akt=akt->next)
	{
		if (!fnmatch(akt->name,str,0))
		{
			str[vgllen]=old;
			return akt->cmd;
		}
	}
	str[vgllen]=old;
	return NULL;
}
