/* msg.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef MSG_H
#define MSG_H

/* this file is to be included from router/routing.h */

#include "brett.h"
#include <simplelist.h>

#define HEADLEN 256
#define MAX_KOPIEN 10

#ifndef LINEEND
#define LINEEND "\r\n"
#endif

/* die zu verarbeitende Nachricht - ohne Body */
typedef struct message_t 
{
	char msg_id[HEADLEN];		/* # */
	char ref_id[HEADLEN];		/* - */
	char absender[HEADLEN];		/* V */
	char sender[HEADLEN];		/* S */
	char reply_to[HEADLEN];		/* T */
	simplelist_t *to;	        /* A, K, > */
	char betreff[HEADLEN];		/* W */
	char eingabezeit[HEADLEN];	/* E */
	time_t eingabezeit_tt;	    /* E */
	simplelist_t *gruppen;		/* G */
	simplelist_t *followup;		/* F */
	char bearbeitungsstatus[HEADLEN];	/* B */
	char organisation[HEADLEN];	/* O */
	char realname[HEADLEN];		/* N */
	char distribution_byte;	    /* D */
	char *gateway_zeile;	    /* Y */
	char *path_zeile;           /* p */
	char *mimeinfo;             /* M */
	char *flags_zeile;          /* X */
	simplelist_t *uo_comments;   /* ! */
	simplelist_t *comments;		/* > */
	UWORD kopienzahl;
	BRETTNR junk_group;			/* Nachricht junken? */
	enum
	{
		false_msg,				/* ungltig */
		pers_msg,				/* P eine persnliche Nachricht */
		gruppen_msg,			/* A ffentliche Nachricht */
		status_msg,				/* S eine Statusnachricht */

		quark_msg,              /* Q direct command */
		nocem_msg,                /* NOCEM */
		ren_msg,                /* R REN */
		head_msg,               /* H HEAD */
		log_msg,                /* L LOG */
		cmd_msg,                /* C CMD */
		cnf_msg,                /* B CNF */
		info_msg,               /* I Infofile */
		out_msg                 /* O Kommandooutput */
	}
	msgtyp;
	time_t importzeit;

	struct tauschbody
	{
		size_t bufsize;
		char *buf;
		size_t len;				/* ohne : */
		size_t physlen;			/* mit : */
		char *next;
	}
	body;

	/* falls der Dateiname angeben ist, wird der Inhalt der Datei 
	 * (Textfile, nicht im MausTauschformat) statt des Inhalts von
	 * "body" benutzt.
	 */
	char *fname;
} message_t;

BOOLEAN msg_change_access(void);

void msg_clean_message(message_t *head);
message_t *msg_alloc(void);
void msg_free(message_t *);
extern void msg_add_line_to_body(message_t *,char *); 

#endif


