/* post_box.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include <portab.h>

#include "post_box.h"
#include "befehle.h"


/*
	im Boxmodus aus dem Offline-Message-Browser heraus Nachrichten verschicken

	offensichtlich mu in TOM "bef_senden/senden/senden_text" erweitert werden, 
	um z.B. bei einer Antwort/Kommentar die Referenz-ID zu bergeben sowie den 
	aktuellen Betreff als Voreinstellung bernehmen zu knnen.
	Die Funktionen in befehle/senden.c gehen davon aus, da das Ziel entweder 
	ein explizit angegebener User oder aber das _aktuelle_ Brett ist.
	Auerdem funktioniert das Mail-Versenden nur aus Textbrettern heraus, 
	was solange aber problemlos ist, wie diese Funktion selbst nur aus dem 
	Browser heraus aufgerufen wird, da dann ja immer ein Textbrett bzw. das 
	persnliche Postfach und nicht etwa -Programmfach aktiv ist.

	Die Anpassungen der TOM-Funktionen sollte relativ einfach sein, da inzwi-
	schen alles in einem Modul (senden.c) vorliegt.

	Dieses Modul sollte dann auch in senden.c integriert werden, da es klar 
	eher Bestandteil von TOM denn Offline ist.

	Zu beachten ist noch, die Fn. in TOM high-level genug aufzurufen, um 
	Zugriffsprfungen zu erledigen.
*/
BOOLEAN message(int wahl,const char *name,char *id,char *thema,char *autor)
{
	switch (wahl)
	{
		case 'f' :
			/* forward */
			break;

		case 'b' :
			/* beantworten */
			bef_senden("");
			break;

		case 'k' :
			/* kommentieren */
			bef_senden("");
			break;

		case 'm' :
			/* neue OM */
			bef_senden("");
			break;

		case 'p' :
			/* neue PM */
			bef_senden("");
			break;

		default :
			return FALSE;
	}

	return TRUE;

} /* message */
