/* import.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	vorhandene bzw. notwendige Headerfelder (HC = Headercode)
	kein Bitset, da Compiler-Unabhngigkeit wichtiger

	Idee: Buchstabencode als Referenz bzw. Index verwenden.
	also: if (index.header & (1 << 'T'-'A'))  then Eintrag vorhanden
	bzw.: if (index.header & HC('T'))  then Eintrag vorhanden

	Mit einer Maske kann man so auch prima die Gltigkeit berprfen.
*/
#define HC(a)				(1L << (a-'A'))
#define NOTWENDIG_PM		(HC('V') + HC('A') + HC('B') + HC('E') + HC('W'))
#define NOTWENDIG_OM		(HC('W') + HC('E') + HC('G'))
#define IRON				(HC('I') + HC('R') + HC('O') + HC('N'))
#define ERLAUBT_PM		(NOTWENDIG_PM + IRON)
#define ERLAUBT_OM		(NOTWENDIG_OM + IRON + HC('V') + HC('A') + HC('D'))

/*
	diese Maske enthlt die in eigenen PMs vorkommenden Zeilen, inkl. der 
	ggf. vom Export generierten B-Statuszeile.
	Damit lassen sich beim Import von PM-Outfiles z.B. bei bernahme aus 
	anderen FEs die selbst verfaten Nachrichten erkennen.
*/
#define EIGENE_PM			(HC('A') + HC('W') + HC('E'))
#define ERLAUBT_EIGENE	(HC('A') + HC('W') + HC('E') + HC('B'))
