/* msgid.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Offline - MausTausch-FrontEnd

	globale Message-ID Verwaltung
	(c) 1992-95 bei Frank Baumgart

	begonnen am 16.05.1994
	Version vom 29.01.1995
*/

/* #define USE_NDBM */


#include "portab.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#ifdef USE_NDBM
#include <ndbm.h>
#else
#include <sdbm.h>
#endif

#include "system.h"
#include "struktur.h"
#include "mdb_conf.h"
#include "mdb_glob.h"
#include "mdb_intr.h"
#include "msgid.h"
#include "screen/io.h"
#include "message.h"						/* wg. msgid_find_infos() */
#include "tool.h"
#include "missing/missing.h"
#include "fehler.h"

extern CONFIG config;

extern WORK *msg[];						/* wg. msgid_find_infos() */

static DBM *mdbh = NULL;				/* handle fr MsgID-DB */
static DBM *rdbh = NULL;				/* handel fr Ref-DB */

static void msgid_exit(void);
static BOOLEAN msgid_append(BOOLEAN pm);

/*
	interne Normierung der IDs bei Suche/Einfgen/Lschen/Ersetzen.
	Der domain-Part ist case-insensitiv zu behandeln, intern werden daher 
	alle domain-Parts in Kleinschrift gewandelt, um caseinsensitiv suchen 
	zu knnen.
	Da die meisten anderen Tools/FrontEnds damit nicht zurechtkommen drften 
	(z.B. Wildwestverkettung) ist diese Normierung z.Z. nicht aktiv.
*/
#if 1
#define NormID(d,s)		{	char *p; \
									strncpy(d,s,MAX_HDR); \
									d[MAX_HDR-1] = 0; \
									if ((p = strchr(d,'@')) != NULL) \
										strlwr(p+1); }
#else
#define NormID(d,s)		{ strncpy(d,s,MAX_HDR); d[MAX_HDR-1] = 0; }
#endif



/*
	MsgIDs aller Gruppen _oder_ User in globale Referenz-DB einfgen

	->			pm	:	TRUE = PM, FALSE = Gruppen

	Es werden nur IDs realer Msgs. eingetragen, bei crosspostings 
	also nur die des "Originals" (= erste angegebene Gruppe), nicht 
	die der virt. Referenzen.
*/
static BOOLEAN msgid_append(BOOLEAN pm)
{
	char key[MAX_HDR];
	char name[MAX_CPG];
	char ind_pfad[PATH_MAX];
	char dat_pfad[PATH_MAX];
	char buf[2048];
	FILE *ind_f;
	FILE *dat_f;
	GLOBAL_REF ref;
	INDEX ix;
	MESSAGE msg_nr;
	long nr;
	char rot[] = "-\\|/";
	int i = 0;

	if (!open_grplst(pm))
		return FALSE;

	while (read_grplst(name))
	{
		printf("%s\n",name);
		/* putchar(rot[i & 3]); */
		fflush(stdout);
		putchar('\b');
		i++;

		if ((nr = group_path(name,ind_pfad,pm)) < 0)
			continue;
		strcpy(dat_pfad,ind_pfad);
		strcat(dat_pfad,"dat");
		strcat(ind_pfad,"ind");

		if ((ind_f = fopen(ind_pfad,BINREAD)) == NULL)
			continue;
		pufferung(ind_f,NULL,_IOFBF,16384);
		fseek(ind_f,sizeof(KENNUNG),SEEK_SET);

		if ((dat_f = fopen(dat_pfad,BINREAD)) == NULL)
		{
			fclose(ind_f);
			continue;
		}

		msg_nr = 0;
		while (fread(&ix,sizeof(INDEX),1,ind_f))
		{
			/* keine virt. xp-Referenzen eintragen */
			if (ix.flags & XP_REF)
			{
				msg_nr++;
				continue;
			}
			if (ftell(dat_f) != ix.pos)
				fseek(dat_f,ix.pos,SEEK_SET);
			fgets(key,sizeof(key),dat_f);
			if (ix.len < 1024)
				fread(buf,ix.len - strlen(key),1,dat_f);
			ref.grp_nr = (pm) ? (nr | 0x8000) : nr;
			ref.msg_nr = msg_nr;
			msgid_add(key+1,&ref);
			msg_nr++;
		}
		fclose(dat_f);
		fclose(ind_f);
	}
	printf("%d %s\r\n",i,(pm) ? "User" : "Gruppen");

	close_grplst();

	return TRUE;

} /* msgid_append */



/*
	ID Datenbank komplett neu erzeugen
*/
BOOLEAN msgid_create(void)
{
	char tmp[PATH_MAX];
	BOOLEAN ok = FALSE;

	strcpy(tmp,config.system);
	strcat(tmp,"id");
	if ((mdbh = dbm_open(tmp,O_CREAT | O_RDWR,0644)) == NULL)
	{
		puts("kann REF-DB nicht anlegen");
		return FALSE;
	}
	if (msgid_append(FALSE) && msgid_append(TRUE))
		ok = TRUE;
	dbm_close(mdbh);

	return ok;

} /* msgid_create */



/*
	todo:
	alle msgid_* Funktionen abhngig machen von:
	if (!config.verkettung || !config.dupe_chk)
*/
BOOLEAN msgid_init(void)
{
	char tmp[PATH_MAX];

	strcpy(tmp,config.system);
	strcat(tmp,"id");
	if ((mdbh = dbm_open(tmp,O_RDWR,0644)) == NULL)
	{
		if (!msgid_create()
		|| ((mdbh = dbm_open(tmp,O_RDWR,0644)) == NULL))
		{
			puts("kann REF-DB nicht ffnen/anlegen");
			return FALSE;
		}
	}

	atexit(msgid_exit);

	return TRUE;

} /* msgid_init */



/*
	ref-DB schlieen
*/
static void msgid_exit(void)
{
	if (mdbh)
		dbm_close(mdbh);

} /* msgid_exit */



/*
	ref-ID-Datensatz in ref-DB aufnehmen

	->			id			:	ID-Text, darf opt. auf \r\n, \r bzw. \n enden
				ref		:	enthlt Gruppen- und Messagenummer

	ein Datensatz besteht aus:
	key:
	- ID-Text
	value:
	- Gruppennummer in Hex (verodert mit 0x8000 bei PMs)
	- Messagenummer innerhalb der Gruppe/User-DB in Hex
	Die beiden Eintrge sind durch ein Leerzeichen getrennt.

	Problem:
	- es knnten mehrere Prozesse gleichzeitig Daten eintragen wollen.
	Lsungen:
	a) Semaphore
	b) (falls mglich) Kommunikation zur ref-DB via Scheduler
		(eigentlich laufen Funktionen wie Import etc. ja IM Server, von 
		dem der Scheduler ja ein Teil ist, ab, doch warum nicht mit sich 
		selbst connect'en ?)
*/
void msgid_add(const char *id,GLOBAL_REF *ref)
{
	char tmp[MAX_HDR];
	datum k,v;

	NormID(tmp,id);
	k.dptr  = tmp;
	k.dsize = strcspn(tmp,"\r\n");
	v.dptr  = (char *) ref;
	v.dsize = sizeof(GLOBAL_REF);
	dbm_store(mdbh,k,v,DBM_INSERT);
	if (dbm_error(mdbh))
	{
		fputs("Fehler beim ID-Einfgen\n",stderr);
		dbm_clearerr(mdbh);
	}
} /* msgid_add */



/*
	ref-ID-Datensatz in ref-DB suchen

	->			id			:	ID-Text, opt. mit \r\n
			<-	ref		:	liefert bei Erfolg Gruppen- und Messagenummer

	<-			TRUE		:	Datensatz gefunden, Rckgabe in ref
				FALSE		:	Datensatz nicht gefunden

	ref kann auch NULL sein, wenn User/Gruppe und Message nicht interessieren.
*/
BOOLEAN msgid_find(const char *id,GLOBAL_REF *ref)
{
	char tmp[MAX_HDR];
	datum k,v;

	NormID(tmp,id);
	k.dptr = tmp;
	k.dsize = strcspn(tmp,"\r\n");
	v = dbm_fetch(mdbh,k);
#ifdef USE_NDBM
	if (v.dptr==NULL)
#else
	if (!memcmp(&v,&nullitem,sizeof(nullitem)))
#endif
		return FALSE;
	if (ref)
	{
#if 1
		GLOBAL_REF aligned;
		memcpy(&aligned,v.dptr,sizeof(GLOBAL_REF));
		ref->grp_nr = aligned.grp_nr;
		ref->msg_nr = aligned.msg_nr;
#else
		ref->msg_nr = ((GLOBAL_REF *) v.dptr)->msg_nr;
		ref->grp_nr = ((GLOBAL_REF *) v.dptr)->grp_nr;
#endif
	}
	return TRUE;

} /* msgid_find */



/*
	ref-ID-Datensatz in ref-DB ndern

	->			id			:	ID-Text, opt. mit \r\n
				neu		:	neuer ref-ID-Datensatz
*/
void msgid_change(const char *id,GLOBAL_REF *neu)
{
	char tmp[MAX_HDR];
	datum k,v;

	NormID(tmp,id);
	k.dptr  = tmp;
	k.dsize = strcspn(tmp,"\r\n");
	v.dptr  = (char *) neu;
	v.dsize = sizeof(GLOBAL_REF);
	dbm_store(mdbh,k,v,DBM_REPLACE);

} /* msgid_change */



/*
	ref-ID-Datensatz in ref-DB lschen

	->			id			:	zu lschende ID, opt. mit \r\n
*/
void msgid_delete(const char *id)
{
	char tmp[MAX_HDR];
	datum k;

	NormID(tmp,id);
	k.dptr  = tmp;
	k.dsize = strcspn(tmp,"\r\n");
	dbm_delete(mdbh,k);

} /* msgid_change */



/*
	globale ID-Suche

	->			id			:	zu suchender ID-String (darf auf \r\n enden)
			<-	grname	:	Name der Gruppe, die die Nachricht enthlt bzw. NULL
			<-	usname	:	Name des Absenders der Nachricht bzw. NULL
			<-	autor		:	Autor der Nachricht an usname bzw. NULL
	<-			TRUE		:	ID gefunden, ggf. grname/usname/autor initialisiert
				FALSE		:	ID nicht gefunden
*/
BOOLEAN msgid_find_infos(const char *id,char *grname,char *usname,char *autor)
{
	static pid_t pid = 0;

	GLOBAL_REF gref;
	char tmp[MAX_CPG];
	BOOLEAN pm;
	int gh;
	char *v;

	if (grname)
		*grname = 0;
	if (usname)
		*usname = 0;
	if (autor)
		*autor = 0;

	if (!msgid_find(id,&gref))
		return FALSE;

	pm = (gref.grp_nr & 0x8000) != 0;
	gref.grp_nr &= 0x7fff;

	/* Gruppen- bzw. Usernamen ermitteln */
	if (!gruppen_nr2name(gref.grp_nr,pm,tmp))
		return FALSE;

	/* nur User- oder Gruppenname gefragt ? */
	if (pm && usname)
		strcpy(usname,tmp);
	else
	if (!pm && grname)
		strcpy(grname,tmp);

	if (!autor)
		return TRUE;

	/*
		nun ist der Name des Autors der referenzierten Mail gefragt, z.B. 
		um festzustellen (fr die Box), da ein Status auch vom richtigen 
		Absender ist, nmlich dem, der die Mail an usname geschrieben hat.
		Oder da ein User seine eigene ffentliche Msg. lschen darf.
	*/

	if (!pid)
		pid = getpid();

	/* Gruppen-lokale Suche und ID-Textvergleich */
	if (!gruppen_nr2name(gref.grp_nr,pm,tmp))
		return FALSE;
	if ((gh = group_open(pid,tmp,pm,FALSE)) < 0)
		return FALSE;

	/* Absendername zur angegebenen Nachricht ermitteln */
	if (index_goto(gh,gref.msg_nr) && msg_read_header(gh))
	{
		size_t vlen;

		v = msg[gh]->puffer + msg[gh]->ix.t_author;
		vlen = strcspn(v,"\r\n");
		strncpy(autor,v,vlen);
		autor[vlen] = 0;
	}
	else
	{
		group_close(gh,pid);
		puts("kein Autor zu ermitteln");
		return FALSE;
	}
	group_close(gh,pid);

	return TRUE;

} /* msg_find_infos */



/*
	Message-IDs einer Gruppe exportieren

	->			name	:	Gruppen/Username
				pm		:	TRUE = User
				datei	:	Datei, in die die IDs geschrieben werden sollen

	<-			TRUE	:	ok
				FALSE	:	Fehler (keine Gruppe/User bzw. <datei> nicht zu ffnen)

	Wichtig:
	Die IDs werden in keiner bestimmten Reihenfolge exportiert, schon gar 
	nicht chronologisch.
*/
BOOLEAN msgid_export(const char *name,BOOLEAN pm,const char *datei)
{
	datum key,val;
	long grp_nr,vgl;
	FILE *lst_f;

	if ((grp_nr = group_path(name,NULL,pm)) < 0)
		return FALSE;

	if ((lst_f = fopen(datei,"w")) == NULL)
		return FALSE;

	for (key = dbm_firstkey(mdbh); key.dptr != NULL; key = dbm_nextkey(mdbh))
	{
		GLOBAL_REF aligned;
		val = dbm_fetch(mdbh,key);
#ifdef USE_NDBM
		if (val.dptr==NULL)
#else
		if (!memcmp(&val,&nullitem,sizeof(nullitem)))
#endif
			continue;
		memcpy(&aligned,val.dptr,sizeof(GLOBAL_REF));
		vgl = aligned.grp_nr;
		if (pm && !(vgl & 0x8000))
			continue;
		vgl &= 0x7fff;
		if ((vgl & 0x7fff) != grp_nr)
			continue;

		fprintf(lst_f,"%.*s\r\n",key.dsize,key.dptr);
	}

	fclose(lst_f);

	return TRUE;

} /* msgid_export */



/*
	smtliche IDs exportieren
*/
BOOLEAN msgid_export_all(const char *datei)
{
	FILE *lst_f;
	datum key,val;

	if ((lst_f = fopen(datei,"w")) == NULL)
		return FALSE;

	for (key = dbm_firstkey(mdbh); key.dptr != NULL; key = dbm_nextkey(mdbh))
	{
		val = dbm_fetch(mdbh,key);
#ifdef USE_NDBM
		if (val.dptr==NULL)
#else
		if (!memcmp(&val,&nullitem,sizeof(nullitem)))
#endif
		{
			puts("kein (gltiges) Datum beim ID-Export");
			continue;
		}
		fprintf(lst_f,"%.*s\r\n",key.dsize,key.dptr); 
	}
	fclose(lst_f);

	return TRUE;

} /* msgid_export_all */



/*
	Msg. mit angegeber ID zum lschen markieren
	(auch crosspostings)

	->			id		:	ID, optional mit \r\n

	->			TRUE	:	Nachricht (bereits) lschmarkiert
				FALSE	:	Nachricht nicht gefunden etc.
*/
BOOLEAN mdb_kill_article(const char *id)
{
	char name[MAX_CPG];
	GLOBAL_REF ref;
	BOOLEAN pm;
	BOOLEAN xp;
	int gh;					/* Gruppen-Handle */
	pid_t pid;				/* akt. Proze-ID */
	char *h = NULL;		/* Header-Puffer, keep gcc happy */
	CRC author_crc = 0;	/* keep gcc happy */

	if (!msgid_find(id,&ref))
		return FALSE;

	pm = (ref.grp_nr & 0x8000) != 0;

	/* Gruppen- bzw. Usernamen ermitteln */
	if (!gruppen_nr2name(ref.grp_nr & 0x7fff,pm,name))
		return FALSE;

	pid = getpid();

	if ((gh = group_open(pid,name,pm,TRUE)) < 0)
		return FALSE;

	if (!index_goto(gh,ref.msg_nr) || !index_read(gh))
	{
		group_close(gh,pid);
		return FALSE;
	}

	(void) msg_set_flag(gh,TOTAL);

	xp = (msg_get_flag(gh) & XP) != 0;

	if (xp)
	{
		msg_read_header(gh);
		h = strdup(msg[gh]->puffer);
		author_crc = msg[gh]->ix.author_crc;
	}

	group_close(gh,pid);

	if (xp)
	{
		size_t len;			/* Gruppennamenlnge */
		size_t len_a;		/* Lnge der Such-ID */
		size_t len_b;		/* Lnge der Vergleichs-ID */
		char *p = h;

		if (!h)
			return FALSE;

		len_a = strcspn(h+1,"\r\n");

		while ((p = strstr(p,"\nG")) != NULL)
		{
			len = strcspn(p+2,"\r\n");
			strncpy(name,p+2,len);
			name[len] = 0;
#ifdef DEBUG
			printf("Gruppe: %s\r\n",name);
#endif
			p += 2 + len;

			/*
				nicht ex. Gruppe sind kein Fehler, denn bei xp's 
				wird ja allenfalls die erste Gruppe angelegt
			*/
			if ((gh = group_open(pid,name,pm,TRUE)) >= 0)
			{
				/* jetzt beginnt eine aufwendige ID-Suche */
				while (index_read(gh))
				{
					/* Verschnellerung durch sinnvolle Index-Vergleiche */
					if ((msg_get_flag(gh) & XP)
					&& (author_crc == msg[gh]->ix.author_crc))
					{
						msg_read_header(gh);
						len_b = strcspn(msg[gh]->puffer+1,"\r\n");
						if ((len_a == len_b) && !strncmp(msg[gh]->puffer+1,h+1,len_a))
						{
							(void) msg_set_flag(gh,TOTAL);
							break;
						}
					}
					if (!index_next(gh))
						break;
				}
				group_close(gh,pid);
			}
		}
		free(h);
	}

	return TRUE;

} /* mdb_kill_article */
