/* fehler.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB3 (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Offline - MausTausch-FrontEnd

	Fehler- und allgemeine Meldungen
	(c) 1992-94 bei Frank Baumgart

	begonnen am 23.04.1992
	Version vom 18.10.1994
*/


#include "portab.h"
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <limits.h>

#include "system.h"
#include "struktur.h"
#include "mdb_conf.h"
#include "mdb/mdb_intr.h"			/* nur wg. protokoll_* */
#include "screen/io.h"
#include "fehler.h"



extern CONFIG config;				/* globale Einstellungen (Verkettung...) */



static FILE *prot = NULL;

static struct
{
	const int nr;
	const BOOLEAN wait;
	const char *text;
}
meldung[] =
{
	{ GRP_UNUSED,	TRUE,	"???" },
	{ NO_GROUP,		TRUE,	"Gruppe nicht vorhanden" },
	{ IND_OPEN,		TRUE,	"kann Indexdatei nicht ffnen" },
	{ DAT_OPEN,		TRUE,	"kann Datendatei nicht ffnen" },
	{ IND_CREATE,	TRUE,	"kann Indexdatei nicht anlegen" },
	{ DAT_CREATE,	TRUE,	"kann Datendatei nicht anlegen" },
	{ NO_CREATE,	TRUE,	"Fehler beim Anlegen der Datei" },
	{ EXEC_ERR,		TRUE,	"Fehler bei Programmausfhrung" },
	{ NO_MSGS,		FALSE,"Gruppe enthlt keine Nachrichten" },
	{ NO_MEMORY,	TRUE,	"zuwenig RAM" },
	{ MEM_ERR,		TRUE,	"Puffergrenzen berschritten" },
	{ READ_ERR,		TRUE,	"Fehler beim Einlesen der Daten" },
	{ WRT_DAT,		TRUE,	"import: Fehler beim Schreiben in Datendatei" },
	{ WRT_IND,		TRUE,	"import: Fehler beim Schreiben in Indexdatei" },
	{ OUT_OPEN,		TRUE,	"import: kann Outfile nicht ffnen" },
	{ WRT_BACK,		TRUE,	"puffer: kann Indexdaten nicht zurckschreiben" },
	{ ILL_HDR,		FALSE,"import: ungltige Headerzeilenkombination" },
	{ INF_CREATE,	TRUE,	"kann Infile nicht anlegen" },
	{ NO_SHELL,		TRUE,	"keine Shell vorhanden" },
	{ NO_PRINT,		TRUE,	"\"Print\" Variable im CNF nicht gesetzt" },
	{ ILL_IND,		TRUE,	"ungltige Indexdaten" },
	{ NO_TMP,		FALSE,"kann temporre Datei nicht anlegen" },
	{ NO_PUTZ,		FALSE,"Putzfehler: kein Datenverlust, evtl. Verlust der Verkettung" },
	{ NO_INFILE,	TRUE,	"kann Infile nicht ffnen" },
	{ NO_EXPFILE,	TRUE,	"kann Exportdatei nicht anlegen" },
	{ ILL_OUTFILE,	TRUE,	"ungltiges Outfile" },
	{ DUP_GROUP,	TRUE,	"Gruppe mit dem Zielnamen existiert bereits" },
	{ NO_SPACE,		TRUE,	"zuwenig externer Speicher" },
	{ NO_GRPLST,	TRUE,	"kann keine Gruppenlistendatei anlegen" },
	{ NO_USRLST,	TRUE,	"kann keine Userlistendatei anlegen" },
	{ REF_APPEND,	TRUE,	"kann Referenzdatei nicht anlegen/erweitern" },
};



/*
	Fehlermeldung ausgeben
	und je nach Fehler auf Tastendruck warten

	->			nummer	:	Fehlernummer
*/
void fehler(int nummer)
{
#ifdef TEXT_FRONTEND
	fputs(meldung[nummer].text,stderr);
	fputs("\r\n",stderr);
#endif
	protokoll(meldung[nummer].text);
	protokoll("\n");
	protokoll_schliessen();

	/* auf Tastendruck warten ? */
#if defined(TEXT_FRONTEND) && !defined(BOX)
	if (meldung[nummer].wait)
		taste();
#endif

} /* fehler */



/*
	String in Protokolldatei bernehmen

	->			text	:	String fr die Protokolldatei
							bzw. NULL fr Protokolldatei schlieen
*/
void protokoll(const char *text)
{
	char pfad[PATH_MAX];

	/* Protokolldatei schlieen ? */
	if (text == NULL)
	{
		if (prot)
			protokoll_schliessen();

		return;
	}

	/* Protokolldatei noch nicht erffnet ? */
	if (!prot)
	{
		time_t zeit;

		strcpy(pfad,config.log);
		strcat(pfad,"Logfile");
		prot = fopen(pfad,"a+");
		time(&zeit);
		if (prot)  fputs(ctime(&zeit),prot);
	}

	if (prot)  fputs(text,prot);

} /* protokoll */



/*
	Protokolldatei schlieen
*/
void protokoll_schliessen(void)
{
	if (prot)
	{
		fclose(prot);
		prot = NULL;
	}
} /* protokoll_schliessen */
