/* struktur.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
/*
	Datenformate

	(c) Frank Baumgart

	Stand: 20.01.1994
*/


#if !defined(DB_STRUCT)
#define DB_STRUCT

#include <time.h>

#include "mdb_defs.h"
#include "kennung.h"



/*
	Aufbau des Indexfeldes zu jeder Message
*/
typedef struct
{
	CRC unused1;				/* war: 32 Bit CRC ber gesamte Msg. */
	CRC id_crc;				/* 32 Bit CRC ber Msg.ID (wg. "Monster"-IDs) */
	CRC author_crc;		/* dito ber Namen des Autors */
	CRC topic_crc;			/* dito ber Titel */
	size_t len;				/* Lnge des Messagetextes */
	long pos;				/* Startposition desselben in der Datenbank */
	UWORD t_author;		/* Offset zum Absender vom Msg.anfang */
	UWORD t_topic;			/* Offset zum Betreff, dito */
	UWORD t_text;			/* Offset zum Text, dito */
	UWORD t_status;		/* Offset zur Statuszeile (fr FE-Statusex/import) */
	UWORD zeilen;			/* Anzahl Textzeilen */
	UWORD max_col;			/* Lnge der lngsten Textzeile */
	time_t zeit;			/* Zeitpunkt des Imports der Msg. */
	time_t eingabe;		/* Zeitpunkt der Eingabe der Msg. */
	time_t bearbeit;		/* Zeitpunkt der Bearbeitung der Msg. */
	time_t expire;			/* Zeitpunkt zum Lschen der Msg. */
	time_t getauscht;		/* Zeitpunkt des Tausches der Msg. bei PMs */
	ULONG flags;			/* diverse Flags (TOTAL, GESCHUETZT, etc.) */
	ULONG header;			/* Flags fr besetzte Headerfelder */
	UWORD status;			/* Bearbeitungsstatus (GELESEN, etc.) */
	UWORD unused2;				/* war: Anzahl Zugriffe auf diese Nachricht */
	UWORD kommentare;		/* Anzahl Kommentare */
/* ^^^^^ besser: MESSAGE, aber Seiteneffekte beachten ! */
	MESSAGE oben;			/* Index der kommentierten Msg. */
	MESSAGE unten;			/* Index des ersten Kommentars */
	MESSAGE letzter;		/* Index des letzten Kommentars */
	MESSAGE links;			/* Index vorangehender Nachricht selber Ebene */
	MESSAGE rechts;		/* Index nachfolgender     "       "      "   */
	CRC unused3;				/* war: von_msg, ID-CRC der Nachricht der Vorgngergruppe */
	CRC zu_msg;				/* ID-CRC der Nachricht der Nachfolgegruppe */

} INDEX;



/*
	Indexdatei-Makros
*/
#define get_index(p)		fread(p,(long)sizeof(INDEX),1,ind_f)
#define put_index(p)		fwrite(p,(long)sizeof(INDEX),1,ind_f)
#define fback()			fseek(ind_f, - (long)(sizeof(INDEX)),SEEK_CUR)
#define fgoto(i)			fseek(ind_f,(long)sizeof(KENNUNG) + (long)(i) * (long)sizeof(INDEX),SEEK_SET)
#define akt_msg()			((ftell(ind_f)-sizeof(KENNUNG))/sizeof(INDEX))

#endif
