/* owrite_cmdl.c : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include <string.h>

#if defined(HPUX)
#include <sys/pstat.h>
#endif  /* defined(HPUX) */

#include "owrite_cmdl.h"

#if !defined(HPUX)
static char *cmdline_start;
static char *cmdline_end;
#endif

void 
cmdline_save_param(int argc,char **argv)
{
#if !defined(HPUX)
    cmdline_start = argv[0];
	cmdline_end = argv[argc - 1] + strlen(argv[argc - 1]) - 1;
#endif
}

/*
**  Overwrite the original argv so that ps will show what's going on.
*/
void
cmdline_overwrite(const char *what)
{
#if !defined(HPUX)
    char   *p;
	int    l;
	int    place;
	int    klammer=0;
	
	l = strlen(what);
	place=cmdline_end - cmdline_start + 1;

	p = cmdline_start;
	if (l+2<place)
	{
		*p++ = '(';
		place--;
		klammer=1;
	}
	
	if (l >= place) {
		l = place;
	}
	(void)memcpy(p, what,l);
	p+=l;
	place-=l;
	if (klammer)
	{
		*p++=')';
		place--;
	}
	while (place>0)
	{
		*p++ = ' ';
		place--;
	}
	*p=0;
#else
    char        buff[BUFSIZ];

	union pstun un;
	(void)sprintf(buff, "(tom) %s", what);
	(void)pstat(PSTAT_SETCMD, un, strlen(buff), 0, 0);
#endif  /* defined(HPUX) */
}
