/* protokoll.h : still no description */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#ifndef PROTOKOLL_H
#define PROTOKOLL_H

#include "aktdata.h"

/* 
	Format der Protokolldatei:
	Defines fr die Position der jeweiligen Werte
012345678901234567890123456789012345678901234567890123456789012345678901234567
          1         2         3         4         5         6         7
E 25    Systemputz                   02:05 02:10  00:05:00    <freier String>
123456 $johannes goettker-schnetmann 01:00 02:00  01:00:00  1 2400  TBCN   WO?
                                                         PRO_OFFSET_ZULETZT^
                                                   PROT_OFFSET_FLAGS^
                                           PROT_OFFSET_CONNECT^
                                                           ^PROT_OFFSET_PORT
                                                  ^PROT_OFFSET_DAUER
                                           ^PROT_OFFSET_END
                                     ^PROT_OFFSET_START
        ^PROT_OFFSET_NAME
       ^PROT_OFFSET_DOLLAR
^POS_OFFSET_ANRUF

Es gibt mehrere mgliche Formen von "Anrufzahlen":
- die eine ist eine Zahl, eventuell mit Leerstellen davor. Es handelt sich
  hierbei um einen User. Nur fr diesen Fall sind die Daten ab "Connect"
  vorgeschrieben.
- die zweite beginnt mit einem Buchstaben, in dem Fall handelt es sich um
  ein anderes Ereignis. Zur Zeit definiert:
  EVnnnn Event Nummer nnnn
  Start  Start der Box. "Endzeit" ist leer.
  Ende   Ende der Box. "Startzeit" ist leer.
- eine fr zuknftige Erweiterungen reservierte Form ist die mit einem
  Minuszeichen beginnende. Sie steht fr Fortsetzungszeilen.
*/
#define PROT_OFFSET_ANRUF	0
#define PROT_OFFSET_DOLLAR	7
#define PROT_OFFSET_NAME    8
#define PROT_OFFSET_START  37
#define PROT_OFFSET_END    43
#define PROT_OFFSET_DAUER  50
#define PROT_OFFSET_PORT   59
#define PROT_OFFSET_CONNECT	62
#define PROT_OFFSET_FLAGS	68
#define PROT_OFFSET_ZULETZT 75

	/* Schreibt einen Protokolleintrag */
void login_protokoll_write(void);


#endif
