/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>

#include "prototyp.h"
#include "user.h"
#include "modem.h"
#include "md5file.h"
#include "box_conf.h"
#include "tompaths.h"

extern USER user;

BOOLEAN 
passwort_aenderung(USER *work, BOOLEAN *leer)
{
	BOOLEAN ret;
	char vergleich[UDAT_PW_LEN];
	char neu[UDAT_PW_LEN];

	*neu='\0';
	*leer=FALSE;

	ret=FALSE;

	/* Vorsichtshalber nach dem Passwort fragen - auer beim ersten Mal 
	 * == Userantrag und beim Editieren anderer User (aus dem Usereditor) 
	 */
	userglocke();
	set_status_line("Pawort ndern:");
	userglocke();

	if (*work->passwort && (user.nummer==work->nummer))
	{
		mbquestion(15,4,TRUE," >> Bitte altes Pawort eingeben : ","",vergleich);
		if (!*vergleich)
		{
			*leer=TRUE;
			goto cleanup;
		}
		if (!passwort_vergleich(work,vergleich))
		{
			mbfehler("Falsches Pawort - Abbruch");
			goto cleanup;
		}
	}

	if (*work->passwort)
		mbquestion(15,4,TRUE," >> Bitte neues Pawort eingeben : ","",neu);
	else
		mbquestion(15,4,TRUE," >> Bitte Pawort eingeben       : ","",neu);
	if (!*neu)
	{
		*leer=TRUE;
		goto cleanup;
	}
	if (strlen(neu)<6)
	{
		mbfehler("Pawort mu mindestens 6 Zeichen lang sein");
		goto cleanup;
	}

	mbquestion(15,4,TRUE," >> Bitte zur Kontrolle nochmal   : ","",vergleich);
	if (!*vergleich)
	{
		*leer=TRUE;
		goto cleanup;
	}
	if (stricmp(vergleich,neu))
	{
		mbfehler("Pawrter nicht identisch - altes Pawort wird beibehalten");
		goto cleanup;
	}

	/* Mistpasswort soll meckern */
	if (!mistpasswort(work,neu,TRUE))
	{
		passwort_crypt(work->passwort,neu,work->nummer,PW_MD5);
		work->passwortdatum=time(NULL);
		work->pw_encoding=PW_MD5;
		ret=TRUE;
	}

cleanup:
	memset(vergleich,0,sizeof(vergleich));
	memset(neu,0,sizeof(neu));
	return ret;
}
