#ifndef QUARKOUTFILE_INTERN_H
#define QUARKOUTFILE_INTERN_H


typedef struct grpconv_struct {
		char *longname;
		char *shortname;
		BOOLEAN import_flag;	/* Gruppe ins MausNet importieren? */
		struct grpconv_struct *next;
} grpconv_t;

grpconv_t *find_shortname(unsigned char *sname);
grpconv_t *find_longname(unsigned char *lname);
void grp_einfuegen(unsigned char *shortname, unsigned char *longname,
				   BOOLEAN imp);
void lade_grplist(const char *fname);
void speichere_grplist(const char *fname);

const char *get_boxkuerzel(const char *dom);
BOOLEAN mask_as_fremdbox(const char *kuerzel); 
void lade_boxlist(const char *fname, const char *me, const char *maus);

void generate_bounces(FILE * out, char *flameadressen);
void add_bounceinfo(const char *mausid, const char *realid,
	   const char *gruppe, const char *empfaenger, const char *absender);
void merke_bounce(const char *mausid, const char *fehler);
void create_bouncefile(const char *bouncefile);
void load_bouncefiles(char *bouncefile);
void close_bouncefile(void);

extern const char *program_name;
extern const char *mailer_daemon;
extern const char *sysop_adresse;
extern const char *mysite;

#endif
