/* read_date.c : read a date from the user */
/*
    Copyright (C) 1998 Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@ohse.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/

#include <portab.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "prototyp.h"
#include "modem.h"
#include "user.h"

extern USER user;

time_t 
mb_read_date(time_t vgl)
{
	char datum[128];
	char input[128];
	struct tm tm;
	time_t t;
	time(&t);
	tm=*localtime(&t);
	time_t_to_mtzeit(vgl ? & vgl : &user.letzter_login,datum);
	mbquestion(2,2,TRUE," >> Tag    (TT): ",datum+6,input);
	if (!*input)
		return 0;
	tm.tm_mday = atoi(input);
	mbquestion(2,2,TRUE," >> Monat  (MM): ",datum+4,input);
	if (!*input)
		return 0;
	tm.tm_mon = atoi(input)-1; /* 0..11 */
	mbquestion(4,2,TRUE," >> Jahr   ([JJ]JJ): ",datum,input);
	if (!*input)
		return 0;
	t = atoi(input);
	if (t>99)
		t-=1900;
	if (t<100) { /* y2k */
		if (tm.tm_year>=100)
			t+=100;
	}
	tm.tm_year = t;
	mbquestion(2,2,TRUE," >> Stunde (SS): ",datum+8,input);
	if (!*input)
		tm.tm_hour = 0;
	else
		tm.tm_hour = atoi(input);
	mbquestion(2,2,TRUE," >> Minute (MM): ",datum+10,input);
	if (!*input)
		tm.tm_min = 0;
	else
		tm.tm_min = atoi(input);
	return mktime(&tm);
}

