/* strhalfcasecmp: strcasecmp optimized for lower case second string
   Copyright (C) 1995 1996 Uwe Ohse

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <ctype.h>

#include "libquark.h"

int 
strhalfcasecmp(const char *uplow, const char *low)
{
	register const unsigned char *p1 = (const unsigned char *) uplow;
	register const unsigned char *p2 = (const unsigned char *) low;
	register int ret;
	unsigned char c1;

	if (p1 == p2)
		return 0;

	for (; !(ret = (c1 = tolower(*p1)) - (*p2)); p1++, p2++)
		if (c1 == '\0') break;
	return ret;
}
