#line 1 "ta_mcmd.c4"
/* ta_mcmd.c4 : still no description  -*- C -*- */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#line 31 "ta_mcmd.c4"

/*
   Tausch: diverse Kommandos 
 */


#include <portab.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <syslog.h>
#include <ctype.h>

#include "tomsysdep.h"
#include "prototyp.h"
#include "aktdata.h"

#include "tausch.h"
#include "ta_int.h"
#include "ta_ext.h"
#include "ta_cmd.h"

static void ta_mcmd_maxlen (char *, const char *, LONG);
static void ta_mcmd_transferzeit (char *, const char *, LONG);
static void ta_mcmd_simpel (char *, const char *, LONG);
static void ta_mcmd_dupe (char *, const char *, LONG);
static void ta_mcmd_tauschdatum (char *, const char *, LONG);
static void ta_mcmd_tausch_brett (char *, const char *, LONG);

#define STRING2(x) #x
#define STRING(x) STRING2(x)

/*
 * M[0-9]* : Kommando zum Setzen der gewnschten Outfile-Maximalgre.
 */
#line 96

#line 96
ta_command_t ta_mcmd_desc_maxlen = {
#line 96
	/* Magic 1       */ "M",
#line 96
	/* Magic 2       */     "",
#line 96
	/* Funktionsname */     ta_mcmd_maxlen,
#line 96
	/* Min. Level    */     0,
#line 96
	/* Textpara      */     NULL,
#line 96
	/* Num. Parameter*/     0,
#line 96

#line 96
	/* ITK-ID-Nummer */     8,
#line 96
	/* Gruppierung   */     "T",
#line 96
	/* ITK-Version   */     0,
#line 96
	/* ITK-Typ       */     "K", 
#line 96
	/* ITK-Name      */     "Maximale Outfilegre", 
#line 96
	/* ITK-Beschrei. */ 
#line 96
	    
#line 96
    "Mit dieser Funktion knnen Sie die Maximalgre des Outfiles "
#line 96
	"festlegen. Sie wird von der Box aber erst nach dem Export der "
#line 96
	"Nachrichten beachtet."     
#line 96
	, 
#line 96

#line 96
	/* ITK-Syntaxdefinition*/
#line 96
	    
#line 96
    ":CM\r\n"
#line 96
    ":FI1,2147483647\r\n"
#line 96
    ":KMaximalgre\r\n"
#line 96
    ":LGegen Sie die Maximalgre des Outfiles ein\r\n"
#line 96
    
#line 96

#line 96
	,
#line 96

#line 96
	/* Verkettungsptr*/ NULL
#line 96
};
#line 96


static void
ta_mcmd_maxlen (char *cmd, 
	const char *dummy TOM_ATTRIB_UNUSED, 
	LONG dummy2 TOM_ATTRIB_UNUSED)
{
	ULONG mb;
	char *next;

	mb = strtoul (cmd + 1, &next, 10);
	if (next == cmd + 1)
	{
		ta_do_log_error ("Maximallaenge unverstndlich\r\n");
	}
	else
	{
		ta_passinfo.maxbytes = mb;
		ta_do_log (":! Maximallaenge %lu\r\n", mb);
	}
}

#line 147

#line 147
ta_command_t ta_mcmd_desc_oeff_crosspostings = {
#line 147
	/* Magic 1       */ "OC",
#line 147
	/* Magic 2       */     "",
#line 147
	/* Funktionsname */     ta_mcmd_simpel,
#line 147
	/* Min. Level    */     0,
#line 147
	/* Textpara      */     NULL,
#line 147
	/* Num. Parameter*/     0,
#line 147

#line 147
	/* ITK-ID-Nummer */     1200,
#line 147
	/* Gruppierung   */     "F",
#line 147
	/* ITK-Version   */     0,
#line 147
	/* ITK-Typ       */     "E", 
#line 147
	/* ITK-Name      */     "Crosspostings", 
#line 147
	/* ITK-Beschrei. */ 
#line 147
	    
#line 147
    "Mit dieser Funktion bestimmen Sie, ob die Box ihnen Crosspostings " 
#line 147
    "'richtig' (das heit: mit mehreren Gruppenangaben) oder auf eine "
#line 147
    "Gruppe verstmmelt senden soll. Viele ltere Frontends kommen mit "
#line 147
    "Crosspostings nicht klar!"     
#line 147
	, 
#line 147

#line 147
	/* ITK-Syntaxdefinition*/
#line 147
	    
#line 147
    ":COC\r\n"
#line 147
    ":KCrosspostings\r\n"
#line 147
    ":LLegen Sie fest, ob Sie Crosspostings erhalten wollen\r\n"
#line 147
    ":FA\r\n"
#line 147
    ":A+:-\r\n"
#line 147
    ":B'Richtig' senden\r\n"
#line 147
    
#line 147

#line 147
	,
#line 147

#line 147
	/* Verkettungsptr*/ NULL
#line 147
};
#line 147


#line 177

#line 177
ta_command_t ta_mcmd_desc_oe = {
#line 177
	/* Magic 1       */ "OE",
#line 177
	/* Magic 2       */     "",
#line 177
	/* Funktionsname */     ta_mcmd_simpel,
#line 177
	/* Min. Level    */     0,
#line 177
	/* Textpara      */     NULL,
#line 177
	/* Num. Parameter*/     0,
#line 177

#line 177
	/* ITK-ID-Nummer */     5,
#line 177
	/* Gruppierung   */     "F",
#line 177
	/* ITK-Version   */     0,
#line 177
	/* ITK-Typ       */     "K", 
#line 177
	/* ITK-Name      */     "Eigene ffentliche Mitteilungen zurcksenden", 
#line 177
	/* ITK-Beschrei. */ 
#line 177
	    
#line 177
    "Hier knnen Sie festlegen, ob Sie Ihre selbstgeschriebenen "
#line 177
    "ffentlichen Nachrichten von der Box zurckgesandt bekommen "
#line 177
    "mchten."     
#line 177
	, 
#line 177

#line 177
	/* ITK-Syntaxdefinition*/
#line 177
	    
#line 177
    ":FA\r\n"
#line 177
    ":KMitteilungsecho\r\n"
#line 177
    ":LWhlen Sie, ob sie ihre eigenen ffentlichen Nachrichten\r\n"
#line 177
    ":Lzurckerhalten wollen.\r\n"
#line 177
    ":A:OE\r\n"
#line 177
    ":Bzurckschicken\r\n"
#line 177
    
#line 177

#line 177
	,
#line 177

#line 177
	/* Verkettungsptr*/ NULL
#line 177
};
#line 177

#line 205

#line 205
ta_command_t ta_mcmd_desc_on = {
#line 205
	/* Magic 1       */ "ON",
#line 205
	/* Magic 2       */     "",
#line 205
	/* Funktionsname */     ta_mcmd_simpel,
#line 205
	/* Min. Level    */     0,
#line 205
	/* Textpara      */     NULL,
#line 205
	/* Num. Parameter*/     0,
#line 205

#line 205
	/* ITK-ID-Nummer */     4,
#line 205
	/* Gruppierung   */     "F",
#line 205
	/* ITK-Version   */     0,
#line 205
	/* ITK-Typ       */     "K", 
#line 205
	/* ITK-Name      */     "ffentliche Nachrichten anfordern", 
#line 205
	/* ITK-Beschrei. */ 
#line 205
	    
#line 205
    "Mit dieser Funktion knnen Sie bestimmen, ob die Box Ihnen ffentliche " 
#line 205
    "Nachrichten in den bestellten Gruppen senden soll. Sie schalten auch "
#line 205
    "das Senden persnlicher Nachrichten mit ein."     
#line 205
	, 
#line 205

#line 205
	/* ITK-Syntaxdefinition*/
#line 205
	    
#line 205
    ":FA\r\n"
#line 205
    ":KMitteilungen anfordern\r\n"
#line 205
	":LWhlen Sie, ob Sie Mitteilungen aus den abonnierten Gruppen erhalten wollen.\r\n"
#line 205
    ":AON:\r\n"
#line 205
    ":Bffentliche Mitteilungen anfordern\r\n"
#line 205
    
#line 205

#line 205
	,
#line 205

#line 205
	/* Verkettungsptr*/ NULL
#line 205
};
#line 205


#line 238

#line 238
ta_command_t ta_mcmd_desc_pn = {
#line 238
	/* Magic 1       */ "PN",
#line 238
	/* Magic 2       */     "PA",
#line 238
	/* Funktionsname */     ta_mcmd_simpel,
#line 238
	/* Min. Level    */     0,
#line 238
	/* Textpara      */     NULL,
#line 238
	/* Num. Parameter*/     0,
#line 238

#line 238
	/* ITK-ID-Nummer */     1,
#line 238
	/* Gruppierung   */     "F",
#line 238
	/* ITK-Version   */     0,
#line 238
	/* ITK-Typ       */     "K", 
#line 238
	/* ITK-Name      */     "Persnliche Nachrichten anfordern", 
#line 238
	/* ITK-Beschrei. */ 
#line 238
	    
#line 238
	"Mit dieser Funktion stellen Sie ein, ob Ihnen bereitliegende neue "
#line 238
	"persnliche Mitteilungen gesendet werden sollen. "     
#line 238
	, 
#line 238

#line 238
	/* ITK-Syntaxdefinition*/
#line 238
	    
#line 238
    ":FA\r\n"
#line 238
    ":KUmfang\r\n"
#line 238
    ":LWhlen Sie, ob Sie alle noch vorhandenen oder nur neue persnliche\r\n"
#line 238
    ":LNachrichten erhalten wollen.\r\n"
#line 238
    ":APN\r\n"
#line 238
    ":Bneue Mitteilungen\r\n"
#line 238
    ":APA\r\n"
#line 238
    ":Balle vorhandenen Nachrichten\r\n"
#line 238
    ":A\r\n"
#line 238
    ":Bkeine persnlichen Nachrichten\r\n"
#line 238
    
#line 238

#line 238
	,
#line 238

#line 238
	/* Verkettungsptr*/ NULL
#line 238
};
#line 238


#line 267

#line 267
ta_command_t ta_mcmd_desc_pe = {
#line 267
	/* Magic 1       */ "PE",
#line 267
	/* Magic 2       */     "",
#line 267
	/* Funktionsname */     ta_mcmd_simpel,
#line 267
	/* Min. Level    */     0,
#line 267
	/* Textpara      */     NULL,
#line 267
	/* Num. Parameter*/     0,
#line 267

#line 267
	/* ITK-ID-Nummer */     2,
#line 267
	/* Gruppierung   */     "F",
#line 267
	/* ITK-Version   */     0,
#line 267
	/* ITK-Typ       */     "K", 
#line 267
	/* ITK-Name      */     "Eigene persnliche Nachrichten zurcksenden", 
#line 267
	/* ITK-Beschrei. */ 
#line 267
	    
#line 267
    "Hiermit legen Sie fest, ob Sie eine Kopie der von ihnen selbst "
#line 267
    "geschriebenen Nachrichten von der Box zurckerhalten mchten."     
#line 267
	, 
#line 267

#line 267
	/* ITK-Syntaxdefinition*/
#line 267
	    
#line 267
    ":FA\r\n"
#line 267
    ":KMitteilungsecho\r\n"
#line 267
	":LWhlen Sie, ob sie Ihre eigenen persnlichen Nachrichten\r\n"
#line 267
	":Lzurckerhalten wollen.\r\n"
#line 267
    ":APE:\r\n"
#line 267
    ":BEigene PMs zurckschicken\r\n"
#line 267
    
#line 267

#line 267
	,
#line 267

#line 267
	/* Verkettungsptr*/ NULL
#line 267
};
#line 267


#line 299

#line 299
ta_command_t ta_mcmd_desc_ps = {
#line 299
	/* Magic 1       */ "PS",
#line 299
	/* Magic 2       */     "",
#line 299
	/* Funktionsname */     ta_mcmd_simpel,
#line 299
	/* Min. Level    */     0,
#line 299
	/* Textpara      */     NULL,
#line 299
	/* Num. Parameter*/     0,
#line 299

#line 299
	/* ITK-ID-Nummer */     3,
#line 299
	/* Gruppierung   */     "F",
#line 299
	/* ITK-Version   */     0,
#line 299
	/* ITK-Typ       */     "K", 
#line 299
	/* ITK-Name      */     "PM-Status anfordern", 
#line 299
	/* ITK-Beschrei. */ 
#line 299
	    
#line 299
    "Stellen Sie ein, in welchem Umfang Sie Statusinformationen erhalten " 
#line 299
    "wollen."     
#line 299
	, 
#line 299

#line 299
	/* ITK-Syntaxdefinition*/
#line 299
	    
#line 299
    ":FA\r\n"
#line 299
    ":KWelche Status\r\n"
#line 299
    ":LWhlen Sie, wieviele Statusmitteilungen Sie erhalten wollen.\r\n"
#line 299
    ":APSA\r\n"
#line 299
    ":Balle vorhandenen\r\n"
#line 299
    ":APSN\r\n"
#line 299
    ":Bnur genderte\r\n"
#line 299
    ":A\r\n"
#line 299
    ":Bkeine\r\n"
#line 299
    
#line 299

#line 299
	,
#line 299

#line 299
	/* Verkettungsptr*/ NULL
#line 299
};
#line 299



#line 329

#line 329
ta_command_t ta_mcmd_desc_ts  = {
#line 329
	/* Magic 1       */ "TS",
#line 329
	/* Magic 2       */     "",
#line 329
	/* Funktionsname */     ta_mcmd_simpel,
#line 329
	/* Min. Level    */     0,
#line 329
	/* Textpara      */     NULL,
#line 329
	/* Num. Parameter*/     0,
#line 329

#line 329
	/* ITK-ID-Nummer */     7,
#line 329
	/* Gruppierung   */     "F",
#line 329
	/* ITK-Version   */     0,
#line 329
	/* ITK-Typ       */     "K", 
#line 329
	/* ITK-Name      */     "Erweiterte Features", 
#line 329
	/* ITK-Beschrei. */ 
#line 329
	    
#line 329
	"Legen Sie fest, ob Ihr Frontend darauf vorbereitet ist, neue Angaben im " 
#line 329
	"Outfile zu verarbeiten, die gegebenenfalls neuer sind als die verwendete "
#line 329
	"Version des Frontends selber."     
#line 329
	, 
#line 329

#line 329
	/* ITK-Syntaxdefinition*/
#line 329
	    
#line 329
    ":FA\r\n"
#line 329
    ":KFeatures\r\n"
#line 329
    ":LWhlen Sie, ob sie die erweitertern Angaben einschalten wollen.\r\n"
#line 329
    ":ATS:\r\n"
#line 329
    ":Beinschalten\r\n"
#line 329
    
#line 329

#line 329
	,
#line 329

#line 329
	/* Verkettungsptr*/ NULL
#line 329
};
#line 329

static void
ta_mcmd_simpel (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
				LONG dummy2 TOM_ATTRIB_UNUSED)
{
	if (!strncmp (cmd, "OC", 2))
	{
		if (cmd[2]=='+')
			ta_opts.only_one_group = FALSE;
		else
			ta_opts.only_one_group = TRUE;
		ta_opts.changed = TRUE;
	}
	else if (!strcmp (cmd, "OE"))
		ta_passinfo.echo_news = FALSE;
	else if (!strcmp (cmd, "ON"))
		ta_passinfo.send_news = TRUE;
	else if (!strcmp (cmd, "PA"))
		ta_passinfo.send_pa = TRUE;
	else if (!strcmp (cmd, "PE"))
		ta_passinfo.send_pe = TRUE;
	else if (!strcmp (cmd, "PN"))
		ta_passinfo.send_mail = TRUE;
	else if (!strcmp (cmd, "PSA"))
		ta_passinfo.status = TA_STATUS_ALLE;
	else if (!strcmp (cmd, "PSN"))
		ta_passinfo.status = TA_STATUS_NEUE;
	else if (!strcmp (cmd, "TS"))
		ta_passinfo.send_star = TRUE;
	else
	{
		/* this should really not happen */
		ta_do_log_error ("unbekanntes Kommando (simpel, aber unbekannt: TSNH)!\r\n");
	}
}

#line 392

#line 392
ta_command_t ta_mcmd_desc_dupe = {
#line 392
	/* Magic 1       */ "QDUPE",
#line 392
	/* Magic 2       */     "",
#line 392
	/* Funktionsname */     ta_mcmd_dupe,
#line 392
	/* Min. Level    */     9,
#line 392
	/* Textpara      */     NULL,
#line 392
	/* Num. Parameter*/     0,
#line 392

#line 392
	/* ITK-ID-Nummer */     1202,
#line 392
	/* Gruppierung   */     "F",
#line 392
	/* ITK-Version   */     0,
#line 392
	/* ITK-Typ       */     "B", 
#line 392
	/* ITK-Name      */     "Dupecheck", 
#line 392
	/* ITK-Beschrei. */ 
#line 392
	    
#line 392
    "Mit diesem Kommando knnen Sie den Dupecheck ein- oder ausschalten. " 
#line 392
	"Es wirkt nur fr Benutzer. Sie sollten es nicht benutzen."     
#line 392
	, 
#line 392

#line 392
	/* ITK-Syntaxdefinition*/
#line 392
	    
#line 392
    ":CQDUPECHECK=\r\n"
#line 392
    ":FA\r\n"
#line 392
	":AON\r\n"
#line 392
	":Beinschalten\r\n"
#line 392
	":AOFF\r\n"
#line 392
	":Bausschalten\r\n"
#line 392
    
#line 392

#line 392
	,
#line 392

#line 392
	/* Verkettungsptr*/ NULL
#line 392
};
#line 392

static void
ta_mcmd_dupe (char *cmd, 
	const char *dummy TOM_ATTRIB_UNUSED, 
	LONG dummy2 TOM_ATTRIB_UNUSED)
{
	cmd+=strlen("QDUPECHECK");
	while (isspace(*cmd))
		cmd++;
	if (*cmd=='=')
		cmd++;
	while (isspace(*cmd))
		cmd++;
	if (!stricmp(cmd,"OFF"))
	{
		ta_dupe_off ();
		ta_do_log (":!Dupecheck abgeschaltet!\r\n");
		return;
	}
	ta_dupe_on ();
	ta_do_log (":!Dupecheck eingeschaltet!\r\n");
}

#line 452

#line 452
ta_command_t ta_mcmd_desc_tauschdatum = {
#line 452
	/* Magic 1       */ "TD",
#line 452
	/* Magic 2       */     "",
#line 452
	/* Funktionsname */     ta_mcmd_tauschdatum,
#line 452
	/* Min. Level    */     0,
#line 452
	/* Textpara      */     NULL,
#line 452
	/* Num. Parameter*/     0,
#line 452

#line 452
	/* ITK-ID-Nummer */     1203,
#line 452
	/* Gruppierung   */     "T",
#line 452
	/* ITK-Version   */     0,
#line 452
	/* ITK-Typ       */     "E", 
#line 452
	/* ITK-Name      */     "Tauschdatum setzen", 
#line 452
	/* ITK-Beschrei. */ 
#line 452
	    
#line 452
    "Mit dieser Funktion knnen Sie das Datum ihres letzten Tauschs setzen. " 
#line 452
	"Alle seitdem eingegangenen Nachrichten werden als 'neu' angesehen."     
#line 452
	, 
#line 452

#line 452
	/* ITK-Syntaxdefinition*/
#line 452
	    
#line 452
	":CTD\r\n"
#line 452
	":FA\r\n"
#line 452
    ":KNachrichtentyp\r\n"
#line 452
    ":LLegen Sie fest, fr welche Mitteilungen Sie das Datum umsetzen mchten.\r\n"
#line 452
	":A\r\n"
#line 452
	":Bfr ffentliche und persnliche Nachrichten\r\n"
#line 452
	":AN\r\n"
#line 452
	":Bfr ffentliche Nachrichten\r\n"
#line 452
	":AM\r\n"
#line 452
	":Bfr persnliche Nachrichten\r\n"
#line 452
	":AS\r\n"
#line 452
	":Bfr Statusmitteilungen\r\n"
#line 452
	":FD\r\n"
#line 452
	":KDatum\r\n"
#line 452
	":LWhlen Sie, ab welchem Datum Sie die Nachrichten geschickt bekommen "
#line 452
		"wollen.\r\n"
#line 452
    
#line 452

#line 452
	,
#line 452

#line 452
	/* Verkettungsptr*/ NULL
#line 452
};
#line 452

static void 
ta_mcmd_tauschdatum (char *cmd , const char *dummy1 TOM_ATTRIB_UNUSED, 
					 LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *p;
	char mode=0;
	time_t t;

	p=cmd+2;
	if (*p=='N')
	{
		mode='N';
		p++;
	}
	else if (*p=='M')
	{
		mode='M';
		p++;
	}
	else if (*p=='S')
	{
		mode='S';
		p++;
	}
	else
		mode='B';
		
	while (isspace(*p))
		p++;
	if (!mtzeit_to_time_t(p, &t))
	{
		ta_do_log_error ("unparsbares Datum!\r\n");
		return;
	}
	switch(mode)
	{
	case 'N': ta_opts.last_newstausch=t; break;
	case 'M': ta_opts.last_mailtausch=t; break;
	case 'S': ta_opts.last_status=t; break;
	case 'B': 
		ta_opts.last_newstausch=t; 
		ta_opts.last_mailtausch=t; 
		break;
	}
	ta_opts.changed=TRUE;
}

#line 526

#line 526
ta_command_t ta_mcmd_desc_transferzeit = {
#line 526
	/* Magic 1       */ "TZ",
#line 526
	/* Magic 2       */     "",
#line 526
	/* Funktionsname */     ta_mcmd_transferzeit,
#line 526
	/* Min. Level    */     0,
#line 526
	/* Textpara      */     NULL,
#line 526
	/* Num. Parameter*/     0,
#line 526

#line 526
	/* ITK-ID-Nummer */     1204,
#line 526
	/* Gruppierung   */     "T",
#line 526
	/* ITK-Version   */     0,
#line 526
	/* ITK-Typ       */     "K", 
#line 526
	/* ITK-Name      */     "Maximale Transferzeit", 
#line 526
	/* ITK-Beschrei. */ 
#line 526
	    
#line 526
	"Mit diesem Kommando knnen Sie die Maximaldauer des Datentransfers "
#line 526
	"festlegen. Es ist fr Fernzonentauscher gedacht, die Hnger im "
#line 526
	"bertragungsprotokoll erleiden."     
#line 526
	, 
#line 526

#line 526
	/* ITK-Syntaxdefinition*/
#line 526
	    
#line 526
    ":CTZ\r\n"
#line 526
	":FI1,65536\r\n"
#line 526
	":KMaximalzeit in Sekunden\r\n"
#line 526
	":LWhlen Sie die Maximaldauer der Datenbertragung in Sekunden.\r\n"
#line 526
    
#line 526

#line 526
	,
#line 526

#line 526
	/* Verkettungsptr*/ NULL
#line 526
};
#line 526

/*
 * TTZ[0-9]* : Kommando zum Setzen der maximalen Transferzeit.
 */
static void
ta_mcmd_transferzeit (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
					  LONG dummy2 TOM_ATTRIB_UNUSED)
{
	ULONG val;
	char *next;

	val = strtoul (cmd + 2, &next, 10);
	if (next == cmd + 2)
	{
		ta_do_log_error ("Maximaltransferzeit unverstndlich\r\n");
	}
	else
	{
		akt_anruf.max_transferzeit=(time_t) val;
		ta_do_log (":! Max. Transferzeit %lu\r\n", val);
	}
}

#line 579

#line 579
ta_command_t ta_mcmd_desc_tausch_brett = {
#line 579
	/* Magic 1       */ "TB",
#line 579
	/* Magic 2       */     "",
#line 579
	/* Funktionsname */     ta_mcmd_tausch_brett,
#line 579
	/* Min. Level    */     0,
#line 579
	/* Textpara      */     NULL,
#line 579
	/* Num. Parameter*/     0,
#line 579

#line 579
	/* ITK-ID-Nummer */     1205,
#line 579
	/* Gruppierung   */     "T",
#line 579
	/* ITK-Version   */     0,
#line 579
	/* ITK-Typ       */     "K", 
#line 579
	/* ITK-Name      */     "Nachrichten nachbestellen", 
#line 579
	/* ITK-Beschrei. */ 
#line 579
	    
#line 579
	"Mit diesem Kommando knnen Sie die Nachrichten einer Gruppe "
#line 579
	"nachbestellen."     
#line 579
	, 
#line 579

#line 579
	/* ITK-Syntaxdefinition*/
#line 579
	    
#line 579
    ":CTBD\r\n"
#line 579
	":FG\r\n"
#line 579
	":KGruppe\r\n"
#line 579
	":LWhlen Sie eine Gruppe\r\n"
#line 579
	":C,\r\n"
#line 579
	":FD\r\n"
#line 579
	":KDatum\r\n"
#line 579
	":LHier geben Sie an, ab welchem Datum Sie die Nachrichten "
#line 579
	"erhalten wollen\r\n"
#line 579
    
#line 579

#line 579
	,
#line 579

#line 579
	/* Verkettungsptr*/ NULL
#line 579
};
#line 579

/*
 * TB: "Tausch Brett" per MausTausch.
 */
static void
ta_mcmd_tausch_brett (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
					  LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *gname=cmd+3; /* TBD berspringen */
	char *p;
	char *q;
	const char *err=NULL;
	BRETTNR bnr;
	BOOLEAN darf;
	FILE *f;

	p=strchr(gname,',');
	if (p) 
		*p++=0;
	else {
		ta_do_log_error ("Illegale Syntax\r\n");
		return;
	}

	/* Brettdaten lesen, keinen Lock setzen */
	if (!ta_cmd_get_group (gname, &bnr, FALSE))
		return;                 /* log done */

	darf = ta_check_readperm(bnr, &err);
	if (!darf) {
		if (!err)
			err="Zugriff nicht erlaubt";
		ta_do_log_error ( err );
		return;
	}
	f=xfopen(tprintf("%s" TAUSCH_BRETT_F , tom_tmp_dir),BINAPPEND);
	q=strchr(p,'-');
	if (q) {
		unsigned long von,bis;
		*q++=0;
		/* n-m Syntax */
		von=strtoul(p,NULL,10);
		if (!*q)
			bis=ULONG_MAX;
		else
			bis=strtoul(q,NULL,10);
		if (von>bis) {
			ta_do_log_error ("Illegale Syntax\r\n");
			fclose(f);
			return;
		}
		fprintf(f,"%s,%lu-%lu\n",gname,von,bis);
		ta_do_log (":! Sende Nachrichten %lu bis %lu aus %s\r\n", von,bis,gname);
	} else if (0==strcmp(p,"*")) {
		fprintf(f,"%s,*\n",gname);
		ta_do_log (":! Sende alle Nachrichten aus %s\r\n", gname);
	} else {
		time_t t;
		if (!mtzeit_to_time_t(p,&t)) {
			ta_do_log_error ("Illegales Zeitformat\r\n");
		} else if (t>=time(NULL)) {
			ta_do_log_error ("Datum in der Zukunft\r\n");
		} else {
			fprintf(f,"%s,%lu\n",gname,(unsigned long) t);
			ta_do_log (":! Sende Nachrichten ab %s aus %s\r\n", p,gname);
		}
	}
	fclose(f);
	return;
}
