#line 1 "ta_ucmd.c4"
/* ta_ucmd.c4 : still no description  -*- C -*- */
/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#line 31 "ta_ucmd.c4"

/*
 * Tausch - Userbezogene Kommandos
 *
 * Uwe Ohse, 1.6.1994
 */


#include <portab.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <ctype.h>

#include "tomsysdep.h"
#include "prototyp.h"
#include "user.h"
#include "cslib.h"
#include "brett.h"
#include "routing.h" /* Vertreter ndern */
#include "terminal.h"
#include "cslib.h"

#include "tausch.h"
#include "ta_int.h"
#include "ta_ext.h"
#include "ta_cmd.h"

static void ta_ucmd_anlegen (char *cmd, const char *dummy, LONG dummy2);
static void ta_ucmd_passwort (char *cmd, const char *dummy, LONG dummy2);
static void ta_ucmd_vertreter (char *cmd, const char *dummy, LONG dummy2);
static void ta_ucmd_level (char *cmd, const char *dummy, LONG dummy2);
static void ta_ucmd_restzeit (char *cmd, const char *dummy, LONG dummy2);
static void ta_ucmd_konto (char *cmd, const char *dummy, LONG dummy2);
static void ta_ucmd_level (char *cmd, const char *dummy, LONG dummy2);
static void ta_ucmd_string (char *cmd, const char *dummy, LONG dummy2);
static void ta_ucmd_zahl (char *cmd, const char *dummy, LONG dummy2);
static void ta_ucmd_liste (char *cmd, const char *dummy, LONG dummy2);

#define STRING2(x) #x
#define STRING(x) STRING2(x)

#line 103

#line 103
ta_command_t ta_ucmd_desc_anlegen = {
#line 103
	/* Magic 1       */ "UA",
#line 103
	/* Magic 2       */     "",
#line 103
	/* Funktionsname */     ta_ucmd_anlegen,
#line 103
	/* Min. Level    */     8,
#line 103
	/* Textpara      */     NULL,
#line 103
	/* Num. Parameter*/     0,
#line 103

#line 103
	/* ITK-ID-Nummer */     1105,
#line 103
	/* Gruppierung   */ 	"A",
#line 103
	/* ITK-Version   */     0,
#line 103
	/* ITK-Typ       */     "B", 
#line 103
	/* ITK-Name      */     "Benutzer anlegen", 
#line 103
	/* ITK-Beschrei. */ 
#line 103
	    
#line 103
    "Mit dieser Funktion knnen Sie einen leeren Benutzerdatensatz anlegen. " 
#line 103
    "Bevor der neue Benutzer sich einloggen kann, mu noch ein Passwort "
#line 103
    "gesetzt werden."
#line 103
    
#line 103
	, 
#line 103

#line 103
	/* ITK-Syntaxdefinition*/
#line 103
	    
#line 103
    ":CUA\r\n"
#line 103
    ":FU\r\n"
#line 103
    ":KName\r\n"
#line 103
    ":LGeben Sie hier den Namen des anzulegenden Benutzers an.\r\n"
#line 103
    
#line 103

#line 103
	,
#line 103

#line 103
	/* Verkettungsptr*/ NULL
#line 103
};
#line 103


/* 
 * User anlegen
 */
static void
ta_ucmd_anlegen (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
				 LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *uname=cmd+2;
	USERNR *nummern;
	USER neu;

	strtrim(uname);
	if (!*uname)
	{
		ta_do_log_error ("Name fehlt");
		return;
	}

	nummern=ub_find_username_multi(uname,FALSE);
	if (nummern)
	{
		free(nummern);
		ta_do_log_error ("schon vorhanden");
		return;
	}

	if (strlen(uname) >= UDAT_NAME_LEN)
	{
		ta_do_log_error ("Name zu lang");
		return;
	}

	if (!check_username_syntax(uname,FALSE))
	{
		ta_do_log_error ( "Name enthlt unerlaubte Zeichen");
		ta_do_log_error ( "Nur Buchstaben, Zahlen, [./+-] und Space erlaubt");
		return;
	}

	if (mistuser(uname,FALSE))
		ta_do_log ( ":!Name steht in Mistuserdatei. Hope that's ok ...\r\n");

	memset(&neu,0,sizeof(USER));
	strcpy(neu.name,uname);

	/* 
	 * Ein Passwort setzen. Hinreichend zufllig :-)
	 */
	{
		char buf[256];
		srand (akt_anruf.startzeit);
		sprintf(buf,"%lu%lu-%d@%s",
			(ULONG) user.nummer,akt_anruf.anrufnummer,rand(),MYDOMAINPART);
		passwort_crypt(neu.passwort,buf,0,PW_MD5);
		neu.pw_encoding=PW_MD5;
	}

	/*
	 * diverse Defaults setzen. Absichtlich nicht vom aktuellen User
	 * bernommen.
	 */
	neu.mehr=TRUE;
	neu.bs_zeilen=22;
	neu.bs_spalten=80;
	neu.terminal_typ=T_ASCII;
	neu.uhrmodus=UHR_AUS;
	/* neu.box_stil=??? ; */
	neu.menue_stil=1; /* lang */
	neu.glocke=FALSE;
	neu.autohilfe=TRUE;
	neu.autobefehl=TRUE;
	neu.zeichensatz=0;

	if (!ub_create_user(&neu))
	{
		ta_do_log_error ( "Konnte Benutzerdatensatz nicht anlegen");
		return;
	}

	/* Schreiben und unlocken */
	ub_write_user(&neu,TRUE);
	ta_do_log ( ":!Ok\r\n");
}

/* 
 * Passwort ndern. Fr alle.
 */
#line 220

#line 220
ta_command_t ta_ucmd_desc_passwort = {
#line 220
	/* Magic 1       */ "UP",
#line 220
	/* Magic 2       */     "",
#line 220
	/* Funktionsname */     ta_ucmd_passwort,
#line 220
	/* Min. Level    */     0,
#line 220
	/* Textpara      */     NULL,
#line 220
	/* Num. Parameter*/     0,
#line 220

#line 220
	/* ITK-ID-Nummer */     10,
#line 220
	/* Gruppierung   */ 	"U",
#line 220
	/* ITK-Version   */     0,
#line 220
	/* ITK-Typ       */     "B", 
#line 220
	/* ITK-Name      */     "Pawort", 
#line 220
	/* ITK-Beschrei. */ 
#line 220
	    
#line 220
    "Mit dieser Funktion knnen Sie das Pawort ndern."     
#line 220
	, 
#line 220

#line 220
	/* ITK-Syntaxdefinition*/
#line 220
	    
#line 220
    ":CUP\r\n"
#line 220
    ":FUo\r\n"
#line 220
    ":D%uN\r\n"
#line 220
    ":KBenutzer\r\n"
#line 220
    ":LGeben Sie hier den Namen des Benutzers an.\r\n"
#line 220
    ":C=\r\n"
#line 220
    ":Fp64\r\n" /* wird gecrypted, Lnge daher unwichtig */
#line 220
    ":KPasswort\r\n"
#line 220
    ":LGeben Sie hier das neue Passwort ein.\r\n" 
#line 220

#line 220
	,
#line 220

#line 220
	/* Verkettungsptr*/ NULL
#line 220
};
#line 220

static void
ta_ucmd_passwort (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
				  LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *p;
	char *uname=cmd+2;
	BOOLEAN self=FALSE;
	USERNR unr;

	p=strchr(uname,'=');
	if (!p)
	{
		ta_do_log_error ("unbekanntes Kommando!");
		return;
	}
	*p++=0;
	strtrim(p);
	strtrim(uname);
	if (!*uname)
		self=TRUE;
	else if (!ub_find_username(&unr,uname))
	{
		ta_do_log_error ("unbekannter Benutzer");
		return;
	}
	else if (unr==user.nummer)
		self=TRUE;

	if (!self && level()<8)
	{
		ta_do_log_error ("nicht erlaubt");
		return;
	}

	if (!*p)
	{
		ta_do_log_error ("leeres Passwort nicht erlaubt");
		return;
	}

	/* Mistpasswort soll nicht meckern */
	if (self && mistpasswort(&user,p,TRUE))
	{
		ta_do_log_error ("Schlechtes Passwort");
		return;
	}


	if (self)
	{
		passwort_crypt(user.passwort,p,unr,PW_MD5);
		user.pw_encoding=PW_MD5;
		user.passwortdatum=time(NULL);
		ta_do_log(":!ok\r\n");
	}
	else
	{
		USER u;
		if (!ta_cmd_get_user (uname, &unr, &u, TRUE))
			return;                 /* log done */
		if (u.level>level())
		{
			ta_do_log_error ("nicht erlaubt");
		}
		else
		{
			ta_do_log(":!ok\r\n");
			passwort_crypt(u.passwort,p,unr,PW_MD5);
			u.pw_encoding=PW_MD5;
			u.passwortdatum=time(NULL);
		}
		ub_write_user (&u, TRUE);
	}
}

#line 326

#line 326
ta_command_t ta_ucmd_desc_level = {
#line 326
	/* Magic 1       */ "US",
#line 326
	/* Magic 2       */     "",
#line 326
	/* Funktionsname */     ta_ucmd_level,
#line 326
	/* Min. Level    */     8,
#line 326
	/* Textpara      */     NULL,
#line 326
	/* Num. Parameter*/     0,
#line 326

#line 326
	/* ITK-ID-Nummer */     1106,
#line 326
	/* Gruppierung   */ 	"A",
#line 326
	/* ITK-Version   */     0,
#line 326
	/* ITK-Typ       */     "B", 
#line 326
	/* ITK-Name      */     "Userlevel", 
#line 326
	/* ITK-Beschrei. */ 
#line 326
	    
#line 326
    "Mit dieser Funktion knnen Sie den Level eines Benutzers ndern. "
#line 326
    "Bedenken Sie, da Sie Ihren Level nicht selbst (wieder) nach oben "
#line 326
    "setzen knnen."     
#line 326
	, 
#line 326

#line 326
	/* ITK-Syntaxdefinition*/
#line 326
	    
#line 326
    ":CUS\r\n"
#line 326
    ":FUo\r\n"
#line 326
    ":KBenutzer\r\n"
#line 326
    ":LGeben Sie hier den Namen des Benutzers ein.\r\n"
#line 326
    ":C=\r\n"
#line 326
    ":FI0,9\r\n"
#line 326
    ":KLevel\r\n"
#line 326
    ":LGeben Sie hier den neuen Benutzerlevel ein.\r\n"
#line 326
    
#line 326

#line 326
	,
#line 326

#line 326
	/* Verkettungsptr*/ NULL
#line 326
};
#line 326

#line 353

#line 353
ta_command_t ta_ucmd_desc_level_abfragen = {
#line 353
	/* Magic 1       */ "US",
#line 353
	/* Magic 2       */     "",
#line 353
	/* Funktionsname */     ta_ucmd_level,
#line 353
	/* Min. Level    */     0,
#line 353
	/* Textpara      */     NULL,
#line 353
	/* Num. Parameter*/     0,
#line 353

#line 353
	/* ITK-ID-Nummer */     1107,
#line 353
	/* Gruppierung   */ 	"U",
#line 353
	/* ITK-Version   */     0,
#line 353
	/* ITK-Typ       */     "B", 
#line 353
	/* ITK-Name      */     "Level abfragen", 
#line 353
	/* ITK-Beschrei. */ 
#line 353
	    
#line 353
    "Mit dieser Funktion knnen Sie den Level eines Benutzers abfragen. "
#line 353
    "Nur Sysops erfahren die Level anderer Benutzer."     
#line 353
	, 
#line 353

#line 353
	/* ITK-Syntaxdefinition*/
#line 353
	    
#line 353
    ":CUS\r\n"
#line 353
    ":FUo\r\n"
#line 353
    ":KBenutzer\r\n"
#line 353
    ":LGeben Sie hier den Namen des Benutzers ein.\r\n"
#line 353
    ":C=?\r\n"
#line 353
    
#line 353

#line 353
	,
#line 353

#line 353
	/* Verkettungsptr*/ NULL
#line 353
};
#line 353


static void
ta_ucmd_level (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
			   LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *p;
	char *uname=cmd+2;
	UWORD neu_lv;
	BOOLEAN self=FALSE;
	USERNR unr;
	USER u;
	p=strchr(uname,'=');
	if (!p)
	{
		ta_do_log_error ("ungltiges Kommando!");
		return;
	}
	*p++=0;
	strtrim(p);
	strtrim(uname);
	if (!*p)
	{
		ta_do_log_error ("ungltiges Kommando!");
		return;
	}

	if (!*uname)
		self=TRUE;
	else if (!ub_find_username(&unr,uname))
	{
		ta_do_log_error ("unbekannter Benutzer");
		return;
	}
	else if (unr==user.nummer)
		self=TRUE;

	/* query-Mode */
	if (!strcmp(p,"?"))
	{
		if (self)
			ta_do_log(":!Sie haben Level %d\r\n",(int) user.level);
		else if (!ta_cmd_get_user (uname, &unr, &u, FALSE))
			return;                 /* log done */
		else
			ta_do_log(":!%s hat Level %d\r\n",uname,(int) u.level);
		return;
	}

	/*
	 * Level eines Benutzers ndern
	 */
	neu_lv=strtol(p,NULL,10);
	if (neu_lv>level())
	{
		ta_do_log_error ("nicht erlaubt");
		return;
	}

	if (self)
	{
		/* Aha - wir ndern unseren eigenen Level. Der Abschied aus
		 * dem Sysopdasein?
		 */
		user.level=neu_lv;
		ta_do_log(":!Sie haben nun Level %d\r\n",(int) u.level);
	}
	else if (!ta_cmd_get_user (uname, &unr, &u, TRUE))
		return;                 /* log done */
	else
	{
		if (u.level>level())
		{
			/* Das Opfer hat einen hheren Level ... */
			ta_do_log_error("nicht erlaubt");
		}
		else
		{
			u.level=neu_lv;
			ta_do_log(":!%s hat nun Level %d\r\n",uname,(int) u.level);
		}
		ub_write_user (&u, TRUE);
	}
}


/* 
 * Vertreter ndern.
 */
#line 473

#line 473
ta_command_t ta_ucmd_desc_vertreter = {
#line 473
	/* Magic 1       */ "UF",
#line 473
	/* Magic 2       */     "",
#line 473
	/* Funktionsname */     ta_ucmd_vertreter,
#line 473
	/* Min. Level    */     0,
#line 473
	/* Textpara      */     NULL,
#line 473
	/* Num. Parameter*/     0,
#line 473

#line 473
	/* ITK-ID-Nummer */     14,
#line 473
	/* Gruppierung   */ 	"U",
#line 473
	/* ITK-Version   */     0,
#line 473
	/* ITK-Typ       */     "E", 
#line 473
	/* ITK-Name      */     "Vertreter-Adresse", 
#line 473
	/* ITK-Beschrei. */ 
#line 473
	    
#line 473
    "Mit dieser Funktion knnen Sie die Adresse, an die persnliche "
#line 473
    "Nachrichten fr den Benutzer weitergeleitet werden, einstellen."     
#line 473
	, 
#line 473

#line 473
	/* ITK-Syntaxdefinition*/
#line 473
	    
#line 473
    ":CUF\r\n"
#line 473
    ":FUo\r\n"
#line 473
    ":KBenutzer\r\n"
#line 473
    ":LGeben Sie hier den Namen des Benutzers ein (Default: Ihr eigener)\r\n"
#line 473
    ":D%uN\r\n"
#line 473
    ":C=\r\n"
#line 473
    ":FS" STRING(UDAT_NAME_LEN) "\r\n"
#line 473
    ":KAdresse\r\n"
#line 473
    ":LZieladresse fuer die automatische Weiterleitung. Ohne Angabe: "
#line 473
    "Lschung. Mit '?' Abfrage der Adresse.\r\n"
#line 473
    
#line 473

#line 473
	,
#line 473

#line 473
	/* Verkettungsptr*/ NULL
#line 473
};
#line 473

void
ta_ucmd_vertreter (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
				   LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *p;
	char *uname=cmd+2;
	BOOLEAN self=FALSE;
	USERNR unr;
	USER u;
	BOOLEAN abfrage;

	p=strchr(uname,'=');
	if (!p)
	{
		ta_do_log_error ("ungltiges Kommando!");
		return;
	}
	*p++=0;
	strtrim(p);
	strtrim(uname);
	if (!*uname)
		self=TRUE;
	else if (!ub_find_username(&unr,uname))
	{
		ta_do_log_error ("ungltiger Benutzer");
		return;
	}
	else if (unr==user.nummer)
		self=TRUE;

	if (!self && level()<8)
	{
		ta_do_log_error ("nicht erlaubt");
		return;
	}

	if (strlen(p)>=UDAT_NAME_LEN)
	{
		ta_do_log_error ("zu lang");
		return;
	}

	abfrage=(strcmp(p,"?")==0);
	if (!self)
	{
		if (!ta_cmd_get_user (uname, &unr, &u, !abfrage))
			return;                 /* log done */
	}
	if (abfrage)
	{
		ta_do_log(":!ist: %s\r\n", self ? user.vertreter : u.vertreter);
		return;
	}
	if (!*p)
	{
		/* Lschen - sehr einfach */
		ta_do_log(":!gelscht. War: %s\r\n",
			self ? user.vertreter : u.vertreter);
		if (self)
			user.vertreter[0]=0;
		else
			u.vertreter[0]=0;
	}
	else
	{
		/* Neu setzen - das sieht nur einfach aus. */
		char *err=NULL;
		if (!r_vrfy(p, &err, 
			self ? level() : u.level,
			self ? user.bezahlt : u.bezahlt))
		{
			if (err)
				ta_do_log_error(err);
			else
				ta_do_log_error("nicht erlaubt");
		}
		else
		{
			ta_do_log(":!gelscht. War: %s\r\n",
				self ? user.vertreter : u.vertreter);
			if (self)
				strcpy(user.vertreter,p);
			else
				strcpy(u.vertreter,p);
		}
	}
	if (!self)
		ub_write_user (&u, TRUE);
}

/* 
 * Onlinezeit ndern
 */
#line 596

#line 596
ta_command_t ta_ucmd_desc_restzeit = {
#line 596
	/* Magic 1       */ "UO",
#line 596
	/* Magic 2       */     "",
#line 596
	/* Funktionsname */     ta_ucmd_restzeit,
#line 596
	/* Min. Level    */     8,
#line 596
	/* Textpara      */     NULL,
#line 596
	/* Num. Parameter*/     0,
#line 596

#line 596
	/* ITK-ID-Nummer */     1104,
#line 596
	/* Gruppierung   */ 	"A",
#line 596
	/* ITK-Version   */     0,
#line 596
	/* ITK-Typ       */     "B", 
#line 596
	/* ITK-Name      */     "Restonlinezeit", 
#line 596
	/* ITK-Beschrei. */ 
#line 596
	    
#line 596
    "Mit diesem Kommando knnen Sie die heutige Restonlinezeit eines " 
#line 596
    "Benutzers ndern."     
#line 596
	, 
#line 596

#line 596
	/* ITK-Syntaxdefinition*/
#line 596
	    
#line 596
    ":CUO\r\n"
#line 596
    ":FU\r\n"
#line 596
    ":KBenutzer\r\n"
#line 596
    ":LGeben Sie hier den Namen des Benutzers ein\r\n"
#line 596
    ":C=\r\n"
#line 596
    ":FI0,999\r\n"
#line 596
    ":KOnlinezeit\r\n"
#line 596
    ":LGeben Sie hier die neue Restonlinezeit in Minuten ein\r\n"
#line 596
    
#line 596

#line 596
	,
#line 596

#line 596
	/* Verkettungsptr*/ NULL
#line 596
};
#line 596

void
ta_ucmd_restzeit (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
				  LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *p;
	char *uname=cmd+2;
	BOOLEAN self=FALSE;
	USERNR unr;
	long rest;

	p=strchr(uname,'=');
	if (!p)
	{
		ta_do_log_error ("ungltiges Kommando!");
		return;
	}
	*p++=0;
	strtrim(p);
	strtrim(uname);
	if (!*uname)
		self=TRUE;
	else if (!ub_find_username(&unr,uname))
	{
		ta_do_log_error ("ungltiger Benutzer");
		return;
	}
	else if (unr==user.nummer)
		self=TRUE;

	rest=strtol(p,NULL,10);
	if (rest<0 || rest*60 > 86400L)
	{
		ta_do_log_error ("Restzeit zu klein/zu gro");
		return;
	}

	if (self)
	{
		ta_do_log(":!war %d Minuten\r\n", (int) (user.restzeit/60));
		user.restzeit=rest*60;
	}
	else
	{
		USER u;
		if (!ta_cmd_get_user (uname, &unr, &u, TRUE))
			return;                 /* log done */
		if (u.level>level())
		{
			ta_do_log_error ("nicht erlaubt");
		}
		else
		{
			ta_do_log(":!war %d Minuten\r\n", (int) (u.restzeit/60));
			u.restzeit=rest*60;
		}
		ub_write_user (&u, TRUE);
	}
}


/* 
 * Zahlerstatus ndern. Fr alle, wegen "?".
 */
#line 688

#line 688
ta_command_t ta_ucmd_desc_konto_geben = {
#line 688
	/* Magic 1       */ "U$",
#line 688
	/* Magic 2       */     "",
#line 688
	/* Funktionsname */     ta_ucmd_konto,
#line 688
	/* Min. Level    */     8,
#line 688
	/* Textpara      */     NULL,
#line 688
	/* Num. Parameter*/     0,
#line 688

#line 688
	/* ITK-ID-Nummer */     19,
#line 688
	/* Gruppierung   */ 	"A",
#line 688
	/* ITK-Version   */     0,
#line 688
	/* ITK-Typ       */     "B", 
#line 688
	/* ITK-Name      */     "Zahlerstatus geben", 
#line 688
	/* ITK-Beschrei. */ 
#line 688
	    
#line 688
    "Hiermit knnen Sie einem Benutzer Zahlerstatus geben"     
#line 688
	, 
#line 688

#line 688
	/* ITK-Syntaxdefinition*/
#line 688
	    
#line 688
    ":CU$$\r\n"
#line 688
    ":FU\r\n"
#line 688
    ":KBenutzer\r\n"
#line 688
    ":LGeben Sie den Namen des Benutzers ein.\r\n"
#line 688
    ":C=\r\n"
#line 688
    ":FD\r\n"
#line 688
    ":KDatum\r\n"
#line 688
    ":LGeben Sie das Datum ein, bis zu dem der Benutzer bezahlt hat.\r\n"
#line 688
    
#line 688

#line 688
	,
#line 688

#line 688
	/* Verkettungsptr*/ NULL
#line 688
};
#line 688

#line 720

#line 720
ta_command_t ta_ucmd_desc_konto_aendern = {
#line 720
	/* Magic 1       */ "U$",
#line 720
	/* Magic 2       */     "",
#line 720
	/* Funktionsname */     ta_ucmd_konto,
#line 720
	/* Min. Level    */     8,
#line 720
	/* Textpara      */     NULL,
#line 720
	/* Num. Parameter*/     0,
#line 720

#line 720
	/* ITK-ID-Nummer */     20,
#line 720
	/* Gruppierung   */ 	"A",
#line 720
	/* ITK-Version   */     0,
#line 720
	/* ITK-Typ       */     "B", 
#line 720
	/* ITK-Name      */     "Zahlerstatus", 
#line 720
	/* ITK-Beschrei. */ 
#line 720
	    
#line 720
    "Hiermit knnen Sie den Zahlerstatus eines Benutzers verlngern oder"
#line 720
    "-krzen."     
#line 720
	, 
#line 720

#line 720
	/* ITK-Syntaxdefinition*/
#line 720
	    
#line 720
    ":CU$$\r\n"
#line 720
    ":FU\r\n"
#line 720
    ":KBenutzer\r\n"
#line 720
    ":LGeben Sie den Namen des Benutzers ein.\r\n"
#line 720
    ":C=\r\n"
#line 720
    ":FI-9999,9999\r\n"
#line 720
    ":KDatum\r\n"
#line 720
    ":LVerlngerung (positive Zahl) bzw. Verkrzung (negative) des "
#line 720
    "Zahlerstatus.\r\n"
#line 720
	":D+365\r\n"
#line 720
    
#line 720

#line 720
	,
#line 720

#line 720
	/* Verkettungsptr*/ NULL
#line 720
};
#line 720

#line 747

#line 747
ta_command_t ta_ucmd_desc_konto_frage = {
#line 747
	/* Magic 1       */ "U$",
#line 747
	/* Magic 2       */     "",
#line 747
	/* Funktionsname */     ta_ucmd_konto,
#line 747
	/* Min. Level    */     8,
#line 747
	/* Textpara      */     NULL,
#line 747
	/* Num. Parameter*/     0,
#line 747

#line 747
	/* ITK-ID-Nummer */     22,
#line 747
	/* Gruppierung   */ 	"U",
#line 747
	/* ITK-Version   */     0,
#line 747
	/* ITK-Typ       */     "B", 
#line 747
	/* ITK-Name      */     "Zahlerstatus abfragen", 
#line 747
	/* ITK-Beschrei. */ 
#line 747
	    
#line 747
    "Hiermit knnen Sie den Zahlerstatus eines Benutzers abfragen"     
#line 747
	, 
#line 747

#line 747
	/* ITK-Syntaxdefinition*/
#line 747
	    
#line 747
    ":CU$$\r\n"
#line 747
    ":FU\r\n"
#line 747
    ":D%uN\r\n"
#line 747
    ":KBenutzer\r\n"
#line 747
    ":LGeben Sie den Namen des Benutzers ein.\r\n"
#line 747
    ":C=?\r\n"
#line 747
    
#line 747

#line 747
	,
#line 747

#line 747
	/* Verkettungsptr*/ NULL
#line 747
};
#line 747

static void
ta_ucmd_konto (char *cmd, 
			   const char *dummy TOM_ATTRIB_UNUSED, 
			   LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *p;
	char *uname=cmd+2;
	BOOLEAN self=FALSE;
	USERNR unr;
	USER u;
	long diff=0;
	time_t neu=0;

	p=strchr(uname,'=');
	if (!p)
	{
		ta_do_log_error ("unbekanntes Kommando!");
		return;
	}
	*p++=0;
	strtrim(p);
	strtrim(uname);
	if (!*uname)
		self=TRUE;
	else if (!ub_find_username(&unr,uname))
	{
		ta_do_log_error ("unbekannter Benutzer");
		return;
	}
	else if (unr==user.nummer)
		self=TRUE;

	if (!strcmp(p,"?"))
	{
		/* Zahlerdatum abfragen */
		time_t d;
		char *na;

		if (self)
			d=user.bezahlt_bis;
		else if (level()<8)
		{
			ta_do_log_error ("nicht erlaubt");
			return;
		}
		else
		{
			if (!ta_cmd_get_user (uname, &unr, &u, FALSE))
				return;                 /* log done */
			d=u.bezahlt_bis;
		}

		if (self)
			na=user.name;
		else
			na=uname;

		if (d==(time_t) 0)
		{
			ta_do_log(":!%s war nie Zahler\r\n",na);
		}
		else if (d>time(NULL))
			ta_do_log(":!%s ist Zahler bis %24.24s\r\n",
				na, ctime(&d));
		else
			ta_do_log(":!%s war Zahler bis %24.24s\r\n",
				na, ctime(&d));
		return;
	}

	/* Also nderung */
	if (level()<8)
	{
		ta_do_log_error ("nicht erlaubt");
		return;
	}

	if (isdigit(*p))
	{
		if (!mtzeit_to_time_t(p,&neu))
		{
			ta_do_log_error ("unparsbares Datum");
			return;
		}
	}
	else if (*p=='+' || *p=='-')
	{
		diff=strtol(p,NULL,10);
		if (diff < -10 * 365 || diff >10 * 365)
		{
			ta_do_log_error ("unparsbares Datum");
			return;
		}
		if (diff==0)
		{
			ta_do_log ("!ok (unverndert)\r\n");
			return;
		}
	}
	else
	{
		ta_do_log_error ("unparsbares Datum");
		return;
	}

	if (!self)
	{
		if (!ta_cmd_get_user (uname, &unr, &u, TRUE))
			return;                 /* log done */
	}
	else
		u=user;

	if (diff)
		u.bezahlt_bis+=diff*86400L;	
	else
		u.bezahlt_bis=neu;
	if (u.bezahlt_bis < time(NULL))
		u.bezahlt=FALSE;
	else
		u.bezahlt=TRUE;

	if (!self)
		ub_write_user (&u, TRUE);
	else
		user=u;

	ta_do_log(":!ok\r\n");
}

/* 
 * Zeilen/Bildschirmlnge ndern. Fr alle, wegen "?".
 */
#line 907

#line 907
ta_command_t ta_ucmd_desc_zeilenlaenge = {
#line 907
	/* Magic 1       */ "UW",
#line 907
	/* Magic 2       */     "",
#line 907
	/* Funktionsname */     ta_ucmd_zahl,
#line 907
	/* Min. Level    */     0,
#line 907
	/* Textpara      */     NULL,
#line 907
	/* Num. Parameter*/     0,
#line 907

#line 907
	/* ITK-ID-Nummer */     18,
#line 907
	/* Gruppierung   */ 	"U",
#line 907
	/* ITK-Version   */     0,
#line 907
	/* ITK-Typ       */     "E", 
#line 907
	/* ITK-Name      */     "Umbruch einstellen", 
#line 907
	/* ITK-Beschrei. */ 
#line 907
	    
#line 907
    "Mit dieser Funktion knnen Sie den Zeilenlnge fr den Umbruch beim "
#line 907
    	"Tausch einstellen. Mit '0' wird der Umbruch abgeschaltet."     
#line 907
	, 
#line 907

#line 907
	/* ITK-Syntaxdefinition*/
#line 907
	    
#line 907
    ":CUW=\r\n"
#line 907
	":FI0," STRING(USHRT_MAX) "\r\n"
#line 907
	":KZeilenlnge\r\n"
#line 907
	":LGeben Sie hier die neue Zeilenlnge in Zeichen ein.\r\n"
#line 907
	":D78\r\n"
#line 907
    
#line 907

#line 907
	,
#line 907

#line 907
	/* Verkettungsptr*/ NULL
#line 907
};
#line 907

#line 940

#line 940
ta_command_t ta_ucmd_desc_bildschirmlaenge = {
#line 940
	/* Magic 1       */ "UL",
#line 940
	/* Magic 2       */     "",
#line 940
	/* Funktionsname */     ta_ucmd_zahl,
#line 940
	/* Min. Level    */     0,
#line 940
	/* Textpara      */     NULL,
#line 940
	/* Num. Parameter*/     0,
#line 940

#line 940
	/* ITK-ID-Nummer */     16,
#line 940
	/* Gruppierung   */ 	"U",
#line 940
	/* ITK-Version   */     0,
#line 940
	/* ITK-Typ       */     "B", 
#line 940
	/* ITK-Name      */     "Seitenlnge", 
#line 940
	/* ITK-Beschrei. */ 
#line 940
	    
#line 940
    "Geben Sie an, nach wievielen Zeilen die Box auf einen Tastendruck warten"
#line 940
    "soll. 0 bewirkt Abschaltung des Bltterns (MEHR)."     
#line 940
	, 
#line 940

#line 940
	/* ITK-Syntaxdefinition*/
#line 940
	    
#line 940
    ":CUL\r\n"
#line 940
	":FUo\r\n"
#line 940
	":KBenutzer\r\n"
#line 940
	":D%uN\r\n"
#line 940
	":LGeben Sie den Namen des Benutzers ein, dessen Seitenlnge gendert "
#line 940
		"werden soll (oder keinen - dann wird Ihre Seitenlnge gendert)."
#line 940
		"\r\n"
#line 940
	":C=\r\n"
#line 940
	":FI0," STRING(USHRT_MAX) "\r\n"
#line 940
	":KSeitenlnge\r\n"
#line 940
	":LGeben Sie hier die neue Seitenlnge in Zeilen ein.\r\n"
#line 940
	":D22\r\n" 
#line 940

#line 940
	,
#line 940

#line 940
	/* Verkettungsptr*/ NULL
#line 940
};
#line 940

#line 985

#line 985
ta_command_t ta_ucmd_desc_umlaut = {
#line 985
	/* Magic 1       */ "UU",
#line 985
	/* Magic 2       */     "",
#line 985
	/* Funktionsname */     ta_ucmd_zahl,
#line 985
	/* Min. Level    */     0,
#line 985
	/* Textpara      */     NULL,
#line 985
	/* Num. Parameter*/     0,
#line 985

#line 985
	/* ITK-ID-Nummer */     40,
#line 985
	/* Gruppierung   */ 	"U",
#line 985
	/* ITK-Version   */     0,
#line 985
	/* ITK-Typ       */     "B", 
#line 985
	/* ITK-Name      */     "Umlauteinstellung", 
#line 985
	/* ITK-Beschrei. */ 
#line 985
	    
#line 985
    "Mit dieser Funktion setzen Sie die Umlauteinstellung."     
#line 985
	, 
#line 985

#line 985
	/* ITK-Syntaxdefinition*/
#line 985
	    
#line 985
    ":CUU\r\n"
#line 985
	":FUo\r\n"
#line 985
	":KBenutzer\r\n"
#line 985
	":D%uN\r\n"
#line 985
	":LGeben Sie den Namen des Benutzers ein, dessen Umlauteinstellung "
#line 985
		"gendert werden soll (oder keinen, um Ihre Umlauteinstellung zu "
#line 985
		"ndert).\r\n"
#line 985
	":C=\r\n"
#line 985
	":FA\r\n"
#line 985
	":KZeichensatztyp\r\n"
#line 985
	":Leinzustellender Zeichensatztyp\r\n"
#line 985
	":A0\r\n"
#line 985
	":Bkeine Umlaute\r\n"
#line 985
	":A101\r\n"
#line 985
	":BISO 8859-1\r\n"
#line 985
	":A201\r\n"
#line 985
	":BIBM PC\r\n"
#line 985
	":A202\r\n"
#line 985
	":BAtari ST\r\n"
#line 985
	":A203\r\n"
#line 985
	":BMacintosh\r\n"
#line 985
	":A205\r\n"
#line 985
	":BNeXTStep\r\n"
#line 985
	":A206\r\n"
#line 985
	":BSinclair QL\r\n" 
#line 985

#line 985
	,
#line 985

#line 985
	/* Verkettungsptr*/ NULL
#line 985
};
#line 985

#line 1024

#line 1024
ta_command_t ta_ucmd_desc_terminaltyp = {
#line 1024
	/* Magic 1       */ "UE",
#line 1024
	/* Magic 2       */     "",
#line 1024
	/* Funktionsname */     ta_ucmd_zahl,
#line 1024
	/* Min. Level    */     0,
#line 1024
	/* Textpara      */     NULL,
#line 1024
	/* Num. Parameter*/     0,
#line 1024

#line 1024
	/* ITK-ID-Nummer */     42,
#line 1024
	/* Gruppierung   */ 	"U",
#line 1024
	/* ITK-Version   */     0,
#line 1024
	/* ITK-Typ       */     "B", 
#line 1024
	/* ITK-Name      */     "Terminaltyp", 
#line 1024
	/* ITK-Beschrei. */ 
#line 1024
	    
#line 1024
    "Mit dieser Funktion setzen Sie den Terminaltyp."     
#line 1024
	, 
#line 1024

#line 1024
	/* ITK-Syntaxdefinition*/
#line 1024
	    
#line 1024
    ":CUE\r\n"
#line 1024
	":FUo\r\n"
#line 1024
	":KBenutzer\r\n"
#line 1024
	":D%uN\r\n"
#line 1024
	":LGeben Sie den Namen des Benutzers ein, dessen Terminaltyp "
#line 1024
		"gendert werden soll (oder keinen, um Ihren Terminaltyp "
#line 1024
		"zu ndern).\r\n"
#line 1024
	":C=\r\n"
#line 1024
	":FA\r\n"
#line 1024
	":KTerminaltyp\r\n"
#line 1024
	":Leinzustellender Terminaltyp\r\n"
#line 1024
	":A0\r\n"
#line 1024
	":Bkeine Terminalemulation\r\n"
#line 1024
	":A1\r\n"
#line 1024
	":BVT 100\r\n"
#line 1024
	":A2\r\n"
#line 1024
	":BANSI\r\n"
#line 1024
	":A3\r\n"
#line 1024
	":BVT 52\r\n" 
#line 1024

#line 1024
	,
#line 1024

#line 1024
	/* Verkettungsptr*/ NULL
#line 1024
};
#line 1024

static void
ta_ucmd_zahl (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
			  LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *p;
	char *uname=cmd+2;
	BOOLEAN self=FALSE;
	USERNR unr;
	USER u;
	long neu=0;

	p=strchr(uname,'=');
	if (!p)
	{
		ta_do_log_error ("unbekanntes Kommando!");
		return;
	}
	*p++=0;
	strtrim(p);
	strtrim(uname);
	if (!*uname)
		self=TRUE;
	else if (!ub_find_username(&unr,uname))
	{
		ta_do_log_error ("unbekannter Benutzer");
		return;
	}
	else if (unr==user.nummer)
		self=TRUE;

	if (!strcmp(p,"?"))
	{
		/* Abfrage */
		const char *titel=NULL; /* keep gcc quiet */
		long zahl=0;            /* keep gcc quiet */
		const char *str=NULL;

		if (!self && level()<8)
			ta_do_log_error ("nicht erlaubt");
		else if (!self)
		{
			if (!ta_cmd_get_user (uname, &unr, &u, FALSE))
				return;                 /* log done */
		}
		else
			u=user;

		switch(cmd[1])
		{
		case 'E': /* Terminaltyp */
			titel="Terminaltyp";
			zahl=u.terminal_typ;
			switch(zahl)
			{
			case 0: str="ASCII"; break;
			case 1: str="VT 100"; break;
			case 2: str="ANSI"; break;
			case 3: str="VT 52"; break;
			}
			break;
		case 'U': /* Zeichensatz */
			titel="Zeichensatz";
			zahl=u.zeichensatz;
			{
				cstl_t *cs;
				cs=get_charset_from_nr(user.zeichensatz);
				if (!cs)
					str="unbekannt (this should not happen)";
				else
					str=cs->name;
			}
			break;
		case 'L':
			titel="Bildschirmlnge";
			zahl=u.bs_zeilen;
			break;
		case 'W':
			if (self)
			{
				titel="Zeilenlnge (Tausch)";
				zahl=ta_opts.umbruch;
			}
			else
			{
				ta_do_log_error ("nicht mglich");
				return;
			}
			break;
		}

		if (str)
			ta_do_log(":!%s: %ld (%s)\r\n\r\n",titel,zahl,str);
		else
			ta_do_log(":!%s: %ld\r\n\r\n",titel,zahl);
		return;
	}

	/* Also nderung */
	if (!self && level()<8)
		ta_do_log_error ("nicht erlaubt");
	else if (!self)
	{
		if (cmd[2]=='W')
		{
			/* Zeilenlnge im Tausch fr andere zu setzen ist unmglich */
			ta_do_log_error ("Umbruch fr Andere zu setzen ist unmglich");
			return;
		}
		if (!ta_cmd_get_user (uname, &unr, &u, TRUE))
			return;                 /* log done */
	}
	else
		u=user;

	neu=strtol(p,NULL,10);
	switch(cmd[2])
	{
	case 'E': /* Terminaltyp */
		if (neu<0 || neu >3)
			ta_do_log_error ("unbekannter Terminaltyp");
		else
		{
			u.terminal_typ=neu;
			ta_do_log ("!ok\r\n");
		}
		break;
	case 'U': /* Umlauteinstellung */
		{
			cstl_t *cs;
			cs=get_charset_from_nr(user.zeichensatz);
			if (!cs)
				ta_do_log_error ("unbekannter Zeichensatz");
			else
			{
				u.zeichensatz=neu;
				ta_do_log ("!ok\r\n");
			}
		}
		break;
	case 'W':
		if (neu<10 && neu!=0)
			ta_do_log_error ("zu kurz");
		else
		{
			ta_opts.umbruch=neu;
			ta_do_log ("!ok\r\n");
		}
		break;
	case 'L':
		if (neu<=10)
			ta_do_log_error ("zu kurz");
		else
		{
			u.bs_zeilen=neu;
			ta_do_log ("!ok\r\n");
		}
		break;
	}

	if (!self)
		ub_write_user (&u, TRUE);
	else
		user=u;

}

#line 1251

#line 1251
ta_command_t ta_ucmd_desc_liste = {
#line 1251
	/* Magic 1       */ "UQUM",
#line 1251
	/* Magic 2       */ 	"UQUN",
#line 1251
	/* Funktionsname */ 	ta_ucmd_liste,
#line 1251
	/* Min. Level    */ 	8,
#line 1251
	/* Textpara      */ 	NULL,
#line 1251
	/* Num. Parameter*/ 	0,
#line 1251

#line 1251
	/* ITK-ID-Nummer */ 		1003,
#line 1251
	/* Gruppierung   */ 	"A",
#line 1251
	/* ITK-Version   */ 	1,
#line 1251
	/* ITK-Typ       */ 	"E", 
#line 1251
	/* ITK-Name      */ 	"Benutzerliste anfordern", 
#line 1251
	/* ITK-Beschrei. */ 
#line 1251
			
#line 1251
	"Mit dieser Funktion fordern Sie eine Benutzerliste an." 	
#line 1251
	, 
#line 1251

#line 1251
	/* ITK-Syntaxdefinition*/
#line 1251
		
#line 1251
	":CUQU\r\n"
#line 1251
	":FA\r\n"
#line 1251
	":KMaschinenlesbarkeit\r\n"
#line 1251
	":LGeben Sie hier an, ob Sie eine maschinenlesbare Liste wnschen\r\n"
#line 1251
	":AM:N\r\n"
#line 1251
	":BMaschinenlesbar:nicht maschinenlesbar\r\n"
#line 1251
	":FA\r\n"
#line 1251
	":KAuswahl\r\n"
#line 1251
	":LGeben Sie hier an, welche Benutzer in der Liste ausgegeben werden"
#line 1251
	 "sollen.\r\n"
#line 1251
	":A$$+:$$-:\r\n"
#line 1251
	":BZahler:Nichtzahler:Zahler und Nichtzahler\r\n"
#line 1251
	":FAo\r\n"
#line 1251
	":KZeit\r\n"
#line 1251
	":LWhlen Sie, ob Sie eine Liste der Benutzer bekommen wollen, die"
#line 1251
	 "sich vor oder nach dem Datum eingetragen haben.\r\n"
#line 1251
	":A>\r\n"
#line 1251
	":Bnach dem Datum (Default)\r\n"
#line 1251
	":A<\r\n"
#line 1251
	":Bvor dem Datum\r\n"
#line 1251
    ":FDo\r\n"
#line 1251
	":D198001010000\r\n"
#line 1251
    ":KDatum\r\n"
#line 1251
    ":LGeben Sie das Vergleichsdatum ein\r\n"
#line 1251
	":C=\r\n"
#line 1251
	":FM\r\n"
#line 1251
	":KFormat\r\n"
#line 1251
	":LWhlen Sie das Ausgabeformat\r\n"
#line 1251
	":A$$:\r\n"
#line 1251
	":BZahlerstatus\r\n"
#line 1251
	":Al:\r\n"
#line 1251
	":BLevel\r\n"
#line 1251
	":An:\r\n"
#line 1251
	":BNummer\r\n"
#line 1251
	":AL:\r\n"
#line 1251
	":BLetzter Login\r\n"
#line 1251
	":Ae:\r\n"
#line 1251
	":BErster Login\r\n"
#line 1251
	":AA:\r\n"
#line 1251
	":BAnrufezahl\r\n"
#line 1251
	
#line 1251

#line 1251
	,
#line 1251

#line 1251
	/* Verkettungsptr*/ NULL
#line 1251
};
#line 1251

void
ta_ucmd_liste (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
			   LONG dummy2 TOM_ATTRIB_UNUSED)
{
	USER u;
	FILE *f;
	time_t zeit=0;
	BOOLEAN zeit_groesser=TRUE;
	char fname[PATH_MAX];
	BOOLEAN alle=TRUE;
	char *p;
	const char *format;
	BOOLEAN maschinenlesbar;
	BOOLEAN nur_zahler=FALSE;
	BOOLEAN nicht_zahler=FALSE;

	p=cmd+3; /* UQU berspringen */
	if (*p=='M')
	{
		maschinenlesbar=TRUE;
		format="$$lnLeA";
	}
	else 
	{
		maschinenlesbar=FALSE;
		format="";
	}
	p++;

	while (*p)
	{
		if (!p[1])
		{
			ta_do_log_error ("unvollstndiges Kommando");
			return;
		}
		switch(*p)
		{
		case '$':
			alle=FALSE;
			if (p[1]=='+')
				nur_zahler=TRUE;
			else if (p[1]=='-')
				nicht_zahler=TRUE;
			else
				ta_do_log_error ("unbekannter Flagwert");
			p+=2;
			break;
		case '>':
		case '<':
			{
				char *q=p+1;
				char c;
				while (isdigit(*q))
					q++;
				c=*q;
				*q=0;
				if (!mtzeit_to_time_t(p+1,&zeit))
				{
					ta_do_log_error ("unparsbares Datum");
					return;
				}
				*q=c;
				if (*p=='<')
					zeit_groesser=FALSE;
				else
					zeit_groesser=TRUE;
				p=q;
			}
			break;
		case '=':
			format=p+1;
			p+=strlen(p);
			break;
		default:
			ta_do_log_error ("unbekanntes Flag");
			return;
		}
	}

	if (maschinenlesbar)
	{
		sprintf (fname, "%s" KOMMANDO_OUT_F, tom_tmp_dir);
		f = xfopen (fname, "a");
		fprintf (f, "#UQUM\r\n");
		fprintf (f, "WBenutzerliste %s\r\n", cmd);
	}
	else
	{
		f=ta_open_out_block(cmd);
	}
	if (zeit!=0)
	{
		char buf[50];
		time_t_to_mtzeit(&zeit,buf);
		fprintf (f, ":!%s %s eingetragene Benutzer\r\n",
				 zeit_groesser? "Nach" : "Vor",
				 buf);
	}
	if (nur_zahler || nicht_zahler)
		fprintf (f, ":!%s Zahler\r\n", nur_zahler? "Nur" : "Keine");

	u.nummer = 0;
	while (ub_walk_user (&u))
	{
		if (u.geloescht || !u.name || !u.name[0])
			continue;

		/* Einschrnkungen */
		if ((nur_zahler && !u.bezahlt) || (nicht_zahler && u.bezahlt))
			continue;
		if (zeit_groesser && (u.erster_login < zeit))
			continue;
		else if (!zeit_groesser && (u.erster_login > zeit))
			continue;

		/* Ausgabe */
		if (maschinenlesbar)
			fprintf (f, ":U%s\r\n", u.name);
		else
			fprintf (f, ":%s\r\n", u.name);
		/* Zahlerstatus */
		if (strchr(format,'$'))
		{
			if (!u.bezahlt)
			{
				if (!maschinenlesbar)
					fprintf (f, ":  Bezahlt: Nein\r\n");
			}
			else
			{
				char buf[49];
				if (maschinenlesbar)
				{
					time_t_to_mtzeit(&u.bezahlt_bis,buf);
					fprintf(f,":$$%s\r\n",buf);
				}
				else
				{
					fast_strftime (buf, sizeof (buf) - 1, 
								   "%d.%m.%y, %H:%M:%S", 
								   localtime (&u.bezahlt_bis));
					fprintf(f,":  Bezahlt: bis %s\r\n",buf);
				}
			}
		}
		/* l == Level */
		if (strchr(format,'l'))
		{
			if (maschinenlesbar)
				fprintf (f, ":l%d\r\n",u.level);
			else
				fprintf(f, ":  Level: %d\r\n",u.level);
		}
		/* n == nummer */
		if (strchr(format,'n'))
		{
			if (maschinenlesbar)
				fprintf (f, ":n%ld\r\n", (long) u.nummer);
			else
				fprintf(f, ":  Nummer: %ld\r\n", (long) u.nummer);
		}
		/* e == erster Login */
		if (strchr(format,'e'))
		{
			char buf[49];
			if (maschinenlesbar)
			{
				time_t_to_mtzeit(&u.erster_login,buf);
				fprintf(f,":e%s\r\n",buf);
			}
			else
			{
				fast_strftime (buf, sizeof (buf) - 1, 
							   "%d.%m.%y, %H:%M:%S", 
							   localtime (&u.erster_login));
				fprintf(f,":  Erster Login: %s\r\n",buf);
			}
		}

		/* L == letzter Login */
		if (strchr(format,'L'))
		{
			char buf[49];
			if (maschinenlesbar)
			{
				time_t_to_mtzeit(&u.letzter_login,buf);
				fprintf(f,":L%s\r\n",buf);
			}
			else
			{
				fast_strftime (buf, sizeof (buf) - 1, 
							   "%d.%m.%y, %H:%M:%S", 
							   localtime (&u.letzter_login));
				fprintf(f,":  Letzter Login: %s\r\n",buf);
			}
		}
		/* A == Anrufzahl */
		if (strchr(format,'A'))
		{
			if (maschinenlesbar)
				fprintf (f, ":A%ld\r\n",(long) u.anrufe);
			else
				fprintf(f, ":  Anrufe: %ld\r\n", (long) u.anrufe);
		}
		if (!maschinenlesbar && *format)
			fputs(":\r\n",f);
	} /* Schleife */
	fclose (f);
}



/* 
 * Stringdaten (Adressdaten) ndern
 * "UXSxname=value"
 */
#line 1498

#line 1498
ta_command_t ta_ucmd_desc_telefon = {
#line 1498
	/* Magic 1       */ "UXST",
#line 1498
	/* Magic 2       */     "",
#line 1498
	/* Funktionsname */     ta_ucmd_string,
#line 1498
	/* Min. Level    */     0,
#line 1498
	/* Textpara      */     NULL,
#line 1498
	/* Num. Parameter*/     0,
#line 1498

#line 1498
	/* ITK-ID-Nummer */     1103,
#line 1498
	/* Gruppierung   */ 	"U",
#line 1498
	/* ITK-Version   */     0,
#line 1498
	/* ITK-Typ       */     "B", 
#line 1498
	/* ITK-Name      */     "Telefonnummer", 
#line 1498
	/* ITK-Beschrei. */ 
#line 1498
	    
#line 1498
    "Mit dieser Funktion knnen Sie die Telefonnummer eines Benutzers" 
#line 1498
    "ndern."     
#line 1498
	, 
#line 1498

#line 1498
	/* ITK-Syntaxdefinition*/
#line 1498
	    
#line 1498
    ":CUXST\r\n"
#line 1498
    ":FUo\r\n"
#line 1498
	":KBenutzername\r\n"
#line 1498
    ":LName der Benutzers (leer: Sie)\r\n"
#line 1498
    ":D%uN\r\n"
#line 1498
    ":C=\r\n"
#line 1498
	":FS" STRING(UDAT_TEL_LEN) "\r\n"
#line 1498
	":KTelefonnummer.\r\n"
#line 1498
	":LGeben Sie hier die neue Telefonnummer an.\r\n" 
#line 1498

#line 1498
	,
#line 1498

#line 1498
	/* Verkettungsptr*/ NULL
#line 1498
};
#line 1498

#line 1528

#line 1528
ta_command_t ta_ucmd_desc_plz = {
#line 1528
	/* Magic 1       */ "UXSP",
#line 1528
	/* Magic 2       */     "",
#line 1528
	/* Funktionsname */     ta_ucmd_string,
#line 1528
	/* Min. Level    */     0,
#line 1528
	/* Textpara      */     NULL,
#line 1528
	/* Num. Parameter*/     0,
#line 1528

#line 1528
	/* ITK-ID-Nummer */     1102,
#line 1528
	/* Gruppierung   */ 	"U",
#line 1528
	/* ITK-Version   */     0,
#line 1528
	/* ITK-Typ       */     "B", 
#line 1528
	/* ITK-Name      */     "Postleitzahl", 
#line 1528
	/* ITK-Beschrei. */ 
#line 1528
	    
#line 1528
    "Mit dieser Funktion knnen Sie die Postleitzahl eines Benutzers"
#line 1528
    "ndern"     
#line 1528
	, 
#line 1528

#line 1528
	/* ITK-Syntaxdefinition*/
#line 1528
	    
#line 1528
    ":CUXSP\r\n"
#line 1528
    ":FUo\r\n"
#line 1528
	":KBenutzername\r\n"
#line 1528
    ":LName der Benutzers (leer: Sie)\r\n"
#line 1528
    ":D%uN\r\n"
#line 1528
    ":C=\r\n"
#line 1528
	":FS" STRING(UDAT_PLZ_LEN) "o\r\n"
#line 1528
	":KNeue Postleitzahl.\r\n"
#line 1528
	":LGeben Sie hier die neue Postleitzahl an.\r\n" 
#line 1528

#line 1528
	,
#line 1528

#line 1528
	/* Verkettungsptr*/ NULL
#line 1528
};
#line 1528

#line 1557

#line 1557
ta_command_t ta_ucmd_desc_ort = {
#line 1557
	/* Magic 1       */ "UXSO",
#line 1557
	/* Magic 2       */     "",
#line 1557
	/* Funktionsname */     ta_ucmd_string,
#line 1557
	/* Min. Level    */     0,
#line 1557
	/* Textpara      */     NULL,
#line 1557
	/* Num. Parameter*/     0,
#line 1557

#line 1557
	/* ITK-ID-Nummer */     1101,
#line 1557
	/* Gruppierung   */ 	"U",
#line 1557
	/* ITK-Version   */     0,
#line 1557
	/* ITK-Typ       */     "B", 
#line 1557
	/* ITK-Name      */     "Wohnort", 
#line 1557
	/* ITK-Beschrei. */ 
#line 1557
	    
#line 1557
    "Mit dieser Funktion knnen Sie den Wohnort eines Benutzers ndern"     
#line 1557
	, 
#line 1557

#line 1557
	/* ITK-Syntaxdefinition*/
#line 1557
	    
#line 1557
    ":CUXSO\r\n"
#line 1557
    ":FUo\r\n"
#line 1557
	":KBenutzername\r\n"
#line 1557
    ":LName der Benutzers (leer: Sie)\r\n"
#line 1557
    ":D%uN\r\n"
#line 1557
    ":C=\r\n"
#line 1557
	":FS" STRING(UDAT_ORT_LEN) "o\r\n"
#line 1557
	":KNeuer Wohnort.\r\n"
#line 1557
	":LGeben Sie hier den neuen Wohnort an.\r\n" 
#line 1557

#line 1557
	,
#line 1557

#line 1557
	/* Verkettungsptr*/ NULL
#line 1557
};
#line 1557

#line 1586

#line 1586
ta_command_t ta_ucmd_desc_strasse = {
#line 1586
	/* Magic 1       */ "UXSS",
#line 1586
	/* Magic 2       */     "",
#line 1586
	/* Funktionsname */     ta_ucmd_string,
#line 1586
	/* Min. Level    */     0,
#line 1586
	/* Textpara      */     NULL,
#line 1586
	/* Num. Parameter*/     0,
#line 1586

#line 1586
	/* ITK-ID-Nummer */     1100,
#line 1586
	/* Gruppierung   */ 	"U",
#line 1586
	/* ITK-Version   */     0,
#line 1586
	/* ITK-Typ       */     "B", 
#line 1586
	/* ITK-Name      */     "Strae", 
#line 1586
	/* ITK-Beschrei. */ 
#line 1586
	    
#line 1586
    "Mit dieser Funktion knnen Sie die (Wohn-)Strasse eines Benutzers ndern"
#line 1586
    
#line 1586
	, 
#line 1586

#line 1586
	/* ITK-Syntaxdefinition*/
#line 1586
	    
#line 1586
    ":CUXSS\r\n"
#line 1586
    ":FUo\r\n"
#line 1586
	":KBenutzername\r\n"
#line 1586
    ":LName der Benutzers (leer: Sie)\r\n"
#line 1586
    ":D%uN\r\n"
#line 1586
    ":C=\r\n"
#line 1586
	":FS" STRING(UDAT_STRA_LEN) "o\r\n"
#line 1586
	":KNeue Strasse.\r\n"
#line 1586
	":LGeben Sie hier die neue Strasse an.\r\n" 
#line 1586

#line 1586
	,
#line 1586

#line 1586
	/* Verkettungsptr*/ NULL
#line 1586
};
#line 1586

#line 1617

#line 1617
ta_command_t ta_ucmd_desc_ansage = {
#line 1617
	/* Magic 1       */ "UT",
#line 1617
	/* Magic 2       */     "",
#line 1617
	/* Funktionsname */     ta_ucmd_string,
#line 1617
	/* Min. Level    */     0,
#line 1617
	/* Textpara      */     NULL,
#line 1617
	/* Num. Parameter*/     0,
#line 1617

#line 1617
	/* ITK-ID-Nummer */     12,
#line 1617
	/* Gruppierung   */ 	"U",
#line 1617
	/* ITK-Version   */     0,
#line 1617
	/* ITK-Typ       */     "B", 
#line 1617
	/* ITK-Name      */     "Ansagetext", 
#line 1617
	/* ITK-Beschrei. */ 
#line 1617
	    
#line 1617
    "Mit dieser Funktion knnen Sie den Ansagetext eines Benutzers ndern."     
#line 1617
	, 
#line 1617

#line 1617
	/* ITK-Syntaxdefinition*/
#line 1617
	    
#line 1617
    ":CUT\r\n"
#line 1617
    ":FU\r\n"
#line 1617
    ":D%uN\r\n"
#line 1617
    ":KBenutzer\r\n"
#line 1617
    ":LGeben Sie hier den Namen des Benutzers ein.\r\n"
#line 1617
    ":C=\r\n"
#line 1617
    ":FS" STRING(UDAT_ANS_LEN) "o\r\n"
#line 1617
    ":KAnsagetext\r\n"
#line 1617
    ":LGeben Sie hier den neuen Ansagetext ein. Mit '?' knnen Sie den "
#line 1617
    	"eingestellten Ansagetext abfragen.\r\n"
#line 1617
    
#line 1617

#line 1617
	,
#line 1617

#line 1617
	/* Verkettungsptr*/ NULL
#line 1617
};
#line 1617

static void
ta_ucmd_string (char *cmd, const char *dummy TOM_ATTRIB_UNUSED, 
				LONG dummy2 TOM_ATTRIB_UNUSED)
{
	char *para;
	char *uname=cmd+4;
	char item;
	size_t len;
	char *mod=NULL;
	BOOLEAN self=FALSE;
	USERNR unr;
	USER u;
	BOOLEAN abfrage;

#define ANSAGE_MAGIC 0x01
	if (cmd[1]=='T') /* UT -> Ansagetext */
		item=ANSAGE_MAGIC;
	else
		item=cmd[3];

	para=strchr(uname,'=');
	if (!para)
	{
		ta_do_log_error ("ungltiges Kommando!");
		return;
	}
	*para++=0;
	strtrim(para);
	strtrim(uname);
	if (!*uname)
		self=TRUE;
	else if (!ub_find_username(&unr,uname))
	{
		ta_do_log_error ("ungltiger Benutzer");
		return;
	}
	else if (unr==user.nummer)
		self=TRUE;
	else 
	{
		if (level()<8)
		{
			ta_do_log_error ("nicht erlaubt");
			return;
		}	
	}

	abfrage=(0==strcmp(para,"?"));

	switch(item)
	{
	case ANSAGE_MAGIC: mod=u.ansage; len=sizeof(u.ansage); break;
	case 'T': mod=u.telefon; len=sizeof(u.telefon); break;
	case 'P': mod=u.plz; len=sizeof(u.plz); break;
	case 'O': mod=u.ort; len=sizeof(u.ort); break;
	case 'S': mod=u.strasse; len=sizeof(u.strasse); break;
	default:
		ta_do_log_error ("unbekanntes Kommando");
		return;
	}
	
	if (self)
		u=user;
	else
	{
		if (!ta_cmd_get_user (uname, &unr, &u, !abfrage))
			return;                 /* log done */
		if (u.level>level())
		{
			if (!abfrage)
				ub_write_user (&u, TRUE);
			ta_do_log_error ("nicht erlaubt");
			return;
		}
	}

	if (abfrage)
	{
		ta_do_log(":!ist: %s\r\n", mod);
		return;
	}

	if (strlen(para)>=len)
	{
		ta_do_log_error ("Parameter zu lang");
	}
	else
	{
		ta_do_log(":!war %s\r\n", mod);
		strcpy(mod,para);
	}	

	if (self)
		user=u;
	else 
		ub_write_user (&u, TRUE);

}

