/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
       Snail Mail (don't expect me to answer):
             Uwe Ohse
             Drosselstrae 2
             47055 Duisburg
             Germany
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
       (might be the wrong person except for offline)

    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <portab.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>

#include "prototyp.h"
#include "user.h"
#include "modem.h"
#include "md5file.h"
#include "box_conf.h"
#include "tompaths.h"

extern USER user;

#if MD5FILE_HASHLEN >= UDAT_PW_LEN
#error MD5FILE_HASHLEN zu gross!
#endif

/* 
 * Vorsicht bei der Usernummer - die ist beim Userantrag 0!
 */
void
passwort_crypt(char *crypted, const char *uncrypted, 
	USERNR unr, PW_ENCODING pw_encoding)
{
	md5file md5;

	if (pw_encoding==PW_MD5)
	{
		unsigned char digest[16];
		size_t size;
		char *buf;
		size=strlen(uncrypted)+40;
		buf=XMALLOC(size);
		sprintf(buf,"%lu%s%ld",(ULONG) unr, uncrypted, (long) -unr);
		strlwr(buf);
		md5file_clear(&md5);
		md5file_addn(&md5,(unsigned char *)buf,strlen(buf));
		md5file_hash(&md5,digest);
		memcpy(crypted,digest,16);
		crypted[16]=0;
		memset(buf,0,size);
		free(buf);
	}
	else
	{
		sprintf(crypted,"%s",uncrypted);
		strlwr(crypted);
	}
}

BOOLEAN 
passwort_vergleich(USER *work, const char *eingabe)
{
	BOOLEAN ret;
	char vergleich[UDAT_PW_LEN];
	switch(work->pw_encoding)
	{
	case PW_MD5: /* MD5 */
		passwort_crypt(vergleich,eingabe,work->nummer,PW_MD5);
		if (!memcmp(vergleich,work->passwort,MD5FILE_HASHLEN))
			return TRUE;
		/* Aufstand weil die Usernummer whrend des Userantrags und der
		 * Erstvergabe des Passworts noch 0 ist!
		 */
		passwort_crypt(vergleich,eingabe,0,PW_MD5);
		ret=!memcmp(vergleich,work->passwort,MD5FILE_HASHLEN);
		memset(vergleich,0,sizeof(vergleich));
		return ret;
	default:
		ret=!stricmp(work->passwort,eingabe);
		return ret;
		break;
	}
}

