/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <portab.h>
#include <errno.h>
#include <ctype.h>
#include <unistd.h>
#include <syslog.h>
#include <sys/types.h> /* off_t */

#include "prototyp.h"
#include "userbase.h"
#include "ub_int.h"


BOOLEAN 
ub_unlock_user(USERNR nr)
{

	ub_fd_control_t *li = NULL;
	ub_fd_control_t *last;

	for (last = NULL,li = ub_fd_anker; li && li->unr != nr; last=li,li=li->next)
		/* nothing */ ;
	if (!li) {
		fprintf (stderr, "ub_unlock_user: user # %lu not locked\n", nr);
		syslog (LOG_ERR, "ub_unlock_user: user # %lu not locked", nr);
		return FALSE;
	}
	if (last)
		last->next = li->next;
	else
		ub_fd_anker = li->next;
	close (li->fd);
	free (li);
	return TRUE;
} /* ub_unlock_user */

