/*
    Copyright (C) 1994 1995 1996 Frank Baumgart, Uwe Ohse

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact: uwe@tirka.gun.de, Uwe Ohse @ DU3 (mausnet)
    Contact2: godot@uni-paderborn.de, Frank Baumgart @ PB (mausnet)
    Contact3: MausNet Newsgroups Quark & Q-Sysops.
*/
#include "tomsysdep.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <portab.h>
#include <errno.h>
#include <unistd.h>
#include <ctype.h>

#include "box_conf.h"
#include "prototyp.h" /* entumlauten */
#include "userbase.h"
#include "ub_int.h"

/*
	Userliste Client/Server-tauglich durchlaufen
	07.10.93 Frank

	->		<-	next	:	Puffer fr Userstruktur

	<-			TRUE	:	weiterer User in <next>
				FALSE	:	Ende der Userliste erreicht

	Der Aufrufer initialisiert nur die Usernummer der Struktur und bekommt 
	dann die Userstruktur der nchsthheren Usernummer zurck.
	Durch die bertragung der gesamten Struktur anstelle der Nummern kann 
	ein nachfolgendes ub_read_user vom Anforderer aus eingespart werden.
*/
BOOLEAN ub_walk_user(USER *next)
{
	/* zum schnelleren Auffinden des nchsten Users */
	static USERNR letzte_nr = 0;
	static LISTUSER *letzte_pos = 0;

	retry:
	/*
		Optimierung: nur bei nicht aufeinanderfolgenden Durchlufen wird
		eine neue Adresse vom Anfang der Liste an gesucht
	*/
	if (next->nummer != letzte_nr)
	{
		letzte_nr = 0;
		letzte_pos = ub_anker;
		while (letzte_pos)
		{
			if (letzte_pos->nummer > next->nummer)
			{
				letzte_nr = letzte_pos->nummer;
				break;
			}
			letzte_pos = letzte_pos->next;
		}
	}
	else
	{
		if (!next->nummer && !letzte_pos)
			letzte_pos = ub_anker;
		else
			letzte_pos = letzte_pos->next;
		if (!letzte_pos)
			return FALSE;
		letzte_nr = letzte_pos->nummer;
	}

	if (letzte_pos)
	{
		/* to skip users which have been deleted in between */
		if (!ub_read_user(letzte_nr,next,FALSE))
			goto retry;
		return TRUE;
	}
	else
		return FALSE;

} /* ub_walk_user */


