#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <limits.h>
#include <time.h>
#include <sys/stat.h> /* mkdir */

#include "tomsysdep.h"
#include "user.h"
#include "ub_int.h"

int 
main(void)
{
	char buf[UB_USERBLOCK];
	FILE *in,*out,*list;
	in=fopen("user.dat","r");
	if (!in) {
		perror("user.dat: fopen");
		exit(1);
	}
	list=fopen("user_2.dat","w");
	if (!list) {
		perror("user_2.dat: fopen");
		exit(1);
	}
	mkdir("users",0700);
	/* skip header */
	if (1!=fread(buf,UB_USERBLOCK,1,in)) {
		perror("user.dat: read");
		exit(1);
	}
	while (1==fread(buf,UB_USERBLOCK,1,in)) {
		USER u;
		char fname[PATH_MAX];
		memcpy(&u,buf,sizeof(u));
		if (u.geloescht || u.nummer==0)
			continue;
		sprintf(fname,"users/%lu",u.nummer);
		out=fopen(fname,"w");
		if (!out) {
			fprintf(stderr,"%s: fopen: %s\n",fname,strerror(errno));
			exit(1);
		}
		if (1!=fwrite(buf,sizeof(USER),1,out)) {
			fprintf(stderr,"%s: fwrite: %s\n",fname,strerror(errno));
			exit(1);
		}
		if (0!=fclose(out)) {
			fprintf(stderr,"%s: fclose: %s\n",fname,strerror(errno));
			exit(1);
		}
		fprintf(list,"%lu:%s\n",u.nummer,u.name);
	}
	if (ferror(in)) {
		fprintf(stderr,"user.dat: fread: %s\n",strerror(errno));
		exit(1);
	}
	fclose(in);
	if (0!=fclose(list)) {
		fprintf(stderr,"user_2.dat: fclose: %s\n",strerror(errno));
		exit(1);
	}
	fprintf(stderr,"conversion ok\n");
	exit(0);
}
