#include "tomsysdep.h"
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <syslog.h>
#include <string.h>
#include "box_conf.h"
#include "user.h"
#include "uostr.h"

USER user;
char *program_name;

int
main (int argc, char **argv)
{
	LISTUSER *lu;
	gid_t gid;
	uid_t uid;
	const char *prefix;
	uostr_t dirname;dirname.data=0;

	program_name = argv[0];

	if (argc<5) {
		syslog (LOG_ERR, "incorrect number of arguments");
		_exit (2);
	}
	gid=strtol(argv[3],0,10);
	uid=strtol(argv[2],0,10);
	prefix=argv[4];
	if (!read_quark_configuration (argv[1])) {
		syslog (LOG_ERR, "can't read configuration file %s", argv[1]);
		_exit (3);
	}
	if (!ub_init (box_conf.var_dir)) {
		syslog (LOG_ERR, "can't open user database in %s", box_conf.var_dir);
		_exit (5);
	}
	lu = ub_get_first ();
	if (!lu) {
		syslog (LOG_ERR, "cannot read user database");
		_exit (6);
	}
	while (lu) {
		char x[UDAT_NAME_LEN * 2 + 1];
		char y[UDAT_NAME_LEN * 2 + 1];
		if (!ub_read_user (lu->nummer, &user, 0)) {
			syslog (LOG_ERR, "usernummer %d not found", lu->nummer);
			_exit (1);
		}
		ub_canonical_underscore (user.name, x);
		ub_canonical (user.name, y);
		uostr_xdup_cstrmulti (&dirname, box_conf.user_dir, x, NULL);
		uostr_x0 (&dirname);

		if (user.level > 0)
			printf ("%s%s%s:x:%d:%d:%s:%s:/dev/null\n", 
				prefix ? prefix : "", prefix ? "-" : "",
				x, uid,gid, y, dirname.data);
		lu = lu->next;
	}
	argc++;						/* get rid of warning */
	exit (0);

}
